/* Dimensions.c generated by valac 0.12.1, the Vala compiler
 * generated from Dimensions.vala, do not modify */

/* Copyright 2009-2011 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>


#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())
typedef struct _Scaling Scaling;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_ZOOM_STATE (zoom_state_get_type ())
typedef struct _ZoomState ZoomState;

typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

struct _Dimensions {
	gint width;
	gint height;
};

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _ZoomState {
	Dimensions content_dimensions;
	Dimensions viewport_dimensions;
	gdouble zoom_factor;
	gdouble interpolation_factor;
	gdouble min_factor;
	gdouble max_factor;
	GdkPoint viewport_center;
};



GType scale_constraint_get_type (void) G_GNUC_CONST;
gchar* scale_constraint_to_string (ScaleConstraint self);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void dimensions_init (Dimensions *self, gint width, gint height);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf, Dimensions* result);
void dimensions_for_allocation (GtkAllocation* allocation, Dimensions* result);
void dimensions_for_rectangle (GdkRectangle* rect, Dimensions* result);
gboolean dimensions_has_area (Dimensions *self);
void dimensions_floor (Dimensions *self, Dimensions* min, Dimensions* result);
gchar* dimensions_to_string (Dimensions *self);
gboolean dimensions_equals (Dimensions *self, Dimensions* dim);
gboolean dimensions_approx_equals (Dimensions *self, Dimensions* dim, gint fudge);
gboolean dimensions_approx_scaled (Dimensions *self, gint scale, gint fudge);
gint dimensions_major_axis (Dimensions *self);
gint dimensions_minor_axis (Dimensions *self);
void dimensions_with_min (Dimensions *self, gint min_width, gint min_height, Dimensions* result);
void dimensions_get_scaled (Dimensions *self, gint scale, gboolean scale_up, Dimensions* result);
void dimensions_get_scaled_by_width (Dimensions *self, gint scale, Dimensions* result);
void dimensions_get_scaled_by_height (Dimensions *self, gint scale, Dimensions* result);
void dimensions_get_scale_ratios (Dimensions *self, Dimensions* scaled, gdouble* width_ratio, gdouble* height_ratio);
gdouble dimensions_get_aspect_ratio (Dimensions *self);
void dimensions_get_scaled_proportional (Dimensions *self, Dimensions* viewport, Dimensions* result);
void dimensions_get_scaled_to_fill_viewport (Dimensions *self, Dimensions* viewport, Dimensions* result);
void dimensions_get_scaled_rectangle (Dimensions *self, Dimensions* scaled, GdkRectangle* rect, GdkRectangle* result);
void dimensions_get_scaled_similar (Dimensions *self, Dimensions* original, Dimensions* scaled, Dimensions* result);
void dimensions_get_scaled_by_constraint (Dimensions *self, gint scale, ScaleConstraint constraint, Dimensions* result);
GType scaling_get_type (void) G_GNUC_CONST;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
#define SCALING_NO_SCALE 0
static void scaling_init (Scaling *self, ScaleConstraint constraint, gint scale, Dimensions* viewport, gboolean scale_up);
void scaling_for_original (Scaling* result);
void scaling_for_screen (GtkWindow* window, gboolean scale_up, Scaling* result);
void scaling_for_viewport (Dimensions* viewport, gboolean scale_up, Scaling* result);
static void scaling_get_screen_dimensions (GtkWindow* window, Dimensions* result);
void scaling_for_best_fit (gint pixels, gboolean scale_up, Scaling* result);
void scaling_for_widget (GtkWidget* widget, gboolean scale_up, Scaling* result);
void scaling_to_fill_viewport (Dimensions* viewport, Scaling* result);
void scaling_to_fill_screen (GtkWindow* window, Scaling* result);
void scaling_for_constraint (ScaleConstraint constraint, gint scale, gboolean scale_up, Scaling* result);
static gint scaling_scale_to_pixels (Scaling *self);
gboolean scaling_is_unscaled (Scaling *self);
gboolean scaling_is_best_fit (Scaling *self, Dimensions* original, gint* pixels);
gboolean scaling_is_best_fit_dimensions (Scaling *self, Dimensions* original, Dimensions* scaled);
gboolean scaling_is_for_viewport (Scaling *self, Dimensions* original, Dimensions* scaled);
gboolean scaling_is_fill_viewport (Scaling *self, Dimensions* original, Dimensions* scaled);
void scaling_get_scaled_dimensions (Scaling *self, Dimensions* original, Dimensions* result);
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self, GdkPixbuf* pixbuf, GdkInterpType interp, gboolean scale_up);
GdkPixbuf* scale_pixbuf (GdkPixbuf* pixbuf, gint scale, GdkInterpType interp, gboolean scale_up);
GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf, Dimensions* resized, GdkInterpType interp);
gchar* scaling_to_string (Scaling *self);
gboolean scaling_equals (Scaling *self, Scaling* scaling);
GType zoom_state_get_type (void) G_GNUC_CONST;
ZoomState* zoom_state_dup (const ZoomState* self);
void zoom_state_free (ZoomState* self);
void zoom_state_init (ZoomState *self, Dimensions* content_dimensions, Dimensions* viewport_dimensions, gdouble slider_val, GdkPoint* viewport_center);
static void zoom_state_compute_zoom_factors (ZoomState *self);
static void zoom_state_center_viewport (ZoomState *self);
static void zoom_state_clamp_viewport_center (ZoomState *self);
void zoom_state_init_rescale (ZoomState *self, ZoomState* existing, gdouble new_slider_val);
void zoom_state_init_rescale_to_isomorphic (ZoomState *self, ZoomState* existing);
void zoom_state_init_pan (ZoomState *self, ZoomState* existing, GdkPoint* new_viewport_center);
gint zoom_state_get_zoomed_width (ZoomState *self);
gint zoom_state_get_zoomed_height (ZoomState *self);
gdouble zoom_state_get_interpolation_factor (ZoomState *self);
void zoom_state_get_viewing_rectangle_wrt_content (ZoomState *self, GdkRectangle* result);
void zoom_state_get_viewing_rectangle_wrt_screen (ZoomState *self, GdkRectangle* result);
void zoom_state_get_viewing_rectangle_projection (ZoomState *self, GdkPixbuf* for_pixbuf, GdkRectangle* result);
gdouble zoom_state_get_zoom_factor (ZoomState *self);
void zoom_state_get_viewport_center (ZoomState *self, GdkPoint* result);
gchar* zoom_state_to_string (ZoomState *self);
gboolean zoom_state_is_min (ZoomState *self);
gboolean zoom_state_is_default (ZoomState *self);
gboolean zoom_state_is_isomorphic (ZoomState *self);
gboolean zoom_state_is_max (ZoomState *self);
gboolean zoom_state_equals (ZoomState *self, ZoomState* other);


gchar* scale_constraint_to_string (ScaleConstraint self) {
	gchar* result = NULL;
	switch (self) {
		case SCALE_CONSTRAINT_ORIGINAL:
		{
			const gchar* _tmp0_ = NULL;
			gchar* _tmp1_;
			_tmp0_ = _ ("Original size");
			_tmp1_ = g_strdup (_tmp0_);
			result = _tmp1_;
			return result;
		}
		case SCALE_CONSTRAINT_DIMENSIONS:
		{
			const gchar* _tmp2_ = NULL;
			gchar* _tmp3_;
			_tmp2_ = _ ("Width or height");
			_tmp3_ = g_strdup (_tmp2_);
			result = _tmp3_;
			return result;
		}
		case SCALE_CONSTRAINT_WIDTH:
		{
			const gchar* _tmp4_ = NULL;
			gchar* _tmp5_;
			_tmp4_ = _ ("Width");
			_tmp5_ = g_strdup (_tmp4_);
			result = _tmp5_;
			return result;
		}
		case SCALE_CONSTRAINT_HEIGHT:
		{
			const gchar* _tmp6_ = NULL;
			gchar* _tmp7_;
			_tmp6_ = _ ("Height");
			_tmp7_ = g_strdup (_tmp6_);
			result = _tmp7_;
			return result;
		}
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
		{
			gchar* _tmp8_;
			_tmp8_ = g_strdup ("Fill Viewport");
			result = _tmp8_;
			return result;
		}
		default:
		break;
	}
	g_warn_if_reached ();
	result = NULL;
	return result;
}


GType scale_constraint_get_type (void) {
	static volatile gsize scale_constraint_type_id__volatile = 0;
	if (g_once_init_enter (&scale_constraint_type_id__volatile)) {
		static const GEnumValue values[] = {{SCALE_CONSTRAINT_ORIGINAL, "SCALE_CONSTRAINT_ORIGINAL", "original"}, {SCALE_CONSTRAINT_DIMENSIONS, "SCALE_CONSTRAINT_DIMENSIONS", "dimensions"}, {SCALE_CONSTRAINT_WIDTH, "SCALE_CONSTRAINT_WIDTH", "width"}, {SCALE_CONSTRAINT_HEIGHT, "SCALE_CONSTRAINT_HEIGHT", "height"}, {SCALE_CONSTRAINT_FILL_VIEWPORT, "SCALE_CONSTRAINT_FILL_VIEWPORT", "fill-viewport"}, {0, NULL, NULL}};
		GType scale_constraint_type_id;
		scale_constraint_type_id = g_enum_register_static ("ScaleConstraint", values);
		g_once_init_leave (&scale_constraint_type_id__volatile, scale_constraint_type_id);
	}
	return scale_constraint_type_id__volatile;
}


void dimensions_init (Dimensions *self, gint width, gint height) {
	gboolean _tmp0_ = FALSE;
	memset (self, 0, sizeof (Dimensions));
	if (width >= 0) {
		_tmp0_ = height >= 0;
	} else {
		_tmp0_ = FALSE;
	}
	g_assert (_tmp0_);
	(*self).width = width;
	(*self).height = height;
}


void dimensions_for_pixbuf (GdkPixbuf* pixbuf, Dimensions* result) {
	gint _tmp0_;
	gint _tmp1_;
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	g_return_if_fail (GDK_IS_PIXBUF (pixbuf));
	_tmp0_ = gdk_pixbuf_get_width (pixbuf);
	_tmp1_ = gdk_pixbuf_get_height (pixbuf);
	dimensions_init (&_tmp2_, _tmp0_, _tmp1_);
	_tmp3_ = _tmp2_;
	*result = _tmp3_;
	return;
}


void dimensions_for_allocation (GtkAllocation* allocation, Dimensions* result) {
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	dimensions_init (&_tmp0_, (*allocation).width, (*allocation).height);
	_tmp1_ = _tmp0_;
	*result = _tmp1_;
	return;
}


void dimensions_for_rectangle (GdkRectangle* rect, Dimensions* result) {
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	dimensions_init (&_tmp0_, (*rect).width, (*rect).height);
	_tmp1_ = _tmp0_;
	*result = _tmp1_;
	return;
}


gboolean dimensions_has_area (Dimensions *self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	if ((*self).width > 0) {
		_tmp0_ = (*self).height > 0;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


void dimensions_floor (Dimensions *self, Dimensions* min, Dimensions* result) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	if ((*self).width > (*min).width) {
		_tmp0_ = (*self).width;
	} else {
		_tmp0_ = (*min).width;
	}
	if ((*self).height > (*min).height) {
		_tmp1_ = (*self).height;
	} else {
		_tmp1_ = (*min).height;
	}
	dimensions_init (&_tmp2_, _tmp0_, _tmp1_);
	_tmp3_ = _tmp2_;
	*result = _tmp3_;
	return;
}


gchar* dimensions_to_string (Dimensions *self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	_tmp0_ = g_strdup_printf ("%dx%d", (*self).width, (*self).height);
	result = _tmp0_;
	return result;
}


gboolean dimensions_equals (Dimensions *self, Dimensions* dim) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	if ((*self).width == (*dim).width) {
		_tmp0_ = (*self).height == (*dim).height;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


gboolean dimensions_approx_equals (Dimensions *self, Dimensions* dim, gint fudge) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	_tmp1_ = abs ((*self).width - (*dim).width);
	if (_tmp1_ <= fudge) {
		gint _tmp2_;
		_tmp2_ = abs ((*self).height - (*dim).height);
		_tmp0_ = _tmp2_ <= fudge;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


gboolean dimensions_approx_scaled (Dimensions *self, gint scale, gint fudge) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	if ((*self).width <= (scale + fudge)) {
		_tmp0_ = (*self).height <= (scale + fudge);
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


gint dimensions_major_axis (Dimensions *self) {
	gint result = 0;
	gint _tmp0_;
	_tmp0_ = MAX ((*self).width, (*self).height);
	result = _tmp0_;
	return result;
}


gint dimensions_minor_axis (Dimensions *self) {
	gint result = 0;
	gint _tmp0_;
	_tmp0_ = MIN ((*self).width, (*self).height);
	result = _tmp0_;
	return result;
}


void dimensions_with_min (Dimensions *self, gint min_width, gint min_height, Dimensions* result) {
	Dimensions min = {0};
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	dimensions_init (&min, 0, 0);
	if ((*self).width > min_width) {
		_tmp0_ = (*self).width;
	} else {
		_tmp0_ = min_width;
	}
	min.width = _tmp0_;
	if ((*self).height > min_height) {
		_tmp1_ = (*self).height;
	} else {
		_tmp1_ = min_height;
	}
	min.height = _tmp1_;
	*result = min;
	return;
}


void dimensions_get_scaled (Dimensions *self, gint scale, gboolean scale_up, Dimensions* result) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp5_ = FALSE;
	g_assert (scale > 0);
	if ((*self).width == scale) {
		_tmp1_ = (*self).height < scale;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_ = FALSE;
		if ((*self).height == scale) {
			_tmp2_ = (*self).width < scale;
		} else {
			_tmp2_ = FALSE;
		}
		_tmp0_ = _tmp2_;
	}
	if (_tmp0_) {
		Dimensions _tmp3_ = {0};
		Dimensions _tmp4_ = {0};
		dimensions_init (&_tmp3_, (*self).width, (*self).height);
		_tmp4_ = _tmp3_;
		*result = _tmp4_;
		return;
	}
	if (!scale_up) {
		gboolean _tmp6_ = FALSE;
		if ((*self).width < scale) {
			_tmp6_ = (*self).height < scale;
		} else {
			_tmp6_ = FALSE;
		}
		_tmp5_ = _tmp6_;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		Dimensions _tmp7_ = {0};
		Dimensions _tmp8_ = {0};
		dimensions_init (&_tmp7_, (*self).width, (*self).height);
		_tmp8_ = _tmp7_;
		*result = _tmp8_;
		return;
	}
	if (((*self).width - scale) > ((*self).height - scale)) {
		Dimensions _tmp9_ = {0};
		Dimensions _tmp10_ = {0};
		dimensions_get_scaled_by_width (&(*self), scale, &_tmp9_);
		_tmp10_ = _tmp9_;
		*result = _tmp10_;
		return;
	} else {
		Dimensions _tmp11_ = {0};
		Dimensions _tmp12_ = {0};
		dimensions_get_scaled_by_height (&(*self), scale, &_tmp11_);
		_tmp12_ = _tmp11_;
		*result = _tmp12_;
		return;
	}
}


void dimensions_get_scale_ratios (Dimensions *self, Dimensions* scaled, gdouble* width_ratio, gdouble* height_ratio) {
	gdouble _width_ratio = 0.0;
	gdouble _height_ratio = 0.0;
	_width_ratio = ((gdouble) (*scaled).width) / ((gdouble) (*self).width);
	_height_ratio = ((gdouble) (*scaled).height) / ((gdouble) (*self).height);
	if (width_ratio) {
		*width_ratio = _width_ratio;
	}
	if (height_ratio) {
		*height_ratio = _height_ratio;
	}
}


gdouble dimensions_get_aspect_ratio (Dimensions *self) {
	gdouble result = 0.0;
	result = ((gdouble) (*self).width) / (*self).height;
	return result;
}


void dimensions_get_scaled_proportional (Dimensions *self, Dimensions* viewport, Dimensions* result) {
	gdouble width_ratio = 0.0;
	gdouble height_ratio = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble scaled_width = 0.0;
	gdouble scaled_height = 0.0;
	gdouble _tmp2_;
	gdouble _tmp3_;
	Dimensions _tmp4_ = {0};
	Dimensions _tmp5_ = {0};
	Dimensions _tmp6_ = {0};
	Dimensions _tmp7_ = {0};
	Dimensions _tmp8_ = {0};
	Dimensions _tmp9_ = {0};
	Dimensions scaled;
	dimensions_get_scale_ratios (&(*self), viewport, &_tmp0_, &_tmp1_);
	width_ratio = _tmp0_;
	height_ratio = _tmp1_;
	if (width_ratio < height_ratio) {
		scaled_width = (gdouble) (*viewport).width;
		scaled_height = ((gdouble) (*self).height) * width_ratio;
	} else {
		scaled_width = ((gdouble) (*self).width) * height_ratio;
		scaled_height = (gdouble) (*viewport).height;
	}
	_tmp2_ = round (scaled_width);
	_tmp3_ = round (scaled_height);
	dimensions_init (&_tmp4_, (gint) _tmp2_, (gint) _tmp3_);
	_tmp5_ = _tmp4_;
	dimensions_init (&_tmp6_, 1, 1);
	_tmp7_ = _tmp6_;
	dimensions_floor (&_tmp5_, &_tmp7_, &_tmp8_);
	_tmp9_ = _tmp8_;
	scaled = _tmp9_;
	g_assert (scaled.height <= (*viewport).height);
	g_assert (scaled.width <= (*viewport).width);
	*result = scaled;
	return;
}


void dimensions_get_scaled_to_fill_viewport (Dimensions *self, Dimensions* viewport, Dimensions* result) {
	gdouble width_ratio = 0.0;
	gdouble height_ratio = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble scaled_width = 0.0;
	gdouble scaled_height = 0.0;
	gboolean _tmp2_ = FALSE;
	gdouble _tmp5_;
	gdouble _tmp6_;
	Dimensions _tmp7_ = {0};
	Dimensions _tmp8_ = {0};
	Dimensions _tmp9_ = {0};
	Dimensions _tmp10_ = {0};
	Dimensions _tmp11_ = {0};
	Dimensions _tmp12_ = {0};
	dimensions_get_scale_ratios (&(*self), viewport, &_tmp0_, &_tmp1_);
	width_ratio = _tmp0_;
	height_ratio = _tmp1_;
	if ((*self).width < (*viewport).width) {
		_tmp2_ = (*self).height >= (*viewport).height;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		scaled_width = (gdouble) (*viewport).width;
		scaled_height = ((gdouble) (*self).height) * width_ratio;
	} else {
		gboolean _tmp3_ = FALSE;
		if ((*self).width >= (*viewport).width) {
			_tmp3_ = (*self).height < (*viewport).height;
		} else {
			_tmp3_ = FALSE;
		}
		if (_tmp3_) {
			scaled_width = ((gdouble) (*self).width) * height_ratio;
			scaled_height = (gdouble) (*viewport).height;
		} else {
			gdouble _tmp4_;
			gdouble ratio;
			_tmp4_ = MAX (width_ratio, height_ratio);
			ratio = _tmp4_;
			scaled_width = ((gdouble) (*self).width) * ratio;
			scaled_height = ((gdouble) (*self).height) * ratio;
		}
	}
	_tmp5_ = round (scaled_width);
	_tmp6_ = round (scaled_height);
	dimensions_init (&_tmp7_, (gint) _tmp5_, (gint) _tmp6_);
	_tmp8_ = _tmp7_;
	dimensions_init (&_tmp9_, 1, 1);
	_tmp10_ = _tmp9_;
	dimensions_floor (&_tmp8_, &_tmp10_, &_tmp11_);
	_tmp12_ = _tmp11_;
	*result = _tmp12_;
	return;
}


void dimensions_get_scaled_rectangle (Dimensions *self, Dimensions* scaled, GdkRectangle* rect, GdkRectangle* result) {
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	GdkRectangle scaled_rect = {0};
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	dimensions_get_scale_ratios (&(*self), scaled, &_tmp0_, &_tmp1_);
	x_scale = _tmp0_;
	y_scale = _tmp1_;
	memset (&scaled_rect, 0, sizeof (GdkRectangle));
	_tmp2_ = round (((gdouble) (*rect).x) * x_scale);
	scaled_rect.x = (gint) _tmp2_;
	_tmp3_ = round (((gdouble) (*rect).y) * y_scale);
	scaled_rect.y = (gint) _tmp3_;
	_tmp4_ = round (((gdouble) (*rect).width) * x_scale);
	scaled_rect.width = (gint) _tmp4_;
	_tmp5_ = round (((gdouble) (*rect).height) * y_scale);
	scaled_rect.height = (gint) _tmp5_;
	if (scaled_rect.width <= 0) {
		scaled_rect.width = 1;
	}
	if (scaled_rect.height <= 0) {
		scaled_rect.height = 1;
	}
	*result = scaled_rect;
	return;
}


void dimensions_get_scaled_similar (Dimensions *self, Dimensions* original, Dimensions* scaled, Dimensions* result) {
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble scale;
	gdouble _tmp3_;
	gdouble _tmp4_;
	Dimensions _tmp5_ = {0};
	Dimensions _tmp6_ = {0};
	Dimensions _tmp7_ = {0};
	Dimensions _tmp8_ = {0};
	Dimensions _tmp9_ = {0};
	Dimensions _tmp10_ = {0};
	dimensions_get_scale_ratios (original, scaled, &_tmp0_, &_tmp1_);
	x_scale = _tmp0_;
	y_scale = _tmp1_;
	_tmp2_ = MIN (x_scale, y_scale);
	scale = _tmp2_;
	_tmp3_ = round (((gdouble) (*self).width) * scale);
	_tmp4_ = round (((gdouble) (*self).height) * scale);
	dimensions_init (&_tmp5_, (gint) _tmp3_, (gint) _tmp4_);
	_tmp6_ = _tmp5_;
	dimensions_init (&_tmp7_, 1, 1);
	_tmp8_ = _tmp7_;
	dimensions_floor (&_tmp6_, &_tmp8_, &_tmp9_);
	_tmp10_ = _tmp9_;
	*result = _tmp10_;
	return;
}


void dimensions_get_scaled_by_width (Dimensions *self, gint scale, Dimensions* result) {
	gdouble ratio;
	gdouble _tmp0_;
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	Dimensions _tmp4_ = {0};
	Dimensions _tmp5_ = {0};
	Dimensions _tmp6_ = {0};
	g_assert (scale > 0);
	ratio = ((gdouble) scale) / ((gdouble) (*self).width);
	_tmp0_ = round (((gdouble) (*self).height) * ratio);
	dimensions_init (&_tmp1_, scale, (gint) _tmp0_);
	_tmp2_ = _tmp1_;
	dimensions_init (&_tmp3_, 1, 1);
	_tmp4_ = _tmp3_;
	dimensions_floor (&_tmp2_, &_tmp4_, &_tmp5_);
	_tmp6_ = _tmp5_;
	*result = _tmp6_;
	return;
}


void dimensions_get_scaled_by_height (Dimensions *self, gint scale, Dimensions* result) {
	gdouble ratio;
	gdouble _tmp0_;
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	Dimensions _tmp4_ = {0};
	Dimensions _tmp5_ = {0};
	Dimensions _tmp6_ = {0};
	g_assert (scale > 0);
	ratio = ((gdouble) scale) / ((gdouble) (*self).height);
	_tmp0_ = round (((gdouble) (*self).width) * ratio);
	dimensions_init (&_tmp1_, (gint) _tmp0_, scale);
	_tmp2_ = _tmp1_;
	dimensions_init (&_tmp3_, 1, 1);
	_tmp4_ = _tmp3_;
	dimensions_floor (&_tmp2_, &_tmp4_, &_tmp5_);
	_tmp6_ = _tmp5_;
	*result = _tmp6_;
	return;
}


void dimensions_get_scaled_by_constraint (Dimensions *self, gint scale, ScaleConstraint constraint, Dimensions* result) {
	switch (constraint) {
		case SCALE_CONSTRAINT_ORIGINAL:
		{
			Dimensions _tmp0_ = {0};
			Dimensions _tmp1_ = {0};
			dimensions_init (&_tmp0_, (*self).width, (*self).height);
			_tmp1_ = _tmp0_;
			*result = _tmp1_;
			return;
		}
		case SCALE_CONSTRAINT_DIMENSIONS:
		{
			Dimensions _tmp2_ = {0};
			if ((*self).width >= (*self).height) {
				Dimensions _tmp3_ = {0};
				Dimensions _tmp4_ = {0};
				dimensions_get_scaled_by_width (&(*self), scale, &_tmp3_);
				_tmp4_ = _tmp3_;
				_tmp2_ = _tmp4_;
			} else {
				Dimensions _tmp5_ = {0};
				Dimensions _tmp6_ = {0};
				dimensions_get_scaled_by_height (&(*self), scale, &_tmp5_);
				_tmp6_ = _tmp5_;
				_tmp2_ = _tmp6_;
			}
			*result = _tmp2_;
			return;
		}
		case SCALE_CONSTRAINT_WIDTH:
		{
			Dimensions _tmp7_ = {0};
			Dimensions _tmp8_ = {0};
			dimensions_get_scaled_by_width (&(*self), scale, &_tmp7_);
			_tmp8_ = _tmp7_;
			*result = _tmp8_;
			return;
		}
		case SCALE_CONSTRAINT_HEIGHT:
		{
			Dimensions _tmp9_ = {0};
			Dimensions _tmp10_ = {0};
			dimensions_get_scaled_by_height (&(*self), scale, &_tmp9_);
			_tmp10_ = _tmp9_;
			*result = _tmp10_;
			return;
		}
		default:
		{
			g_error ("Dimensions.vala:236: Bad constraint: %d", (gint) constraint);
		}
	}
}


Dimensions* dimensions_dup (const Dimensions* self) {
	Dimensions* dup;
	dup = g_new0 (Dimensions, 1);
	memcpy (dup, self, sizeof (Dimensions));
	return dup;
}


void dimensions_free (Dimensions* self) {
	g_free (self);
}


GType dimensions_get_type (void) {
	static volatile gsize dimensions_type_id__volatile = 0;
	if (g_once_init_enter (&dimensions_type_id__volatile)) {
		GType dimensions_type_id;
		dimensions_type_id = g_boxed_type_register_static ("Dimensions", (GBoxedCopyFunc) dimensions_dup, (GBoxedFreeFunc) dimensions_free);
		g_once_init_leave (&dimensions_type_id__volatile, dimensions_type_id);
	}
	return dimensions_type_id__volatile;
}


static void scaling_init (Scaling *self, ScaleConstraint constraint, gint scale, Dimensions* viewport, gboolean scale_up) {
	memset (self, 0, sizeof (Scaling));
	(*self).constraint = constraint;
	(*self).scale = scale;
	(*self).viewport = *viewport;
	(*self).scale_up = scale_up;
}


void scaling_for_original (Scaling* result) {
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	Scaling _tmp2_ = {0};
	Scaling _tmp3_ = {0};
	dimensions_init (&_tmp0_, 0, 0);
	_tmp1_ = _tmp0_;
	scaling_init (&_tmp2_, SCALE_CONSTRAINT_ORIGINAL, SCALING_NO_SCALE, &_tmp1_, FALSE);
	_tmp3_ = _tmp2_;
	*result = _tmp3_;
	return;
}


void scaling_for_screen (GtkWindow* window, gboolean scale_up, Scaling* result) {
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	Scaling _tmp2_ = {0};
	Scaling _tmp3_ = {0};
	g_return_if_fail (GTK_IS_WINDOW (window));
	scaling_get_screen_dimensions (window, &_tmp0_);
	_tmp1_ = _tmp0_;
	scaling_for_viewport (&_tmp1_, scale_up, &_tmp2_);
	_tmp3_ = _tmp2_;
	*result = _tmp3_;
	return;
}


void scaling_for_best_fit (gint pixels, gboolean scale_up, Scaling* result) {
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	Scaling _tmp2_ = {0};
	Scaling _tmp3_ = {0};
	g_assert (pixels > 0);
	dimensions_init (&_tmp0_, 0, 0);
	_tmp1_ = _tmp0_;
	scaling_init (&_tmp2_, SCALE_CONSTRAINT_DIMENSIONS, pixels, &_tmp1_, scale_up);
	_tmp3_ = _tmp2_;
	*result = _tmp3_;
	return;
}


void scaling_for_viewport (Dimensions* viewport, gboolean scale_up, Scaling* result) {
	gboolean _tmp0_;
	Scaling _tmp1_ = {0};
	Scaling _tmp2_ = {0};
	_tmp0_ = dimensions_has_area (viewport);
	g_assert (_tmp0_);
	scaling_init (&_tmp1_, SCALE_CONSTRAINT_DIMENSIONS, SCALING_NO_SCALE, viewport, scale_up);
	_tmp2_ = _tmp1_;
	*result = _tmp2_;
	return;
}


void scaling_for_widget (GtkWidget* widget, gboolean scale_up, Scaling* result) {
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	Dimensions viewport;
	gboolean _tmp2_;
	Scaling _tmp3_ = {0};
	Scaling _tmp4_ = {0};
	g_return_if_fail (GTK_IS_WIDGET (widget));
	dimensions_for_allocation (&widget->allocation, &_tmp0_);
	_tmp1_ = _tmp0_;
	viewport = _tmp1_;
	_tmp2_ = dimensions_has_area (&viewport);
	g_assert (_tmp2_);
	scaling_init (&_tmp3_, SCALE_CONSTRAINT_DIMENSIONS, SCALING_NO_SCALE, &viewport, scale_up);
	_tmp4_ = _tmp3_;
	*result = _tmp4_;
	return;
}


void scaling_to_fill_viewport (Dimensions* viewport, Scaling* result) {
	gboolean _tmp0_;
	Scaling _tmp1_ = {0};
	Scaling _tmp2_ = {0};
	_tmp0_ = dimensions_has_area (viewport);
	g_assert (_tmp0_);
	scaling_init (&_tmp1_, SCALE_CONSTRAINT_FILL_VIEWPORT, SCALING_NO_SCALE, viewport, TRUE);
	_tmp2_ = _tmp1_;
	*result = _tmp2_;
	return;
}


void scaling_to_fill_screen (GtkWindow* window, Scaling* result) {
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	Scaling _tmp2_ = {0};
	Scaling _tmp3_ = {0};
	g_return_if_fail (GTK_IS_WINDOW (window));
	scaling_get_screen_dimensions (window, &_tmp0_);
	_tmp1_ = _tmp0_;
	scaling_to_fill_viewport (&_tmp1_, &_tmp2_);
	_tmp3_ = _tmp2_;
	*result = _tmp3_;
	return;
}


void scaling_for_constraint (ScaleConstraint constraint, gint scale, gboolean scale_up, Scaling* result) {
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	Scaling _tmp2_ = {0};
	Scaling _tmp3_ = {0};
	dimensions_init (&_tmp0_, 0, 0);
	_tmp1_ = _tmp0_;
	scaling_init (&_tmp2_, constraint, scale, &_tmp1_, scale_up);
	_tmp3_ = _tmp2_;
	*result = _tmp3_;
	return;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void scaling_get_screen_dimensions (GtkWindow* window, Dimensions* result) {
	GdkScreen* _tmp0_ = NULL;
	GdkScreen* _tmp1_;
	GdkScreen* screen;
	gint _tmp2_;
	gint _tmp3_;
	Dimensions _tmp4_ = {0};
	Dimensions _tmp5_ = {0};
	g_return_if_fail (GTK_IS_WINDOW (window));
	_tmp0_ = gtk_window_get_screen (window);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	screen = _tmp1_;
	_tmp2_ = gdk_screen_get_width (screen);
	_tmp3_ = gdk_screen_get_height (screen);
	dimensions_init (&_tmp4_, _tmp2_, _tmp3_);
	_tmp5_ = _tmp4_;
	*result = _tmp5_;
	_g_object_unref0 (screen);
	return;
}


static gint scaling_scale_to_pixels (Scaling *self) {
	gint result = 0;
	gint _tmp0_ = 0;
	if ((*self).scale >= 0) {
		_tmp0_ = (*self).scale;
	} else {
		_tmp0_ = 0;
	}
	result = _tmp0_;
	return result;
}


gboolean scaling_is_unscaled (Scaling *self) {
	gboolean result = FALSE;
	result = (*self).constraint == SCALE_CONSTRAINT_ORIGINAL;
	return result;
}


gboolean scaling_is_best_fit (Scaling *self, Dimensions* original, gint* pixels) {
	gint _pixels = 0;
	gboolean result = FALSE;
	if ((*self).scale == SCALING_NO_SCALE) {
		result = FALSE;
		if (pixels) {
			*pixels = _pixels;
		}
		return result;
	}
	switch ((*self).constraint) {
		case SCALE_CONSTRAINT_ORIGINAL:
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
		{
			result = FALSE;
			if (pixels) {
				*pixels = _pixels;
			}
			return result;
		}
		default:
		{
			gint _tmp0_;
			_tmp0_ = scaling_scale_to_pixels (&(*self));
			_pixels = _tmp0_;
			g_assert (_pixels > 0);
			result = TRUE;
			if (pixels) {
				*pixels = _pixels;
			}
			return result;
		}
	}
	if (pixels) {
		*pixels = _pixels;
	}
}


gboolean scaling_is_best_fit_dimensions (Scaling *self, Dimensions* original, Dimensions* scaled) {
	Dimensions _scaled = {0};
	gboolean result = FALSE;
	if ((*self).scale == SCALING_NO_SCALE) {
		result = FALSE;
		if (scaled) {
			*scaled = _scaled;
		}
		return result;
	}
	switch ((*self).constraint) {
		case SCALE_CONSTRAINT_ORIGINAL:
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
		{
			result = FALSE;
			if (scaled) {
				*scaled = _scaled;
			}
			return result;
		}
		default:
		{
			gint _tmp0_;
			gint pixels;
			Dimensions _tmp1_ = {0};
			Dimensions _tmp2_ = {0};
			_tmp0_ = scaling_scale_to_pixels (&(*self));
			pixels = _tmp0_;
			g_assert (pixels > 0);
			dimensions_get_scaled_by_constraint (original, pixels, (*self).constraint, &_tmp1_);
			_tmp2_ = _tmp1_;
			_scaled = _tmp2_;
			result = TRUE;
			if (scaled) {
				*scaled = _scaled;
			}
			return result;
		}
	}
	if (scaled) {
		*scaled = _scaled;
	}
}


gboolean scaling_is_for_viewport (Scaling *self, Dimensions* original, Dimensions* scaled) {
	Dimensions _scaled = {0};
	gboolean result = FALSE;
	if ((*self).scale != SCALING_NO_SCALE) {
		result = FALSE;
		if (scaled) {
			*scaled = _scaled;
		}
		return result;
	}
	switch ((*self).constraint) {
		case SCALE_CONSTRAINT_ORIGINAL:
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
		{
			result = FALSE;
			if (scaled) {
				*scaled = _scaled;
			}
			return result;
		}
		default:
		{
			gboolean _tmp0_;
			gboolean _tmp1_ = FALSE;
			gboolean _tmp2_ = FALSE;
			_tmp0_ = dimensions_has_area (&(*self).viewport);
			g_assert (_tmp0_);
			if (!(*self).scale_up) {
				_tmp2_ = (*original).width < (*self).viewport.width;
			} else {
				_tmp2_ = FALSE;
			}
			if (_tmp2_) {
				_tmp1_ = (*original).height < (*self).viewport.height;
			} else {
				_tmp1_ = FALSE;
			}
			if (_tmp1_) {
				_scaled = *original;
			} else {
				Dimensions _tmp3_ = {0};
				Dimensions _tmp4_ = {0};
				dimensions_get_scaled_proportional (original, &(*self).viewport, &_tmp3_);
				_tmp4_ = _tmp3_;
				_scaled = _tmp4_;
			}
			result = TRUE;
			if (scaled) {
				*scaled = _scaled;
			}
			return result;
		}
	}
	if (scaled) {
		*scaled = _scaled;
	}
}


gboolean scaling_is_fill_viewport (Scaling *self, Dimensions* original, Dimensions* scaled) {
	Dimensions _scaled = {0};
	gboolean result = FALSE;
	gboolean _tmp0_;
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_ = {0};
	if ((*self).constraint != SCALE_CONSTRAINT_FILL_VIEWPORT) {
		result = FALSE;
		if (scaled) {
			*scaled = _scaled;
		}
		return result;
	}
	_tmp0_ = dimensions_has_area (&(*self).viewport);
	g_assert (_tmp0_);
	dimensions_get_scaled_to_fill_viewport (original, &(*self).viewport, &_tmp1_);
	_tmp2_ = _tmp1_;
	_scaled = _tmp2_;
	result = TRUE;
	if (scaled) {
		*scaled = _scaled;
	}
	return result;
}


void scaling_get_scaled_dimensions (Scaling *self, Dimensions* original, Dimensions* result) {
	gboolean _tmp0_;
	Dimensions scaled = {0};
	Dimensions _tmp1_ = {0};
	gboolean _tmp2_;
	Dimensions _tmp3_ = {0};
	gboolean _tmp4_;
	Dimensions _tmp5_ = {0};
	gboolean _tmp6_;
	gboolean is_viewport;
	_tmp0_ = scaling_is_unscaled (&(*self));
	if (_tmp0_) {
		*result = *original;
		return;
	}
	_tmp2_ = scaling_is_fill_viewport (&(*self), original, &_tmp1_);
	scaled = _tmp1_;
	if (_tmp2_) {
		*result = scaled;
		return;
	}
	_tmp4_ = scaling_is_best_fit_dimensions (&(*self), original, &_tmp3_);
	scaled = _tmp3_;
	if (_tmp4_) {
		*result = scaled;
		return;
	}
	_tmp6_ = scaling_is_for_viewport (&(*self), original, &_tmp5_);
	scaled = _tmp5_;
	is_viewport = _tmp6_;
	g_assert (is_viewport);
	*result = scaled;
	return;
}


GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self, GdkPixbuf* pixbuf, GdkInterpType interp, gboolean scale_up) {
	GdkPixbuf* result = NULL;
	gboolean _tmp0_;
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	Dimensions pixbuf_dim;
	gint pixels = 0;
	gint _tmp4_;
	gboolean _tmp5_;
	Dimensions scaled = {0};
	Dimensions _tmp7_ = {0};
	gboolean _tmp8_;
	Dimensions _tmp10_ = {0};
	gboolean _tmp11_;
	gboolean is_viewport;
	GdkPixbuf* _tmp12_ = NULL;
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
	_tmp0_ = scaling_is_unscaled (&(*self));
	if (_tmp0_) {
		GdkPixbuf* _tmp1_;
		_tmp1_ = _g_object_ref0 (pixbuf);
		result = _tmp1_;
		return result;
	}
	dimensions_for_pixbuf (pixbuf, &_tmp2_);
	_tmp3_ = _tmp2_;
	pixbuf_dim = _tmp3_;
	_tmp5_ = scaling_is_best_fit (&(*self), &pixbuf_dim, &_tmp4_);
	pixels = _tmp4_;
	if (_tmp5_) {
		GdkPixbuf* _tmp6_ = NULL;
		_tmp6_ = scale_pixbuf (pixbuf, pixels, interp, scale_up);
		result = _tmp6_;
		return result;
	}
	_tmp8_ = scaling_is_fill_viewport (&(*self), &pixbuf_dim, &_tmp7_);
	scaled = _tmp7_;
	if (_tmp8_) {
		GdkPixbuf* _tmp9_ = NULL;
		_tmp9_ = resize_pixbuf (pixbuf, &scaled, interp);
		result = _tmp9_;
		return result;
	}
	_tmp11_ = scaling_is_for_viewport (&(*self), &pixbuf_dim, &_tmp10_);
	scaled = _tmp10_;
	is_viewport = _tmp11_;
	g_assert (is_viewport);
	_tmp12_ = resize_pixbuf (pixbuf, &scaled, interp);
	result = _tmp12_;
	return result;
}


gchar* scaling_to_string (Scaling *self) {
	gchar* result = NULL;
	if ((*self).constraint == SCALE_CONSTRAINT_ORIGINAL) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("scaling: UNSCALED");
		result = _tmp0_;
		return result;
	} else {
		if ((*self).constraint == SCALE_CONSTRAINT_FILL_VIEWPORT) {
			gchar* _tmp1_ = NULL;
			gchar* _tmp2_;
			gchar* _tmp3_ = NULL;
			gchar* _tmp4_;
			_tmp1_ = dimensions_to_string (&(*self).viewport);
			_tmp2_ = _tmp1_;
			_tmp3_ = g_strdup_printf ("scaling: fill viewport %s", _tmp2_);
			_tmp4_ = _tmp3_;
			_g_free0 (_tmp2_);
			result = _tmp4_;
			return result;
		} else {
			if ((*self).scale != SCALING_NO_SCALE) {
				const gchar* _tmp5_ = NULL;
				gchar* _tmp6_ = NULL;
				gchar* _tmp7_;
				gint _tmp8_;
				gchar* _tmp9_ = NULL;
				gchar* _tmp10_;
				if ((*self).scale_up) {
					_tmp5_ = "scaled up";
				} else {
					_tmp5_ = "not scaled up";
				}
				_tmp6_ = scale_constraint_to_string ((*self).constraint);
				_tmp7_ = _tmp6_;
				_tmp8_ = scaling_scale_to_pixels (&(*self));
				_tmp9_ = g_strdup_printf ("scaling: best-fit (%s %d pixels %s)", _tmp7_, _tmp8_, _tmp5_);
				_tmp10_ = _tmp9_;
				_g_free0 (_tmp7_);
				result = _tmp10_;
				return result;
			} else {
				const gchar* _tmp11_ = NULL;
				gchar* _tmp12_ = NULL;
				gchar* _tmp13_;
				gchar* _tmp14_ = NULL;
				gchar* _tmp15_;
				if ((*self).scale_up) {
					_tmp11_ = "scaled up";
				} else {
					_tmp11_ = "not scaled up";
				}
				_tmp12_ = dimensions_to_string (&(*self).viewport);
				_tmp13_ = _tmp12_;
				_tmp14_ = g_strdup_printf ("scaling: viewport %s (%s)", _tmp13_, _tmp11_);
				_tmp15_ = _tmp14_;
				_g_free0 (_tmp13_);
				result = _tmp15_;
				return result;
			}
		}
	}
}


gboolean scaling_equals (Scaling *self, Scaling* scaling) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	if ((*self).constraint == (*scaling).constraint) {
		_tmp1_ = (*self).scale == (*scaling).scale;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gboolean _tmp2_;
		_tmp2_ = dimensions_equals (&(*self).viewport, &(*scaling).viewport);
		_tmp0_ = _tmp2_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}


Scaling* scaling_dup (const Scaling* self) {
	Scaling* dup;
	dup = g_new0 (Scaling, 1);
	memcpy (dup, self, sizeof (Scaling));
	return dup;
}


void scaling_free (Scaling* self) {
	g_free (self);
}


GType scaling_get_type (void) {
	static volatile gsize scaling_type_id__volatile = 0;
	if (g_once_init_enter (&scaling_type_id__volatile)) {
		GType scaling_type_id;
		scaling_type_id = g_boxed_type_register_static ("Scaling", (GBoxedCopyFunc) scaling_dup, (GBoxedFreeFunc) scaling_free);
		g_once_init_leave (&scaling_type_id__volatile, scaling_type_id);
	}
	return scaling_type_id__volatile;
}


void zoom_state_init (ZoomState *self, Dimensions* content_dimensions, Dimensions* viewport_dimensions, gdouble slider_val, GdkPoint* viewport_center) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	memset (self, 0, sizeof (ZoomState));
	(*self).content_dimensions = *content_dimensions;
	(*self).viewport_dimensions = *viewport_dimensions;
	(*self).interpolation_factor = slider_val;
	zoom_state_compute_zoom_factors (&(*self));
	if (viewport_center == NULL) {
		_tmp1_ = TRUE;
	} else {
		gboolean _tmp2_ = FALSE;
		if ((*viewport_center).x == 0) {
			_tmp2_ = (*viewport_center).y == 0;
		} else {
			_tmp2_ = FALSE;
		}
		_tmp1_ = _tmp2_;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = slider_val == 0.0;
	}
	if (_tmp0_) {
		zoom_state_center_viewport (&(*self));
	} else {
		(*self).viewport_center = *viewport_center;
		zoom_state_clamp_viewport_center (&(*self));
	}
}


void zoom_state_init_rescale (ZoomState *self, ZoomState* existing, gdouble new_slider_val) {
	memset (self, 0, sizeof (ZoomState));
	(*self).content_dimensions = (*existing).content_dimensions;
	(*self).viewport_dimensions = (*existing).viewport_dimensions;
	(*self).interpolation_factor = new_slider_val;
	zoom_state_compute_zoom_factors (&(*self));
	if (new_slider_val == 0.0) {
		zoom_state_center_viewport (&(*self));
	} else {
		(*self).viewport_center.x = (gint) ((*self).zoom_factor * ((*existing).viewport_center.x / (*existing).zoom_factor));
		(*self).viewport_center.y = (gint) ((*self).zoom_factor * ((*existing).viewport_center.y / (*existing).zoom_factor));
		zoom_state_clamp_viewport_center (&(*self));
	}
}


void zoom_state_init_rescale_to_isomorphic (ZoomState *self, ZoomState* existing) {
	gdouble _tmp0_;
	gdouble _tmp1_;
	memset (self, 0, sizeof (ZoomState));
	(*self).content_dimensions = (*existing).content_dimensions;
	(*self).viewport_dimensions = (*existing).viewport_dimensions;
	_tmp0_ = log (1.0 / (*existing).min_factor);
	_tmp1_ = log ((*existing).max_factor / (*existing).min_factor);
	(*self).interpolation_factor = _tmp0_ / _tmp1_;
	zoom_state_compute_zoom_factors (&(*self));
	if ((*self).interpolation_factor == 0.0) {
		zoom_state_center_viewport (&(*self));
	} else {
		(*self).viewport_center.x = (gint) ((*self).zoom_factor * ((*existing).viewport_center.x / (*existing).zoom_factor));
		(*self).viewport_center.y = (gint) ((*self).zoom_factor * ((*existing).viewport_center.y / (*existing).zoom_factor));
		zoom_state_clamp_viewport_center (&(*self));
	}
}


void zoom_state_init_pan (ZoomState *self, ZoomState* existing, GdkPoint* new_viewport_center) {
	memset (self, 0, sizeof (ZoomState));
	(*self).content_dimensions = (*existing).content_dimensions;
	(*self).viewport_dimensions = (*existing).viewport_dimensions;
	(*self).interpolation_factor = (*existing).interpolation_factor;
	zoom_state_compute_zoom_factors (&(*self));
	(*self).viewport_center = *new_viewport_center;
	zoom_state_clamp_viewport_center (&(*self));
}


static void zoom_state_clamp_viewport_center (ZoomState *self) {
	gint _tmp0_;
	gint zoomed_width;
	gint _tmp1_;
	gint zoomed_height;
	gint _tmp2_;
	gint _tmp3_;
	_tmp0_ = zoom_state_get_zoomed_width (&(*self));
	zoomed_width = _tmp0_;
	_tmp1_ = zoom_state_get_zoomed_height (&(*self));
	zoomed_height = _tmp1_;
	_tmp2_ = CLAMP ((*self).viewport_center.x, (*self).viewport_dimensions.width / 2, (zoomed_width - ((*self).viewport_dimensions.width / 2)) - 1);
	(*self).viewport_center.x = _tmp2_;
	_tmp3_ = CLAMP ((*self).viewport_center.y, (*self).viewport_dimensions.height / 2, (zoomed_height - ((*self).viewport_dimensions.height / 2)) - 1);
	(*self).viewport_center.y = _tmp3_;
}


static void zoom_state_center_viewport (ZoomState *self) {
	gint _tmp0_;
	gint _tmp1_;
	_tmp0_ = zoom_state_get_zoomed_width (&(*self));
	(*self).viewport_center.x = _tmp0_ / 2;
	_tmp1_ = zoom_state_get_zoomed_height (&(*self));
	(*self).viewport_center.y = _tmp1_ / 2;
}


static void zoom_state_compute_zoom_factors (ZoomState *self) {
	gdouble viewport_to_content_x = 0.0;
	gdouble viewport_to_content_y = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	(*self).max_factor = 2.0;
	dimensions_get_scale_ratios (&(*self).content_dimensions, &(*self).viewport_dimensions, &_tmp0_, &_tmp1_);
	viewport_to_content_x = _tmp0_;
	viewport_to_content_y = _tmp1_;
	_tmp2_ = MIN (viewport_to_content_x, viewport_to_content_y);
	(*self).min_factor = _tmp2_;
	if ((*self).min_factor > 1.0) {
		(*self).min_factor = 1.0;
	}
	_tmp3_ = pow ((*self).max_factor / (*self).min_factor, (*self).interpolation_factor);
	(*self).zoom_factor = (*self).min_factor * _tmp3_;
}


gdouble zoom_state_get_interpolation_factor (ZoomState *self) {
	gdouble result = 0.0;
	result = (*self).interpolation_factor;
	return result;
}


void zoom_state_get_viewing_rectangle_wrt_content (ZoomState *self, GdkRectangle* result) {
	gint _tmp0_;
	gint zoomed_width;
	gint _tmp1_;
	gint zoomed_height;
	GdkRectangle _tmp2_ = {0};
	GdkRectangle _result_;
	gint right;
	gint bottom;
	gint _tmp3_;
	gint _tmp4_;
	_tmp0_ = zoom_state_get_zoomed_width (&(*self));
	zoomed_width = _tmp0_;
	_tmp1_ = zoom_state_get_zoomed_height (&(*self));
	zoomed_height = _tmp1_;
	_tmp2_.x = 0;
	_result_ = _tmp2_;
	if ((*self).viewport_dimensions.width < zoomed_width) {
		_result_.x = (*self).viewport_center.x - ((*self).viewport_dimensions.width / 2);
	} else {
		_result_.x = (zoomed_width - (*self).viewport_dimensions.width) / 2;
	}
	if (_result_.x < 0) {
		_result_.x = 0;
	}
	if ((*self).viewport_dimensions.height < zoomed_height) {
		_result_.y = (*self).viewport_center.y - ((*self).viewport_dimensions.height / 2);
	} else {
		_result_.y = (zoomed_height - (*self).viewport_dimensions.height) / 2;
	}
	if (_result_.y < 0) {
		_result_.y = 0;
	}
	right = _result_.x + (*self).viewport_dimensions.width;
	if (right > zoomed_width) {
		right = zoomed_width;
	}
	_result_.width = right - _result_.x;
	bottom = _result_.y + (*self).viewport_dimensions.height;
	if (bottom > zoomed_height) {
		bottom = zoomed_height;
	}
	_result_.height = bottom - _result_.y;
	_tmp3_ = CLAMP (_result_.width, 1, G_MAXINT);
	_result_.width = _tmp3_;
	_tmp4_ = CLAMP (_result_.height, 1, G_MAXINT);
	_result_.height = _tmp4_;
	*result = _result_;
	return;
}


void zoom_state_get_viewing_rectangle_wrt_screen (ZoomState *self, GdkRectangle* result) {
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _tmp1_ = {0};
	GdkRectangle wrt_content;
	GdkRectangle _tmp2_ = {0};
	GdkRectangle _result_;
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp0_);
	_tmp1_ = _tmp0_;
	wrt_content = _tmp1_;
	_tmp2_.x = 0;
	_result_ = _tmp2_;
	_result_.x = ((*self).viewport_dimensions.width / 2) - (wrt_content.width / 2);
	if (_result_.x < 0) {
		_result_.x = 0;
	}
	_result_.y = ((*self).viewport_dimensions.height / 2) - (wrt_content.height / 2);
	if (_result_.y < 0) {
		_result_.y = 0;
	}
	_result_.width = wrt_content.width;
	_result_.height = wrt_content.height;
	*result = _result_;
	return;
}


void zoom_state_get_viewing_rectangle_projection (ZoomState *self, GdkPixbuf* for_pixbuf, GdkRectangle* result) {
	gint _tmp0_;
	gdouble zoomed_width;
	gint _tmp1_;
	gdouble zoomed_height;
	gint _tmp2_;
	gdouble horiz_scale;
	gint _tmp3_;
	gdouble vert_scale;
	gdouble scale;
	GdkRectangle _tmp4_ = {0};
	GdkRectangle _tmp5_ = {0};
	GdkRectangle viewing_rectangle;
	GdkRectangle _tmp6_ = {0};
	GdkRectangle _result_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint right;
	gint _tmp11_;
	gint _tmp12_;
	gint bottom;
	gint _tmp13_;
	gint _tmp14_;
	g_return_if_fail (GDK_IS_PIXBUF (for_pixbuf));
	_tmp0_ = zoom_state_get_zoomed_width (&(*self));
	zoomed_width = (gdouble) _tmp0_;
	_tmp1_ = zoom_state_get_zoomed_height (&(*self));
	zoomed_height = (gdouble) _tmp1_;
	_tmp2_ = gdk_pixbuf_get_width (for_pixbuf);
	horiz_scale = _tmp2_ / zoomed_width;
	_tmp3_ = gdk_pixbuf_get_height (for_pixbuf);
	vert_scale = _tmp3_ / zoomed_height;
	scale = (horiz_scale + vert_scale) / 2.0;
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp4_);
	_tmp5_ = _tmp4_;
	viewing_rectangle = _tmp5_;
	_tmp6_.x = 0;
	_result_ = _tmp6_;
	_result_.x = (gint) (viewing_rectangle.x * scale);
	_tmp7_ = gdk_pixbuf_get_width (for_pixbuf);
	_tmp8_ = CLAMP (_result_.x, 0, _tmp7_);
	_result_.x = _tmp8_;
	_result_.y = (gint) (viewing_rectangle.y * scale);
	_tmp9_ = gdk_pixbuf_get_height (for_pixbuf);
	_tmp10_ = CLAMP (_result_.y, 0, _tmp9_);
	_result_.y = _tmp10_;
	right = (gint) ((viewing_rectangle.x + viewing_rectangle.width) * scale);
	_tmp11_ = gdk_pixbuf_get_width (for_pixbuf);
	_tmp12_ = CLAMP (right, 0, _tmp11_);
	right = _tmp12_;
	bottom = (gint) ((viewing_rectangle.y + viewing_rectangle.height) * scale);
	_tmp13_ = gdk_pixbuf_get_height (for_pixbuf);
	_tmp14_ = CLAMP (bottom, 0, _tmp13_);
	bottom = _tmp14_;
	_result_.width = right - _result_.x;
	_result_.height = bottom - _result_.y;
	*result = _result_;
	return;
}


gdouble zoom_state_get_zoom_factor (ZoomState *self) {
	gdouble result = 0.0;
	result = (*self).zoom_factor;
	return result;
}


gint zoom_state_get_zoomed_width (ZoomState *self) {
	gint result = 0;
	result = (gint) ((*self).content_dimensions.width * (*self).zoom_factor);
	return result;
}


gint zoom_state_get_zoomed_height (ZoomState *self) {
	gint result = 0;
	result = (gint) ((*self).content_dimensions.height * (*self).zoom_factor);
	return result;
}


void zoom_state_get_viewport_center (ZoomState *self, GdkPoint* result) {
	*result = (*self).viewport_center;
	return;
}


gchar* zoom_state_to_string (ZoomState *self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* named_modes;
	gboolean _tmp1_;
	gboolean _tmp4_;
	gboolean _tmp7_;
	gboolean _tmp10_;
	GdkRectangle _tmp14_ = {0};
	GdkRectangle _tmp15_ = {0};
	GdkRectangle viewing_rect;
	gint _tmp16_;
	gint _tmp17_;
	gchar* _tmp18_ = NULL;
	_tmp0_ = g_strdup ("");
	named_modes = _tmp0_;
	_tmp1_ = zoom_state_is_min (&(*self));
	if (_tmp1_) {
		const gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
		if (g_strcmp0 (named_modes, "") == 0) {
			_tmp2_ = "MIN";
		} else {
			_tmp2_ = ", MIN";
		}
		_tmp3_ = g_strconcat (named_modes, _tmp2_, NULL);
		_g_free0 (named_modes);
		named_modes = _tmp3_;
	}
	_tmp4_ = zoom_state_is_default (&(*self));
	if (_tmp4_) {
		const gchar* _tmp5_ = NULL;
		gchar* _tmp6_;
		if (g_strcmp0 (named_modes, "") == 0) {
			_tmp5_ = "DEFAULT";
		} else {
			_tmp5_ = ", DEFAULT";
		}
		_tmp6_ = g_strconcat (named_modes, _tmp5_, NULL);
		_g_free0 (named_modes);
		named_modes = _tmp6_;
	}
	_tmp7_ = zoom_state_is_isomorphic (&(*self));
	if (_tmp7_) {
		const gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		if (g_strcmp0 (named_modes, "") == 0) {
			_tmp8_ = "ISOMORPHIC";
		} else {
			_tmp8_ = ", ISOMORPHIC";
		}
		_tmp9_ = g_strconcat (named_modes, _tmp8_, NULL);
		_g_free0 (named_modes);
		named_modes = _tmp9_;
	}
	_tmp10_ = zoom_state_is_max (&(*self));
	if (_tmp10_) {
		const gchar* _tmp11_ = NULL;
		gchar* _tmp12_;
		if (g_strcmp0 (named_modes, "") == 0) {
			_tmp11_ = "MAX";
		} else {
			_tmp11_ = ", MAX";
		}
		_tmp12_ = g_strconcat (named_modes, _tmp11_, NULL);
		_g_free0 (named_modes);
		named_modes = _tmp12_;
	}
	if (g_strcmp0 (named_modes, "") == 0) {
		gchar* _tmp13_;
		_tmp13_ = g_strdup ("(none)");
		_g_free0 (named_modes);
		named_modes = _tmp13_;
	}
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp14_);
	_tmp15_ = _tmp14_;
	viewing_rect = _tmp15_;
	_tmp16_ = zoom_state_get_zoomed_width (&(*self));
	_tmp17_ = zoom_state_get_zoomed_height (&(*self));
	_tmp18_ = g_strdup_printf ("ZoomState {\n" \
"    content dimensions = %d x %d;\n" \
"    viewport dimensions = " "%d x %d;\n" \
"    min factor = %f;\n" \
"    max factor = %f;\n" \
"    current factor = %f;" "\n" \
"    zoomed width = %d;\n" \
"    zoomed height = %d;\n" \
"    named modes = %s;" "\n    viewing rectangle = { x: %d, y: %d, width: %d, height: %d };" "\n    viewport center = (%d, %d);\n}\n", (*self).content_dimensions.width, (*self).content_dimensions.height, (*self).viewport_dimensions.width, (*self).viewport_dimensions.height, (*self).min_factor, (*self).max_factor, (*self).zoom_factor, _tmp16_, _tmp17_, named_modes, viewing_rect.x, viewing_rect.y, viewing_rect.width, viewing_rect.height, (*self).viewport_center.x, (*self).viewport_center.y);
	result = _tmp18_;
	_g_free0 (named_modes);
	return result;
}


gboolean zoom_state_is_min (ZoomState *self) {
	gboolean result = FALSE;
	result = (*self).zoom_factor == (*self).min_factor;
	return result;
}


gboolean zoom_state_is_default (ZoomState *self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	_tmp0_ = zoom_state_is_min (&(*self));
	result = _tmp0_;
	return result;
}


gboolean zoom_state_is_max (ZoomState *self) {
	gboolean result = FALSE;
	result = (*self).zoom_factor == (*self).max_factor;
	return result;
}


gboolean zoom_state_is_isomorphic (ZoomState *self) {
	gboolean result = FALSE;
	result = (*self).zoom_factor == 1.0;
	return result;
}


gboolean zoom_state_equals (ZoomState *self, ZoomState* other) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	_tmp0_ = dimensions_equals (&(*self).content_dimensions, &(*other).content_dimensions);
	if (!_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp1_ = dimensions_equals (&(*self).viewport_dimensions, &(*other).viewport_dimensions);
	if (!_tmp1_) {
		result = FALSE;
		return result;
	}
	if ((*self).zoom_factor != (*other).zoom_factor) {
		result = FALSE;
		return result;
	}
	if ((*self).min_factor != (*other).min_factor) {
		result = FALSE;
		return result;
	}
	if ((*self).max_factor != (*other).max_factor) {
		result = FALSE;
		return result;
	}
	if ((*self).viewport_center.x != (*other).viewport_center.x) {
		result = FALSE;
		return result;
	}
	if ((*self).viewport_center.y != (*other).viewport_center.y) {
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}


ZoomState* zoom_state_dup (const ZoomState* self) {
	ZoomState* dup;
	dup = g_new0 (ZoomState, 1);
	memcpy (dup, self, sizeof (ZoomState));
	return dup;
}


void zoom_state_free (ZoomState* self) {
	g_free (self);
}


GType zoom_state_get_type (void) {
	static volatile gsize zoom_state_type_id__volatile = 0;
	if (g_once_init_enter (&zoom_state_type_id__volatile)) {
		GType zoom_state_type_id;
		zoom_state_type_id = g_boxed_type_register_static ("ZoomState", (GBoxedCopyFunc) zoom_state_dup, (GBoxedFreeFunc) zoom_state_free);
		g_once_init_leave (&zoom_state_type_id__volatile, zoom_state_type_id);
	}
	return zoom_state_type_id__volatile;
}



