/* SourceHoldingTank.c generated by valac 0.12.1, the Vala compiler
 * generated from SourceHoldingTank.vala, do not modify */

/* Copyright 2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */
/* A SourceHoldingTank is similar to the holding tank used by ContainerSourceCollection, but for*/
/* non-ContainerSources to be held offline from their natural SourceCollection (i.e. PhotoSources*/
/* being held in a trashcan, for example).  It is *not* a DataCollection (important!), but rather*/
/* a signalled collection that moves DataSources to and from their SourceCollection.*/
/**/
/* DataSources can be shuttled from their SourceCollection to the SourceHoldingTank manually*/
/* (via unlink_and_hold) or can be automatically moved by installing a HoldingPredicate.*/
/* Only one HoldingConditional may be installed.  Because of assertions in the methods, it's unwise*/
/* to use more than one method.  add() and add_many() should ONLY be used for DataSources not*/
/* first installed in their SourceCollection (i.e. they're born in the SourceHoldingTank).*/
/**/
/* NOTE: DataSources should never be in more than one SourceHoldingTank.  No tests are performed*/
/* here to verify this.  This is why a filter/predicate method (which could automatically move*/
/* them in as they're altered) is not offered; there's no easy way to keep DataSources from being*/
/* moved into more than one holding tank, or which should have preference.  The CheckToRemove*/
/* predicate is offered only to know when to release them.*/

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>


#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;
typedef struct _SourceHoldingTankPrivate SourceHoldingTankPrivate;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_DATA_SET (data_set_get_type ())
#define DATA_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SET, DataSet))
#define DATA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SET, DataSetClass))
#define IS_DATA_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SET))
#define IS_DATA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SET))
#define DATA_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SET, DataSetClass))

typedef struct _DataSet DataSet;
typedef struct _DataSetClass DataSetClass;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _data_set_unref0(var) ((var == NULL) ? NULL : (var = (data_set_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define TYPE_SINGLETON_COLLECTION (singleton_collection_get_type ())
#define SINGLETON_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SINGLETON_COLLECTION, SingletonCollection))
#define SINGLETON_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SINGLETON_COLLECTION, SingletonCollectionClass))
#define IS_SINGLETON_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SINGLETON_COLLECTION))
#define IS_SINGLETON_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SINGLETON_COLLECTION))
#define SINGLETON_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SINGLETON_COLLECTION, SingletonCollectionClass))

typedef struct _SingletonCollection SingletonCollection;
typedef struct _SingletonCollectionClass SingletonCollectionClass;
typedef struct _ParamSpecSourceHoldingTank ParamSpecSourceHoldingTank;

struct _SourceHoldingTank {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceHoldingTankPrivate * priv;
};

struct _SourceHoldingTankClass {
	GTypeClass parent_class;
	void (*finalize) (SourceHoldingTank *self);
	void (*notify_contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
	void (*contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
};

typedef gboolean (*SourceHoldingTankCheckToKeep) (DataSource* source, Alteration* alteration, void* user_data);
struct _SourceHoldingTankPrivate {
	SourceCollection* sources;
	SourceHoldingTankCheckToKeep check_to_keep;
	gpointer check_to_keep_target;
	GDestroyNotify check_to_keep_target_destroy_notify;
	DataSet* tank;
	GeeHashSet* relinks;
	GeeHashSet* unlinking;
	gint64 ordinal;
};

struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, void* user_data);
struct _ParamSpecSourceHoldingTank {
	GParamSpec parent_instance;
};


static gpointer source_holding_tank_parent_class = NULL;

gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_holding_tank (GValue* value, gpointer v_object);
void value_take_source_holding_tank (GValue* value, gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST;
GType data_object_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
gpointer data_set_ref (gpointer instance);
void data_set_unref (gpointer instance);
GParamSpec* param_spec_data_set (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_set (GValue* value, gpointer v_object);
void value_take_data_set (GValue* value, gpointer v_object);
gpointer value_get_data_set (const GValue* value);
GType data_set_get_type (void) G_GNUC_CONST;
#define SOURCE_HOLDING_TANK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankPrivate))
enum  {
	SOURCE_HOLDING_TANK_DUMMY_PROPERTY
};
static void source_holding_tank_on_source_destroyed (SourceHoldingTank* self, DataSource* source);
static void _source_holding_tank_on_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender, DataSource* source, gpointer self);
static void source_holding_tank_on_source_collection_thawed (SourceHoldingTank* self);
static void _source_holding_tank_on_source_collection_thawed_data_collection_thawed (DataCollection* _sender, gpointer self);
DataSet* data_set_new (void);
DataSet* data_set_construct (GType object_type);
SourceHoldingTank* source_holding_tank_new (SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target);
SourceHoldingTank* source_holding_tank_construct (GType object_type, SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target);
void source_holding_tank_notify_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
static void source_holding_tank_real_notify_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
void data_source_notify_held_in_tank (DataSource* self, SourceHoldingTank* holding_tank);
gint source_holding_tank_get_count (SourceHoldingTank* self);
gint data_set_get_count (DataSet* self);
GeeCollection* source_holding_tank_get_all (SourceHoldingTank* self);
GeeList* data_set_get_all (DataSet* self);
gboolean source_holding_tank_contains (SourceHoldingTank* self, DataSource* source);
gboolean data_set_contains (DataSet* self, DataObject* object);
void source_holding_tank_add_many (SourceHoldingTank* self, GeeCollection* many);
void data_object_internal_set_ordinal (DataObject* self, gint64 ordinal);
gboolean data_set_add_many (DataSet* self, GeeCollection* objects);
void source_holding_tank_unlink_and_hold (SourceHoldingTank* self, GeeCollection* unlink);
GType marker_get_type (void) G_GNUC_CONST;
GeeCollection* source_collection_unlink_marked (SourceCollection* self, Marker* marker, ProgressMonitor monitor, void* monitor_target);
Marker* data_collection_mark_many (DataCollection* self, GeeCollection* objects);
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_backlink (GValue* value, gpointer v_object);
void value_take_source_backlink (GValue* value, gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
gboolean source_holding_tank_has_backlink (SourceHoldingTank* self, SourceBacklink* backlink);
DataObject* data_set_get_at (DataSet* self, gint index);
gboolean data_source_has_backlink (DataSource* self, SourceBacklink* backlink);
void source_holding_tank_remove_backlink (SourceHoldingTank* self, SourceBacklink* backlink);
gboolean data_source_remove_backlink (DataSource* self, SourceBacklink* backlink);
void source_holding_tank_destroy_orphans (SourceHoldingTank* self, GeeList* destroy, gboolean delete_backing, ProgressMonitor monitor, void* monitor_target, GeeList* not_removed);
gboolean data_set_remove_many (DataSet* self, GeeCollection* objects);
gboolean data_source_destroy_orphan (DataSource* self, gboolean delete_backing);
gboolean data_set_remove (DataSet* self, DataObject* object);
SingletonCollection* singleton_collection_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, gconstpointer object);
SingletonCollection* singleton_collection_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, gconstpointer object);
GType singleton_collection_get_type (void) G_GNUC_CONST;
void source_holding_tank_internal_notify_altered (SourceHoldingTank* self, DataSource* source, Alteration* alteration);
gboolean data_collection_are_notifications_frozen (DataCollection* self);
void source_collection_relink (SourceCollection* self, DataSource* source);
void source_collection_relink_many (SourceCollection* self, GeeCollection* relink);
void source_holding_tank_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
static void source_holding_tank_real_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void source_holding_tank_finalize (SourceHoldingTank* obj);


static void _source_holding_tank_on_source_destroyed_source_collection_item_destroyed (SourceCollection* _sender, DataSource* source, gpointer self) {
	source_holding_tank_on_source_destroyed (self, source);
}


static void _source_holding_tank_on_source_collection_thawed_data_collection_thawed (DataCollection* _sender, gpointer self) {
	source_holding_tank_on_source_collection_thawed (self);
}


static gpointer _data_collection_ref0 (gpointer self) {
	return self ? data_collection_ref (self) : NULL;
}


SourceHoldingTank* source_holding_tank_construct (GType object_type, SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target) {
	SourceHoldingTank* self = NULL;
	SourceCollection* _tmp0_;
	SourceHoldingTankCheckToKeep _tmp1_;
	g_return_val_if_fail (IS_SOURCE_COLLECTION (sources), NULL);
	self = (SourceHoldingTank*) g_type_create_instance (object_type);
	_tmp0_ = _data_collection_ref0 (sources);
	_data_collection_unref0 (self->priv->sources);
	self->priv->sources = _tmp0_;
	_tmp1_ = check_to_keep;
	(self->priv->check_to_keep_target_destroy_notify == NULL) ? NULL : (self->priv->check_to_keep_target_destroy_notify (self->priv->check_to_keep_target), NULL);
	self->priv->check_to_keep = NULL;
	self->priv->check_to_keep_target = NULL;
	self->priv->check_to_keep_target_destroy_notify = NULL;
	self->priv->check_to_keep = _tmp1_;
	self->priv->check_to_keep_target = check_to_keep_target;
	self->priv->check_to_keep_target_destroy_notify = NULL;
	g_signal_connect (self->priv->sources, "item-destroyed", (GCallback) _source_holding_tank_on_source_destroyed_source_collection_item_destroyed, self);
	g_signal_connect (DATA_COLLECTION (self->priv->sources), "thawed", (GCallback) _source_holding_tank_on_source_collection_thawed_data_collection_thawed, self);
	return self;
}


SourceHoldingTank* source_holding_tank_new (SourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target) {
	return source_holding_tank_construct (TYPE_SOURCE_HOLDING_TANK, sources, check_to_keep, check_to_keep_target);
}


static void source_holding_tank_real_notify_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed) {
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
	if (added != NULL) {
		{
			GeeIterator* _tmp0_ = NULL;
			GeeIterator* _source_it;
			_tmp0_ = gee_iterable_iterator (GEE_ITERABLE (added));
			_source_it = _tmp0_;
			while (TRUE) {
				gboolean _tmp1_;
				gpointer _tmp2_ = NULL;
				DataSource* source;
				_tmp1_ = gee_iterator_next (_source_it);
				if (!_tmp1_) {
					break;
				}
				_tmp2_ = gee_iterator_get (_source_it);
				source = (DataSource*) _tmp2_;
				data_source_notify_held_in_tank (source, self);
				_g_object_unref0 (source);
			}
			_g_object_unref0 (_source_it);
		}
	}
	if (removed != NULL) {
		{
			GeeIterator* _tmp3_ = NULL;
			GeeIterator* _source_it;
			_tmp3_ = gee_iterable_iterator (GEE_ITERABLE (removed));
			_source_it = _tmp3_;
			while (TRUE) {
				gboolean _tmp4_;
				gpointer _tmp5_ = NULL;
				DataSource* source;
				_tmp4_ = gee_iterator_next (_source_it);
				if (!_tmp4_) {
					break;
				}
				_tmp5_ = gee_iterator_get (_source_it);
				source = (DataSource*) _tmp5_;
				data_source_notify_held_in_tank (source, NULL);
				_g_object_unref0 (source);
			}
			_g_object_unref0 (_source_it);
		}
	}
	g_signal_emit_by_name (self, "contents-altered", added, removed);
}


void source_holding_tank_notify_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed) {
	SOURCE_HOLDING_TANK_GET_CLASS (self)->notify_contents_altered (self, added, removed);
}


gint source_holding_tank_get_count (SourceHoldingTank* self) {
	gint result = 0;
	gint _tmp0_;
	g_return_val_if_fail (IS_SOURCE_HOLDING_TANK (self), 0);
	_tmp0_ = data_set_get_count (self->priv->tank);
	result = _tmp0_;
	return result;
}


GeeCollection* source_holding_tank_get_all (SourceHoldingTank* self) {
	GeeCollection* result = NULL;
	GeeList* _tmp0_ = NULL;
	g_return_val_if_fail (IS_SOURCE_HOLDING_TANK (self), NULL);
	_tmp0_ = data_set_get_all (self->priv->tank);
	result = GEE_COLLECTION (_tmp0_);
	return result;
}


gboolean source_holding_tank_contains (SourceHoldingTank* self, DataSource* source) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	g_return_val_if_fail (IS_SOURCE_HOLDING_TANK (self), FALSE);
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
	_tmp1_ = data_set_contains (self->priv->tank, DATA_OBJECT (source));
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_;
		_tmp2_ = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (self->priv->unlinking), source);
		_tmp0_ = _tmp2_;
	}
	result = _tmp0_;
	return result;
}


void source_holding_tank_add_many (SourceHoldingTank* self, GeeCollection* many) {
	gint _tmp0_;
	gboolean _tmp5_;
	gboolean added;
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
	g_return_if_fail (GEE_IS_COLLECTION (many));
	_tmp0_ = gee_collection_get_size (many);
	if (_tmp0_ == 0) {
		return;
	}
	{
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _source_it;
		_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (many));
		_source_it = _tmp1_;
		while (TRUE) {
			gboolean _tmp2_;
			gpointer _tmp3_ = NULL;
			DataSource* source;
			gint64 _tmp4_;
			_tmp2_ = gee_iterator_next (_source_it);
			if (!_tmp2_) {
				break;
			}
			_tmp3_ = gee_iterator_get (_source_it);
			source = (DataSource*) _tmp3_;
			_tmp4_ = self->priv->ordinal;
			self->priv->ordinal = _tmp4_ + 1;
			data_object_internal_set_ordinal (DATA_OBJECT (source), _tmp4_);
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
	_tmp5_ = data_set_add_many (self->priv->tank, many);
	added = _tmp5_;
	g_assert (added);
	source_holding_tank_notify_contents_altered (self, many, NULL);
}


void source_holding_tank_unlink_and_hold (SourceHoldingTank* self, GeeCollection* unlink) {
	gint _tmp0_;
	Marker* _tmp1_ = NULL;
	Marker* _tmp2_;
	GeeCollection* _tmp3_ = NULL;
	GeeCollection* _tmp4_;
	gboolean _tmp9_;
	gboolean added;
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
	g_return_if_fail (GEE_IS_COLLECTION (unlink));
	_tmp0_ = gee_collection_get_size (unlink);
	if (_tmp0_ == 0) {
		return;
	}
	gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (self->priv->unlinking), unlink);
	_tmp1_ = data_collection_mark_many (DATA_COLLECTION (self->priv->sources), unlink);
	_tmp2_ = _tmp1_;
	_tmp3_ = source_collection_unlink_marked (self->priv->sources, _tmp2_, NULL, NULL);
	_tmp4_ = _tmp3_;
	_g_object_unref0 (_tmp4_);
	_g_object_unref0 (_tmp2_);
	{
		GeeIterator* _tmp5_ = NULL;
		GeeIterator* _source_it;
		_tmp5_ = gee_iterable_iterator (GEE_ITERABLE (unlink));
		_source_it = _tmp5_;
		while (TRUE) {
			gboolean _tmp6_;
			gpointer _tmp7_ = NULL;
			DataSource* source;
			gint64 _tmp8_;
			_tmp6_ = gee_iterator_next (_source_it);
			if (!_tmp6_) {
				break;
			}
			_tmp7_ = gee_iterator_get (_source_it);
			source = (DataSource*) _tmp7_;
			_tmp8_ = self->priv->ordinal;
			self->priv->ordinal = _tmp8_ + 1;
			data_object_internal_set_ordinal (DATA_OBJECT (source), _tmp8_);
			_g_object_unref0 (source);
		}
		_g_object_unref0 (_source_it);
	}
	_tmp9_ = data_set_add_many (self->priv->tank, unlink);
	added = _tmp9_;
	g_assert (added);
	gee_abstract_collection_remove_all (GEE_ABSTRACT_COLLECTION (self->priv->unlinking), unlink);
	source_holding_tank_notify_contents_altered (self, unlink, NULL);
}


gboolean source_holding_tank_has_backlink (SourceHoldingTank* self, SourceBacklink* backlink) {
	gboolean result = FALSE;
	gint _tmp0_;
	gint count;
	g_return_val_if_fail (IS_SOURCE_HOLDING_TANK (self), FALSE);
	g_return_val_if_fail (IS_SOURCE_BACKLINK (backlink), FALSE);
	_tmp0_ = data_set_get_count (self->priv->tank);
	count = _tmp0_;
	{
		gint ctr;
		ctr = 0;
		{
			gboolean _tmp1_;
			_tmp1_ = TRUE;
			while (TRUE) {
				DataObject* _tmp2_ = NULL;
				DataSource* _tmp3_;
				gboolean _tmp4_;
				gboolean _tmp5_;
				if (!_tmp1_) {
					ctr++;
				}
				_tmp1_ = FALSE;
				if (!(ctr < count)) {
					break;
				}
				_tmp2_ = data_set_get_at (self->priv->tank, ctr);
				_tmp3_ = DATA_SOURCE (_tmp2_);
				_tmp4_ = data_source_has_backlink (_tmp3_, backlink);
				_tmp5_ = _tmp4_;
				_g_object_unref0 (_tmp3_);
				if (_tmp5_) {
					result = TRUE;
					return result;
				}
			}
		}
	}
	result = FALSE;
	return result;
}


void source_holding_tank_remove_backlink (SourceHoldingTank* self, SourceBacklink* backlink) {
	gint _tmp0_;
	gint count;
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
	_tmp0_ = data_set_get_count (self->priv->tank);
	count = _tmp0_;
	{
		gint ctr;
		ctr = 0;
		{
			gboolean _tmp1_;
			_tmp1_ = TRUE;
			while (TRUE) {
				DataObject* _tmp2_ = NULL;
				DataSource* _tmp3_;
				if (!_tmp1_) {
					ctr++;
				}
				_tmp1_ = FALSE;
				if (!(ctr < count)) {
					break;
				}
				_tmp2_ = data_set_get_at (self->priv->tank, ctr);
				_tmp3_ = DATA_SOURCE (_tmp2_);
				data_source_remove_backlink (_tmp3_, backlink);
				_g_object_unref0 (_tmp3_);
			}
		}
	}
}


void source_holding_tank_destroy_orphans (SourceHoldingTank* self, GeeList* destroy, gboolean delete_backing, ProgressMonitor monitor, void* monitor_target, GeeList* not_removed) {
	gint _tmp0_;
	gboolean _tmp1_;
	gboolean removed;
	gint _tmp2_;
	gint count;
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
	g_return_if_fail (GEE_IS_LIST (destroy));
	g_return_if_fail ((not_removed == NULL) || GEE_IS_LIST (not_removed));
	_tmp0_ = gee_collection_get_size (GEE_COLLECTION (destroy));
	if (_tmp0_ == 0) {
		return;
	}
	_tmp1_ = data_set_remove_many (self->priv->tank, GEE_COLLECTION (destroy));
	removed = _tmp1_;
	g_assert (removed);
	source_holding_tank_notify_contents_altered (self, NULL, GEE_COLLECTION (destroy));
	_tmp2_ = gee_collection_get_size (GEE_COLLECTION (destroy));
	count = _tmp2_;
	{
		gint ctr;
		ctr = 0;
		{
			gboolean _tmp3_;
			_tmp3_ = TRUE;
			while (TRUE) {
				gpointer _tmp4_ = NULL;
				DataSource* source;
				gboolean _tmp5_;
				if (!_tmp3_) {
					ctr++;
				}
				_tmp3_ = FALSE;
				if (!(ctr < count)) {
					break;
				}
				_tmp4_ = gee_list_get (destroy, ctr);
				source = (DataSource*) _tmp4_;
				_tmp5_ = data_source_destroy_orphan (source, delete_backing);
				if (!_tmp5_) {
					if (NULL != not_removed) {
						gee_collection_add (GEE_COLLECTION (not_removed), source);
					}
				}
				if (monitor != NULL) {
					monitor ((guint64) (ctr + 1), (guint64) count, monitor_target);
				}
				_g_object_unref0 (source);
			}
		}
	}
}


static void source_holding_tank_on_source_destroyed (SourceHoldingTank* self, DataSource* source) {
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean removed;
	SingletonCollection* _tmp2_ = NULL;
	SingletonCollection* _tmp3_;
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
	g_return_if_fail (IS_DATA_SOURCE (source));
	_tmp0_ = data_set_contains (self->priv->tank, DATA_OBJECT (source));
	if (!_tmp0_) {
		return;
	}
	_tmp1_ = data_set_remove (self->priv->tank, DATA_OBJECT (source));
	removed = _tmp1_;
	g_assert (removed);
	_tmp2_ = singleton_collection_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, source);
	_tmp3_ = _tmp2_;
	source_holding_tank_notify_contents_altered (self, NULL, GEE_COLLECTION (_tmp3_));
	_g_object_unref0 (_tmp3_);
}


void source_holding_tank_internal_notify_altered (SourceHoldingTank* self, DataSource* source, Alteration* alteration) {
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean removed;
	gboolean _tmp3_;
	SingletonCollection* _tmp4_ = NULL;
	SingletonCollection* _tmp5_;
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
	g_return_if_fail (IS_DATA_SOURCE (source));
	g_return_if_fail (IS_ALTERATION (alteration));
	_tmp0_ = data_set_contains (self->priv->tank, DATA_OBJECT (source));
	g_assert (_tmp0_);
	_tmp1_ = self->priv->check_to_keep (source, alteration, self->priv->check_to_keep_target);
	if (_tmp1_) {
		return;
	}
	_tmp2_ = data_set_remove (self->priv->tank, DATA_OBJECT (source));
	removed = _tmp2_;
	g_assert (removed);
	_tmp3_ = data_collection_are_notifications_frozen (DATA_COLLECTION (self->priv->sources));
	if (_tmp3_) {
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (self->priv->relinks), source);
		return;
	}
	_tmp4_ = singleton_collection_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, source);
	_tmp5_ = _tmp4_;
	source_holding_tank_notify_contents_altered (self, NULL, GEE_COLLECTION (_tmp5_));
	_g_object_unref0 (_tmp5_);
	source_collection_relink (self->priv->sources, source);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void source_holding_tank_on_source_collection_thawed (SourceHoldingTank* self) {
	gint _tmp0_;
	GeeHashSet* _tmp1_;
	GeeHashSet* copy;
	GeeHashSet* _tmp2_ = NULL;
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
	_tmp0_ = gee_collection_get_size (GEE_COLLECTION (self->priv->relinks));
	if (_tmp0_ == 0) {
		return;
	}
	_tmp1_ = _g_object_ref0 (self->priv->relinks);
	copy = _tmp1_;
	_tmp2_ = gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	_g_object_unref0 (self->priv->relinks);
	self->priv->relinks = _tmp2_;
	source_holding_tank_notify_contents_altered (self, NULL, GEE_COLLECTION (copy));
	source_collection_relink_many (self->priv->sources, GEE_COLLECTION (copy));
	_g_object_unref0 (copy);
}


static void source_holding_tank_real_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed) {
	g_return_if_fail (IS_SOURCE_HOLDING_TANK (self));
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
}


static void value_source_holding_tank_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_source_holding_tank_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		source_holding_tank_unref (value->data[0].v_pointer);
	}
}


static void value_source_holding_tank_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = source_holding_tank_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_source_holding_tank_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_source_holding_tank_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		SourceHoldingTank* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = source_holding_tank_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_source_holding_tank_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	SourceHoldingTank** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = source_holding_tank_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_source_holding_tank (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecSourceHoldingTank* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_SOURCE_HOLDING_TANK), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_source_holding_tank (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_HOLDING_TANK), NULL);
	return value->data[0].v_pointer;
}


void value_set_source_holding_tank (GValue* value, gpointer v_object) {
	SourceHoldingTank* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_HOLDING_TANK));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_HOLDING_TANK));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		source_holding_tank_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_holding_tank_unref (old);
	}
}


void value_take_source_holding_tank (GValue* value, gpointer v_object) {
	SourceHoldingTank* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_SOURCE_HOLDING_TANK));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_SOURCE_HOLDING_TANK));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		source_holding_tank_unref (old);
	}
}


static void source_holding_tank_class_init (SourceHoldingTankClass * klass) {
	source_holding_tank_parent_class = g_type_class_peek_parent (klass);
	SOURCE_HOLDING_TANK_CLASS (klass)->finalize = source_holding_tank_finalize;
	g_type_class_add_private (klass, sizeof (SourceHoldingTankPrivate));
	SOURCE_HOLDING_TANK_CLASS (klass)->notify_contents_altered = source_holding_tank_real_notify_contents_altered;
	SOURCE_HOLDING_TANK_CLASS (klass)->contents_altered = source_holding_tank_real_contents_altered;
	g_signal_new ("contents_altered", TYPE_SOURCE_HOLDING_TANK, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (SourceHoldingTankClass, contents_altered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEE_TYPE_COLLECTION, GEE_TYPE_COLLECTION);
}


static void source_holding_tank_instance_init (SourceHoldingTank * self) {
	DataSet* _tmp0_ = NULL;
	GeeHashSet* _tmp1_ = NULL;
	GeeHashSet* _tmp2_ = NULL;
	self->priv = SOURCE_HOLDING_TANK_GET_PRIVATE (self);
	_tmp0_ = data_set_new ();
	self->priv->tank = _tmp0_;
	_tmp1_ = gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	self->priv->relinks = _tmp1_;
	_tmp2_ = gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
	self->priv->unlinking = _tmp2_;
	self->priv->ordinal = (gint64) 0;
	self->ref_count = 1;
}


static void source_holding_tank_finalize (SourceHoldingTank* obj) {
	SourceHoldingTank * self;
	guint _tmp0_;
	guint _tmp1_;
	self = SOURCE_HOLDING_TANK (obj);
	g_signal_parse_name ("item-destroyed", TYPE_SOURCE_COLLECTION, &_tmp0_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (self->priv->sources, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _source_holding_tank_on_source_destroyed_source_collection_item_destroyed, self);
	g_signal_parse_name ("thawed", TYPE_DATA_COLLECTION, &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (DATA_COLLECTION (self->priv->sources), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _source_holding_tank_on_source_collection_thawed_data_collection_thawed, self);
	_data_collection_unref0 (self->priv->sources);
	(self->priv->check_to_keep_target_destroy_notify == NULL) ? NULL : (self->priv->check_to_keep_target_destroy_notify (self->priv->check_to_keep_target), NULL);
	self->priv->check_to_keep = NULL;
	self->priv->check_to_keep_target = NULL;
	self->priv->check_to_keep_target_destroy_notify = NULL;
	_data_set_unref0 (self->priv->tank);
	_g_object_unref0 (self->priv->relinks);
	_g_object_unref0 (self->priv->unlinking);
}


GType source_holding_tank_get_type (void) {
	static volatile gsize source_holding_tank_type_id__volatile = 0;
	if (g_once_init_enter (&source_holding_tank_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_source_holding_tank_init, value_source_holding_tank_free_value, value_source_holding_tank_copy_value, value_source_holding_tank_peek_pointer, "p", value_source_holding_tank_collect_value, "p", value_source_holding_tank_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SourceHoldingTankClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) source_holding_tank_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SourceHoldingTank), 0, (GInstanceInitFunc) source_holding_tank_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType source_holding_tank_type_id;
		source_holding_tank_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SourceHoldingTank", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&source_holding_tank_type_id__volatile, source_holding_tank_type_id);
	}
	return source_holding_tank_type_id__volatile;
}


gpointer source_holding_tank_ref (gpointer instance) {
	SourceHoldingTank* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void source_holding_tank_unref (gpointer instance) {
	SourceHoldingTank* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		SOURCE_HOLDING_TANK_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



