/* Db.c generated by valac 0.12.1, the Vala compiler
 * generated from Db.vala, do not modify */

/* Copyright 2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define _g_free0(var) (var = (g_free (var), NULL))

#define DB_TYPE_VERIFY_RESULT (db_verify_result_get_type ())

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_VERSION_TABLE (version_table_get_type ())
#define VERSION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VERSION_TABLE, VersionTable))
#define VERSION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VERSION_TABLE, VersionTableClass))
#define IS_VERSION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VERSION_TABLE))
#define IS_VERSION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VERSION_TABLE))
#define VERSION_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VERSION_TABLE, VersionTableClass))

typedef struct _VersionTable VersionTable;
typedef struct _VersionTableClass VersionTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))

typedef enum  {
	DB_VERIFY_RESULT_OK,
	DB_VERIFY_RESULT_FUTURE_VERSION,
	DB_VERIFY_RESULT_UPGRADE_ERROR,
	DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE
} DbVerifyResult;


extern gchar* db_filename;
gchar* db_filename = NULL;

#define DB_IN_MEMORY_NAME ":memory:"
void db_preconfigure (GFile* db_file);
void db_init (GError** error);
void database_table_init (const gchar* filename);
void db_terminate (void);
void database_table_terminate (void);
GType db_verify_result_get_type (void) G_GNUC_CONST;
DbVerifyResult db_verify_database (gchar** app_version, gint* schema_version);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType version_table_get_type (void) G_GNUC_CONST;
VersionTable* version_table_get_instance (void);
gint version_table_get_version (VersionTable* self, gchar** app_version);
#define DATABASE_TABLE_SCHEMA_VERSION 12
#define RESOURCES_APP_VERSION _VERSION
void version_table_set_version (VersionTable* self, gint version, const gchar* app_version, const gchar* user_data);
DbVerifyResult db_upgrade_database (gint version);
gboolean database_table_has_column (const gchar* table_name, const gchar* column_name);
gboolean database_table_add_column (const gchar* table_name, const gchar* column_name, const gchar* column_constraints);
gboolean database_table_has_table (const gchar* table_name);
gboolean database_table_ensure_column (const gchar* table_name, const gchar* column_name, const gchar* column_constraints, const gchar* upgrade_msg);
void version_table_update_version (VersionTable* self, gint version, const gchar* app_version);


void db_preconfigure (GFile* db_file) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp3_;
	g_return_if_fail ((db_file == NULL) || G_IS_FILE (db_file));
	if (db_file != NULL) {
		gchar* _tmp1_ = NULL;
		_tmp1_ = g_file_get_path (db_file);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp1_;
	} else {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (DB_IN_MEMORY_NAME);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp2_;
	}
	_tmp3_ = g_strdup (_tmp0_);
	_g_free0 (db_filename);
	db_filename = _tmp3_;
	_g_free0 (_tmp0_);
}


void db_init (GError** error) {
	g_assert (db_filename != NULL);
	database_table_init (db_filename);
}


void db_terminate (void) {
	database_table_terminate ();
}


GType db_verify_result_get_type (void) {
	static volatile gsize db_verify_result_type_id__volatile = 0;
	if (g_once_init_enter (&db_verify_result_type_id__volatile)) {
		static const GEnumValue values[] = {{DB_VERIFY_RESULT_OK, "DB_VERIFY_RESULT_OK", "ok"}, {DB_VERIFY_RESULT_FUTURE_VERSION, "DB_VERIFY_RESULT_FUTURE_VERSION", "future-version"}, {DB_VERIFY_RESULT_UPGRADE_ERROR, "DB_VERIFY_RESULT_UPGRADE_ERROR", "upgrade-error"}, {DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE, "DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE", "no-upgrade-available"}, {0, NULL, NULL}};
		GType db_verify_result_type_id;
		db_verify_result_type_id = g_enum_register_static ("DbVerifyResult", values);
		g_once_init_leave (&db_verify_result_type_id__volatile, db_verify_result_type_id);
	}
	return db_verify_result_type_id__volatile;
}


DbVerifyResult db_verify_database (gchar** app_version, gint* schema_version) {
	gchar* _app_version = NULL;
	gint _schema_version = 0;
	DbVerifyResult result = 0;
	VersionTable* _tmp0_ = NULL;
	VersionTable* version_table;
	gchar* _tmp1_ = NULL;
	gint _tmp2_;
	_tmp0_ = version_table_get_instance ();
	version_table = _tmp0_;
	_tmp2_ = version_table_get_version (version_table, &_tmp1_);
	_g_free0 (_app_version);
	_app_version = _tmp1_;
	_schema_version = _tmp2_;
	if (_schema_version >= 0) {
		g_debug ("Db.vala:40: Database schema version %d created by app version %s", _schema_version, _app_version);
	}
	if (_schema_version == (-1)) {
		gchar* _tmp3_;
		g_debug ("Db.vala:44: Creating database schema version %d for app version %s", DATABASE_TABLE_SCHEMA_VERSION, RESOURCES_APP_VERSION);
		version_table_set_version (version_table, DATABASE_TABLE_SCHEMA_VERSION, RESOURCES_APP_VERSION, NULL);
		_tmp3_ = g_strdup (RESOURCES_APP_VERSION);
		_g_free0 (_app_version);
		_app_version = _tmp3_;
		_schema_version = DATABASE_TABLE_SCHEMA_VERSION;
	} else {
		if (_schema_version > DATABASE_TABLE_SCHEMA_VERSION) {
			result = DB_VERIFY_RESULT_FUTURE_VERSION;
			_database_table_unref0 (version_table);
			if (app_version) {
				*app_version = _app_version;
			} else {
				_g_free0 (_app_version);
			}
			if (schema_version) {
				*schema_version = _schema_version;
			}
			return result;
		} else {
			if (_schema_version < DATABASE_TABLE_SCHEMA_VERSION) {
				DbVerifyResult _tmp4_;
				DbVerifyResult _result_;
				_tmp4_ = db_upgrade_database (_schema_version);
				_result_ = _tmp4_;
				if (_result_ != DB_VERIFY_RESULT_OK) {
					result = _result_;
					_database_table_unref0 (version_table);
					if (app_version) {
						*app_version = _app_version;
					} else {
						_g_free0 (_app_version);
					}
					if (schema_version) {
						*schema_version = _schema_version;
					}
					return result;
				}
			}
		}
	}
	result = DB_VERIFY_RESULT_OK;
	_database_table_unref0 (version_table);
	if (app_version) {
		*app_version = _app_version;
	} else {
		_g_free0 (_app_version);
	}
	if (schema_version) {
		*schema_version = _schema_version;
	}
	return result;
}


DbVerifyResult db_upgrade_database (gint version) {
	DbVerifyResult result = 0;
	gboolean _tmp0_;
	gboolean _tmp2_;
	gboolean _tmp4_;
	gboolean _tmp6_;
	gboolean _tmp8_;
	gboolean _tmp10_;
	gboolean _tmp12_;
	gboolean _tmp14_;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_;
	gboolean _tmp20_;
	gboolean _tmp22_;
	VersionTable* _tmp23_ = NULL;
	VersionTable* _tmp24_;
	g_assert (version < DATABASE_TABLE_SCHEMA_VERSION);
	if (version == 1) {
		result = DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE;
		return result;
	}
	g_message ("Db.vala:69: Upgrading database from schema version %d to %d", version, DATABASE_TABLE_SCHEMA_VERSION);
	_tmp0_ = database_table_has_column ("PhotoTable", "flags");
	if (!_tmp0_) {
		gboolean _tmp1_;
		g_message ("Db.vala:82: upgrade_database: adding flags column to PhotoTable");
		_tmp1_ = database_table_add_column ("PhotoTable", "flags", "INTEGER DEFAULT 0");
		if (!_tmp1_) {
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
			return result;
		}
	}
	version = 3;
	_tmp2_ = database_table_has_column ("PhotoTable", "file_format");
	if (!_tmp2_) {
		gboolean _tmp3_;
		g_message ("Db.vala:99: upgrade_database: adding file_format column to PhotoTable");
		_tmp3_ = database_table_add_column ("PhotoTable", "file_format", "INTEGER DEFAULT 0");
		if (!_tmp3_) {
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
			return result;
		}
	}
	version = 4;
	_tmp4_ = database_table_has_column ("PhotoTable", "title");
	if (!_tmp4_) {
		gboolean _tmp5_;
		g_message ("Db.vala:112: upgrade_database: adding title column to PhotoTable");
		_tmp5_ = database_table_add_column ("PhotoTable", "title", "TEXT");
		if (!_tmp5_) {
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
			return result;
		}
	}
	version = 5;
	_tmp6_ = database_table_has_column ("PhotoTable", "backlinks");
	if (!_tmp6_) {
		gboolean _tmp7_;
		g_message ("Db.vala:125: upgrade_database: adding backlinks column to PhotoTable");
		_tmp7_ = database_table_add_column ("PhotoTable", "backlinks", "TEXT");
		if (!_tmp7_) {
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
			return result;
		}
	}
	version = 6;
	_tmp8_ = database_table_has_column ("PhotoTable", "time_reimported");
	if (!_tmp8_) {
		gboolean _tmp9_;
		g_message ("Db.vala:145: upgrade_database: adding time_reimported column to PhotoT" \
"able");
		_tmp9_ = database_table_add_column ("PhotoTable", "time_reimported", "INTEGER");
		if (!_tmp9_) {
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
			return result;
		}
	}
	_tmp10_ = database_table_has_column ("PhotoTable", "editable_id");
	if (!_tmp10_) {
		gboolean _tmp11_;
		g_message ("Db.vala:151: upgrade_database: adding editable_id column to PhotoTable");
		_tmp11_ = database_table_add_column ("PhotoTable", "editable_id", "INTEGER DEFAULT -1");
		if (!_tmp11_) {
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
			return result;
		}
	}
	version = 7;
	_tmp12_ = database_table_has_column ("PhotoTable", "rating");
	if (!_tmp12_) {
		gboolean _tmp13_;
		g_message ("Db.vala:169: upgrade_database: adding rating column to PhotoTable");
		_tmp13_ = database_table_add_column ("PhotoTable", "rating", "INTEGER DEFAULT 0");
		if (!_tmp13_) {
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
			return result;
		}
	}
	_tmp14_ = database_table_has_column ("PhotoTable", "metadata_dirty");
	if (!_tmp14_) {
		gboolean _tmp15_;
		g_message ("Db.vala:181: upgrade_database: adding metadata_dirty column to PhotoTa" \
"ble");
		_tmp15_ = database_table_add_column ("PhotoTable", "metadata_dirty", "INTEGER DEFAULT 1");
		if (!_tmp15_) {
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
			return result;
		}
	}
	version = 9;
	_tmp17_ = database_table_has_table ("VideoTable");
	if (_tmp17_) {
		gboolean _tmp18_;
		_tmp18_ = database_table_has_column ("VideoTable", "flags");
		_tmp16_ = !_tmp18_;
	} else {
		_tmp16_ = FALSE;
	}
	if (_tmp16_) {
		gboolean _tmp19_;
		g_message ("Db.vala:194: upgrade_database: adding flags column to VideoTable");
		_tmp19_ = database_table_add_column ("VideoTable", "flags", "INTEGER DEFAULT 0");
		if (!_tmp19_) {
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
			return result;
		}
	}
	version = 10;
	_tmp20_ = database_table_has_column ("EventTable", "primary_source_id");
	if (!_tmp20_) {
		gboolean _tmp21_;
		g_message ("Db.vala:207: upgrade_database: adding primary_source_id column to Even" \
"tTable");
		_tmp21_ = database_table_add_column ("EventTable", "primary_source_id", "INTEGER DEFAULT 0");
		if (!_tmp21_) {
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
			return result;
		}
	}
	version = 11;
	_tmp22_ = database_table_ensure_column ("TombstoneTable", "reason", "INTEGER DEFAULT 0", "upgrade_database: adding reason column to TombstoneTable");
	if (!_tmp22_) {
		result = DB_VERIFY_RESULT_UPGRADE_ERROR;
		return result;
	}
	version = 12;
	g_assert (version == DATABASE_TABLE_SCHEMA_VERSION);
	_tmp23_ = version_table_get_instance ();
	_tmp24_ = _tmp23_;
	version_table_update_version (_tmp24_, version, RESOURCES_APP_VERSION);
	_database_table_unref0 (_tmp24_);
	g_message ("Db.vala:229: Database upgrade to schema version %d successful", version);
	result = DB_VERIFY_RESULT_OK;
	return result;
}



