/* TagTable.c generated by valac 0.12.1, the Vala compiler
 * generated from TagTable.vala, do not modify */

/* Copyright 2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <stdlib.h>
#include <gee.h>
#include <time.h>
#include <sqlite3.h>


#define TYPE_TAG_ID (tag_id_get_type ())
typedef struct _TagID TagID;

#define TYPE_TAG_ROW (tag_row_get_type ())
typedef struct _TagRow TagRow;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_TAG_TABLE (tag_table_get_type ())
#define TAG_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_TABLE, TagTable))
#define TAG_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_TABLE, TagTableClass))
#define IS_TAG_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_TABLE))
#define IS_TAG_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_TABLE))
#define TAG_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_TABLE, TagTableClass))

typedef struct _TagTable TagTable;
typedef struct _TagTableClass TagTableClass;
typedef struct _TagTablePrivate TagTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;

struct _TagID {
	gint64 id;
};

struct _TagRow {
	TagID tag_id;
	gchar* name;
	GeeSet* source_id_list;
	time_t time_created;
};

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _TagTable {
	DatabaseTable parent_instance;
	TagTablePrivate * priv;
};

struct _TagTableClass {
	DatabaseTableClass parent_class;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _PhotoID {
	gint64 id;
};


static gpointer tag_table_parent_class = NULL;
static TagTable* tag_table_instance;
static TagTable* tag_table_instance = NULL;
extern sqlite3* database_table_db;

GType tag_id_get_type (void) G_GNUC_CONST;
TagID* tag_id_dup (const TagID* self);
void tag_id_free (TagID* self);
#define TAG_ID_INVALID ((gint64) (-1))
void tag_id_init (TagID *self, gint64 id);
gboolean tag_id_is_invalid (TagID *self);
gboolean tag_id_is_valid (TagID *self);
GType tag_row_get_type (void) G_GNUC_CONST;
TagRow* tag_row_dup (const TagRow* self);
void tag_row_free (TagRow* self);
void tag_row_copy (const TagRow* self, TagRow* dest);
void tag_row_destroy (TagRow* self);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType tag_table_get_type (void) G_GNUC_CONST;
enum  {
	TAG_TABLE_DUMMY_PROPERTY
};
static TagTable* tag_table_new (void);
static TagTable* tag_table_construct (GType object_type);
DatabaseTable* database_table_construct (GType object_type);
void database_table_set_table_name (DatabaseTable* self, const gchar* table_name);
void database_table_fatal (const gchar* op, gint res);
TagTable* tag_table_get_instance (void);
GQuark database_error_quark (void);
void tag_table_add (TagTable* self, const gchar* name, TagRow* result, GError** error);
gulong now_sec (void);
void database_table_throw_error (const gchar* method, gint res, GError** error);
void tag_table_create_from_row (TagTable* self, TagRow* row, TagID* result, GError** error);
static gchar* tag_table_serialize_source_ids (TagTable* self, GeeCollection* source_ids);
void tag_table_remove (TagTable* self, TagID* tag_id, GError** error);
void database_table_delete_by_id (DatabaseTable* self, gint64 id, GError** error);
gchar* tag_table_get_name (TagTable* self, TagID* tag_id, GError** error);
gboolean database_table_select_by_id (DatabaseTable* self, gint64 id, const gchar* columns, sqlite3_stmt** stmt);
TagRow* tag_table_get_row (TagTable* self, TagID* tag_id, GError** error);
static GeeSet* tag_table_unserialize_source_ids (TagTable* self, const gchar* text_list);
GeeList* tag_table_get_all_rows (TagTable* self, GError** error);
void tag_table_rename (TagTable* self, TagID* tag_id, const gchar* new_name, GError** error);
void database_table_update_text_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, const gchar* text, GError** error);
void tag_table_set_tagged_sources (TagTable* self, TagID* tag_id, GeeCollection* source_ids, GError** error);
gboolean is_string_empty (const gchar* s);
GType photo_id_get_type (void) G_GNUC_CONST;
PhotoID* photo_id_dup (const PhotoID* self);
void photo_id_free (PhotoID* self);
gchar* photo_id_upgrade_photo_id_to_source_id (PhotoID* photo_id);
gint64 parse_int64 (const gchar* str, gint num_base);
void photo_id_init (PhotoID *self, gint64 id);
static void tag_table_finalize (DatabaseTable* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


void tag_id_init (TagID *self, gint64 id) {
	memset (self, 0, sizeof (TagID));
	(*self).id = id;
}


gboolean tag_id_is_invalid (TagID *self) {
	gboolean result = FALSE;
	result = (*self).id == TAG_ID_INVALID;
	return result;
}


gboolean tag_id_is_valid (TagID *self) {
	gboolean result = FALSE;
	result = (*self).id != TAG_ID_INVALID;
	return result;
}


TagID* tag_id_dup (const TagID* self) {
	TagID* dup;
	dup = g_new0 (TagID, 1);
	memcpy (dup, self, sizeof (TagID));
	return dup;
}


void tag_id_free (TagID* self) {
	g_free (self);
}


GType tag_id_get_type (void) {
	static volatile gsize tag_id_type_id__volatile = 0;
	if (g_once_init_enter (&tag_id_type_id__volatile)) {
		GType tag_id_type_id;
		tag_id_type_id = g_boxed_type_register_static ("TagID", (GBoxedCopyFunc) tag_id_dup, (GBoxedFreeFunc) tag_id_free);
		g_once_init_leave (&tag_id_type_id__volatile, tag_id_type_id);
	}
	return tag_id_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void tag_row_copy (const TagRow* self, TagRow* dest) {
	dest->tag_id = self->tag_id;
	dest->name = g_strdup (self->name);
	dest->source_id_list = _g_object_ref0 (self->source_id_list);
	dest->time_created = self->time_created;
}


void tag_row_destroy (TagRow* self) {
	_g_free0 ((*self).name);
	_g_object_unref0 ((*self).source_id_list);
}


TagRow* tag_row_dup (const TagRow* self) {
	TagRow* dup;
	dup = g_new0 (TagRow, 1);
	tag_row_copy (self, dup);
	return dup;
}


void tag_row_free (TagRow* self) {
	tag_row_destroy (self);
	g_free (self);
}


GType tag_row_get_type (void) {
	static volatile gsize tag_row_type_id__volatile = 0;
	if (g_once_init_enter (&tag_row_type_id__volatile)) {
		GType tag_row_type_id;
		tag_row_type_id = g_boxed_type_register_static ("TagRow", (GBoxedCopyFunc) tag_row_dup, (GBoxedFreeFunc) tag_row_free);
		g_once_init_leave (&tag_row_type_id__volatile, tag_row_type_id);
	}
	return tag_row_type_id__volatile;
}


static TagTable* tag_table_construct (GType object_type) {
	TagTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gint _tmp2_;
	self = (TagTable*) database_table_construct (object_type);
	database_table_set_table_name (DATABASE_TABLE (self), "TagTable");
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "CREATE TABLE IF NOT EXISTS " "TagTable " "(" "id INTEGER PRIMARY KEY, " "name TEXT UNIQUE NOT NULL, " "photo_id_list TEXT, " "time_created INTEGER" ")", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = sqlite3_step (stmt);
	res = _tmp2_;
	if (res != SQLITE_DONE) {
		database_table_fatal ("create TagTable", res);
	}
	_sqlite3_finalize0 (stmt);
	return self;
}


static TagTable* tag_table_new (void) {
	return tag_table_construct (TYPE_TAG_TABLE);
}


static gpointer _database_table_ref0 (gpointer self) {
	return self ? database_table_ref (self) : NULL;
}


TagTable* tag_table_get_instance (void) {
	TagTable* result = NULL;
	TagTable* _tmp1_;
	if (tag_table_instance == NULL) {
		TagTable* _tmp0_ = NULL;
		_tmp0_ = tag_table_new ();
		_database_table_unref0 (tag_table_instance);
		tag_table_instance = _tmp0_;
	}
	_tmp1_ = _database_table_ref0 (tag_table_instance);
	result = _tmp1_;
	return result;
}


void tag_table_add (TagTable* self, const gchar* name, TagRow* result, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gulong _tmp2_;
	time_t time_created;
	gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	TagRow row = {0};
	gint64 _tmp7_;
	TagID _tmp8_ = {0};
	TagID _tmp9_ = {0};
	gchar* _tmp10_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_TAG_TABLE (self));
	g_return_if_fail (name != NULL);
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "INSERT INTO TagTable (name, time_created) VALUES (?, ?)", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = now_sec ();
	time_created = (time_t) _tmp2_;
	_tmp3_ = g_strdup (name);
	_tmp4_ = sqlite3_bind_text (stmt, 1, _tmp3_, -1, g_free);
	res = _tmp4_;
	g_assert (res == SQLITE_OK);
	_tmp5_ = sqlite3_bind_int64 (stmt, 2, (gint64) time_created);
	res = _tmp5_;
	g_assert (res == SQLITE_OK);
	_tmp6_ = sqlite3_step (stmt);
	res = _tmp6_;
	if (res != SQLITE_DONE) {
		database_table_throw_error ("TagTable.add", res, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_sqlite3_finalize0 (stmt);
				return;
			} else {
				_sqlite3_finalize0 (stmt);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	memset (&row, 0, sizeof (TagRow));
	_tmp7_ = sqlite3_last_insert_rowid (database_table_db);
	tag_id_init (&_tmp8_, _tmp7_);
	_tmp9_ = _tmp8_;
	row.tag_id = _tmp9_;
	_tmp10_ = g_strdup (name);
	_g_free0 (row.name);
	row.name = _tmp10_;
	_g_object_unref0 (row.source_id_list);
	row.source_id_list = NULL;
	row.time_created = time_created;
	*result = row;
	_sqlite3_finalize0 (stmt);
	return;
}


void tag_table_create_from_row (TagTable* self, TagRow* row, TagID* result, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gchar* _tmp2_;
	gint _tmp3_;
	gchar* _tmp4_ = NULL;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint64 _tmp8_;
	TagID _tmp9_ = {0};
	TagID _tmp10_ = {0};
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_TAG_TABLE (self));
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "INSERT INTO TagTable (name, photo_id_list, time_created) VALUES (?, ?," \
" ?)", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = g_strdup ((*row).name);
	_tmp3_ = sqlite3_bind_text (stmt, 1, _tmp2_, -1, g_free);
	res = _tmp3_;
	g_assert (res == SQLITE_OK);
	_tmp4_ = tag_table_serialize_source_ids (self, GEE_COLLECTION ((*row).source_id_list));
	_tmp5_ = sqlite3_bind_text (stmt, 2, _tmp4_, -1, g_free);
	res = _tmp5_;
	g_assert (res == SQLITE_OK);
	_tmp6_ = sqlite3_bind_int64 (stmt, 3, (gint64) (*row).time_created);
	res = _tmp6_;
	g_assert (res == SQLITE_OK);
	_tmp7_ = sqlite3_step (stmt);
	res = _tmp7_;
	if (res != SQLITE_DONE) {
		database_table_throw_error ("TagTable.create_from_row", res, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_sqlite3_finalize0 (stmt);
				return;
			} else {
				_sqlite3_finalize0 (stmt);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	_tmp8_ = sqlite3_last_insert_rowid (database_table_db);
	tag_id_init (&_tmp9_, _tmp8_);
	_tmp10_ = _tmp9_;
	*result = _tmp10_;
	_sqlite3_finalize0 (stmt);
	return;
}


void tag_table_remove (TagTable* self, TagID* tag_id, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_TAG_TABLE (self));
	database_table_delete_by_id (DATABASE_TABLE (self), (*tag_id).id, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


gchar* tag_table_get_name (TagTable* self, TagID* tag_id, GError** error) {
	gchar* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gboolean _tmp1_;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	g_return_val_if_fail (IS_TAG_TABLE (self), NULL);
	_tmp1_ = database_table_select_by_id (DATABASE_TABLE (self), (*tag_id).id, "name", &_tmp0_);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	if (!_tmp1_) {
		result = NULL;
		_sqlite3_finalize0 (stmt);
		return result;
	}
	_tmp2_ = sqlite3_column_text (stmt, 0);
	_tmp3_ = g_strdup (_tmp2_);
	result = _tmp3_;
	_sqlite3_finalize0 (stmt);
	return result;
}


static gpointer _tag_row_dup0 (gpointer self) {
	return self ? tag_row_dup (self) : NULL;
}


TagRow* tag_table_get_row (TagTable* self, TagID* tag_id, GError** error) {
	TagRow* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gint _tmp2_;
	gint _tmp3_;
	TagRow row = {0};
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	const gchar* _tmp6_ = NULL;
	GeeSet* _tmp7_ = NULL;
	gint64 _tmp8_;
	TagRow _tmp9_;
	TagRow* _tmp10_;
	TagRow* _tmp11_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_TAG_TABLE (self), NULL);
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "SELECT name, photo_id_list, time_created FROM TagTable WHERE id=?", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = sqlite3_bind_int64 (stmt, 1, (*tag_id).id);
	res = _tmp2_;
	g_assert (res == SQLITE_OK);
	_tmp3_ = sqlite3_step (stmt);
	res = _tmp3_;
	if (res == SQLITE_DONE) {
		result = NULL;
		_sqlite3_finalize0 (stmt);
		return result;
	} else {
		if (res != SQLITE_ROW) {
			database_table_throw_error ("TagTable.get_row", res, &_inner_error_);
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == DATABASE_ERROR) {
					g_propagate_error (error, _inner_error_);
					_sqlite3_finalize0 (stmt);
					return NULL;
				} else {
					_sqlite3_finalize0 (stmt);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
		}
	}
	memset (&row, 0, sizeof (TagRow));
	row.tag_id = *tag_id;
	_tmp4_ = sqlite3_column_text (stmt, 0);
	_tmp5_ = g_strdup (_tmp4_);
	_g_free0 (row.name);
	row.name = _tmp5_;
	_tmp6_ = sqlite3_column_text (stmt, 1);
	_tmp7_ = tag_table_unserialize_source_ids (self, _tmp6_);
	_g_object_unref0 (row.source_id_list);
	row.source_id_list = _tmp7_;
	_tmp8_ = sqlite3_column_int64 (stmt, 2);
	row.time_created = (time_t) _tmp8_;
	_tmp9_ = row;
	_tmp10_ = _tag_row_dup0 (&_tmp9_);
	_tmp11_ = _tmp10_;
	tag_row_destroy (&_tmp9_);
	result = _tmp11_;
	_sqlite3_finalize0 (stmt);
	return result;
}


GeeList* tag_table_get_all_rows (TagTable* self, GError** error) {
	GeeList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	GeeArrayList* _tmp2_ = NULL;
	GeeList* rows;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_TAG_TABLE (self), NULL);
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "SELECT id, name, photo_id_list, time_created FROM TagTable", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = gee_array_list_new (TYPE_TAG_ROW, (GBoxedCopyFunc) tag_row_dup, tag_row_free, NULL);
	rows = GEE_LIST (_tmp2_);
	{
		gboolean _tmp3_;
		_tmp3_ = TRUE;
		while (TRUE) {
			gint _tmp4_;
			TagRow row = {0};
			gint64 _tmp5_;
			TagID _tmp6_ = {0};
			TagID _tmp7_ = {0};
			const gchar* _tmp8_ = NULL;
			gchar* _tmp9_;
			const gchar* _tmp10_ = NULL;
			GeeSet* _tmp11_ = NULL;
			gint64 _tmp12_;
			if (!_tmp3_) {
			}
			_tmp3_ = FALSE;
			_tmp4_ = sqlite3_step (stmt);
			res = _tmp4_;
			if (res == SQLITE_DONE) {
				break;
			} else {
				if (res != SQLITE_ROW) {
					database_table_throw_error ("TagTable.get_all_rows", res, &_inner_error_);
					if (_inner_error_ != NULL) {
						if (_inner_error_->domain == DATABASE_ERROR) {
							g_propagate_error (error, _inner_error_);
							_g_object_unref0 (rows);
							_sqlite3_finalize0 (stmt);
							return NULL;
						} else {
							_g_object_unref0 (rows);
							_sqlite3_finalize0 (stmt);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return NULL;
						}
					}
				}
			}
			memset (&row, 0, sizeof (TagRow));
			_tmp5_ = sqlite3_column_int64 (stmt, 0);
			tag_id_init (&_tmp6_, _tmp5_);
			_tmp7_ = _tmp6_;
			row.tag_id = _tmp7_;
			_tmp8_ = sqlite3_column_text (stmt, 1);
			_tmp9_ = g_strdup (_tmp8_);
			_g_free0 (row.name);
			row.name = _tmp9_;
			_tmp10_ = sqlite3_column_text (stmt, 2);
			_tmp11_ = tag_table_unserialize_source_ids (self, _tmp10_);
			_g_object_unref0 (row.source_id_list);
			row.source_id_list = _tmp11_;
			_tmp12_ = sqlite3_column_int64 (stmt, 3);
			row.time_created = (time_t) _tmp12_;
			gee_collection_add (GEE_COLLECTION (rows), &row);
			tag_row_destroy (&row);
		}
	}
	result = rows;
	_sqlite3_finalize0 (stmt);
	return result;
}


void tag_table_rename (TagTable* self, TagID* tag_id, const gchar* new_name, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_TAG_TABLE (self));
	g_return_if_fail (new_name != NULL);
	database_table_update_text_by_id_2 (DATABASE_TABLE (self), (*tag_id).id, "name", new_name, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


void tag_table_set_tagged_sources (TagTable* self, TagID* tag_id, GeeCollection* source_ids, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gchar* _tmp2_ = NULL;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_TAG_TABLE (self));
	g_return_if_fail (GEE_IS_COLLECTION (source_ids));
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "UPDATE TagTable SET photo_id_list=? WHERE id=?", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = tag_table_serialize_source_ids (self, source_ids);
	_tmp3_ = sqlite3_bind_text (stmt, 1, _tmp2_, -1, g_free);
	res = _tmp3_;
	g_assert (res == SQLITE_OK);
	_tmp4_ = sqlite3_bind_int64 (stmt, 2, (*tag_id).id);
	res = _tmp4_;
	g_assert (res == SQLITE_OK);
	_tmp5_ = sqlite3_step (stmt);
	res = _tmp5_;
	if (res != SQLITE_DONE) {
		database_table_throw_error ("TagTable.set_tagged_photos", res, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_sqlite3_finalize0 (stmt);
				return;
			} else {
				_sqlite3_finalize0 (stmt);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	_sqlite3_finalize0 (stmt);
}


static gchar* tag_table_serialize_source_ids (TagTable* self, GeeCollection* source_ids) {
	gchar* result = NULL;
	GString* _tmp0_ = NULL;
	GString* _result_;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	g_return_val_if_fail (IS_TAG_TABLE (self), NULL);
	g_return_val_if_fail ((source_ids == NULL) || GEE_IS_COLLECTION (source_ids), NULL);
	if (source_ids == NULL) {
		result = NULL;
		return result;
	}
	_tmp0_ = g_string_new ("");
	_result_ = _tmp0_;
	{
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _source_id_it;
		_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (source_ids));
		_source_id_it = _tmp1_;
		while (TRUE) {
			gboolean _tmp2_;
			gpointer _tmp3_ = NULL;
			gchar* source_id;
			_tmp2_ = gee_iterator_next (_source_id_it);
			if (!_tmp2_) {
				break;
			}
			_tmp3_ = gee_iterator_get (_source_id_it);
			source_id = (gchar*) _tmp3_;
			g_string_append (_result_, source_id);
			g_string_append (_result_, ",");
			_g_free0 (source_id);
		}
		_g_object_unref0 (_source_id_it);
	}
	if (_result_->len != 0) {
		_tmp4_ = _result_->str;
	} else {
		_tmp4_ = NULL;
	}
	_tmp5_ = g_strdup (_tmp4_);
	result = _tmp5_;
	_g_string_free0 (_result_);
	return result;
}


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	result = ((gchar*) self)[index];
	return result;
}


static GeeSet* tag_table_unserialize_source_ids (TagTable* self, const gchar* text_list) {
	GeeSet* result = NULL;
	GeeHashSet* _tmp0_ = NULL;
	GeeSet* _result_;
	gchar** _tmp1_;
	gchar** _tmp2_ = NULL;
	gchar** split;
	gint split_length1;
	gint _split_size_;
	g_return_val_if_fail (IS_TAG_TABLE (self), NULL);
	_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL);
	_result_ = GEE_SET (_tmp0_);
	if (text_list == NULL) {
		result = _result_;
		return result;
	}
	_tmp2_ = _tmp1_ = g_strsplit (text_list, ",", 0);
	split = _tmp2_;
	split_length1 = _vala_array_length (_tmp1_);
	_split_size_ = _vala_array_length (_tmp1_);
	{
		gchar** token_collection;
		int token_collection_length1;
		int token_it;
		token_collection = split;
		token_collection_length1 = split_length1;
		for (token_it = 0; token_it < split_length1; token_it = token_it + 1) {
			gchar* _tmp3_;
			gchar* token;
			_tmp3_ = g_strdup (token_collection[token_it]);
			token = _tmp3_;
			{
				gboolean _tmp4_;
				gchar _tmp5_;
				gboolean _tmp6_;
				_tmp4_ = is_string_empty (token);
				if (_tmp4_) {
					_g_free0 (token);
					continue;
				}
				_tmp5_ = string_get (token, (glong) 0);
				_tmp6_ = g_ascii_isdigit (_tmp5_);
				if (_tmp6_) {
					gint64 _tmp7_;
					PhotoID _tmp8_ = {0};
					PhotoID _tmp9_ = {0};
					gchar* _tmp10_ = NULL;
					gchar* _tmp11_;
					_tmp7_ = parse_int64 (token, 10);
					photo_id_init (&_tmp8_, _tmp7_);
					_tmp9_ = _tmp8_;
					_tmp10_ = photo_id_upgrade_photo_id_to_source_id (&_tmp9_);
					_tmp11_ = _tmp10_;
					gee_collection_add (GEE_COLLECTION (_result_), _tmp11_);
					_g_free0 (_tmp11_);
				} else {
					gchar _tmp12_;
					gboolean _tmp13_;
					_tmp12_ = string_get (token, (glong) 0);
					_tmp13_ = g_ascii_isalpha (_tmp12_);
					if (_tmp13_) {
						gee_collection_add (GEE_COLLECTION (_result_), token);
					}
				}
				_g_free0 (token);
			}
		}
	}
	result = _result_;
	split = (_vala_array_free (split, split_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


static void tag_table_class_init (TagTableClass * klass) {
	tag_table_parent_class = g_type_class_peek_parent (klass);
	DATABASE_TABLE_CLASS (klass)->finalize = tag_table_finalize;
}


static void tag_table_instance_init (TagTable * self) {
}


static void tag_table_finalize (DatabaseTable* obj) {
	TagTable * self;
	self = TAG_TABLE (obj);
	DATABASE_TABLE_CLASS (tag_table_parent_class)->finalize (obj);
}


GType tag_table_get_type (void) {
	static volatile gsize tag_table_type_id__volatile = 0;
	if (g_once_init_enter (&tag_table_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TagTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tag_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TagTable), 0, (GInstanceInitFunc) tag_table_instance_init, NULL };
		GType tag_table_type_id;
		tag_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "TagTable", &g_define_type_info, 0);
		g_once_init_leave (&tag_table_type_id__volatile, tag_table_type_id);
	}
	return tag_table_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



