/* VideoTable.c generated by valac 0.12.1, the Vala compiler
 * generated from VideoTable.vala, do not modify */

/* Copyright 2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <float.h>
#include <math.h>
#include <sqlite3.h>
#include <gee.h>
#include <gio/gio.h>


#define TYPE_VIDEO_ID (video_id_get_type ())
typedef struct _VideoID VideoID;

#define TYPE_VIDEO_ROW (video_row_get_type ())

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;

#define TYPE_RATING (rating_get_type ())
typedef struct _VideoRow VideoRow;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_VIDEO_TABLE (video_table_get_type ())
#define VIDEO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_TABLE, VideoTable))
#define VIDEO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_TABLE, VideoTableClass))
#define IS_VIDEO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_TABLE))
#define IS_VIDEO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_TABLE))
#define VIDEO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_TABLE, VideoTableClass))

typedef struct _VideoTable VideoTable;
typedef struct _VideoTableClass VideoTableClass;
typedef struct _VideoTablePrivate VideoTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _VideoID {
	gint64 id;
};

struct _ImportID {
	gint64 id;
};

struct _EventID {
	gint64 id;
};

typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

struct _VideoRow {
	VideoID video_id;
	gchar* filepath;
	gint64 filesize;
	time_t timestamp;
	gint width;
	gint height;
	gdouble clip_duration;
	gboolean is_interpretable;
	time_t exposure_time;
	ImportID import_id;
	EventID event_id;
	gchar* md5;
	time_t time_created;
	Rating rating;
	gchar* title;
	gchar* backlinks;
	time_t time_reimported;
	guint64 flags;
};

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _VideoTable {
	DatabaseTable parent_instance;
	VideoTablePrivate * priv;
};

struct _VideoTableClass {
	DatabaseTableClass parent_class;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

static gpointer video_table_parent_class = NULL;
static VideoTable* video_table_instance;
static VideoTable* video_table_instance = NULL;
extern sqlite3* database_table_db;

GType video_id_get_type (void) G_GNUC_CONST;
VideoID* video_id_dup (const VideoID* self);
void video_id_free (VideoID* self);
#define VIDEO_ID_INVALID ((gint64) (-1))
void video_id_init (VideoID *self, gint64 id);
gboolean video_id_is_invalid (VideoID *self);
gboolean video_id_is_valid (VideoID *self);
guint video_id_hash (void* a);
guint int64_hash (void* p);
gboolean video_id_equal (void* a, void* b);
gchar* video_id_upgrade_video_id_to_source_id (VideoID* video_id);
#define VIDEO_TYPENAME "video"
GType video_row_get_type (void) G_GNUC_CONST;
GType import_id_get_type (void) G_GNUC_CONST;
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
GType event_id_get_type (void) G_GNUC_CONST;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
GType rating_get_type (void) G_GNUC_CONST;
VideoRow* video_row_dup (const VideoRow* self);
void video_row_free (VideoRow* self);
void video_row_copy (const VideoRow* self, VideoRow* dest);
void video_row_destroy (VideoRow* self);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType video_table_get_type (void) G_GNUC_CONST;
enum  {
	VIDEO_TABLE_DUMMY_PROPERTY
};
static VideoTable* video_table_new (void);
static VideoTable* video_table_construct (GType object_type);
DatabaseTable* database_table_construct (GType object_type);
void database_table_fatal (const gchar* op, gint res);
void database_table_set_table_name (DatabaseTable* self, const gchar* table_name);
VideoTable* video_table_get_instance (void);
GQuark database_error_quark (void);
void video_table_add (VideoTable* self, VideoRow* video_row, VideoID* result, GError** error);
gulong now_sec (void);
#define EVENT_ID_INVALID ((gint64) (-1))
void database_table_throw_error (const gchar* method, gint res, GError** error);
void event_id_init (EventID *self, gint64 id);
gboolean video_table_drop_event (VideoTable* self, EventID* event_id);
VideoRow* video_table_get_row (VideoTable* self, VideoID* video_id);
Rating rating_unserialize (gint value);
GeeArrayList* video_table_get_all (VideoTable* self);
void video_table_set_filepath (VideoTable* self, VideoID* video_id, const gchar* filepath, GError** error);
void database_table_update_text_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, const gchar* text, GError** error);
void video_table_set_title (VideoTable* self, VideoID* video_id, const gchar* new_title, GError** error);
void video_table_set_exposure_time (VideoTable* self, VideoID* video_id, time_t time, GError** error);
void database_table_update_int64_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, gint64 value, GError** error);
void video_table_set_rating (VideoTable* self, VideoID* video_id, Rating rating, GError** error);
gint rating_serialize (Rating self);
void video_table_set_flags (VideoTable* self, VideoID* video_id, guint64 flags, GError** error);
void video_table_update_backlinks (VideoTable* self, VideoID* video_id, const gchar* backlinks, GError** error);
void video_table_update_is_interpretable (VideoTable* self, VideoID* video_id, gboolean is_interpretable, GError** error);
void database_table_update_int_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, gint value, GError** error);
gboolean video_table_set_event (VideoTable* self, VideoID* video_id, EventID* event_id);
gboolean database_table_update_int64_by_id (DatabaseTable* self, gint64 id, const gchar* column, gint64 value);
void video_table_remove_by_file (VideoTable* self, GFile* file, GError** error);
void video_table_remove (VideoTable* self, VideoID* videoID, GError** error);
gboolean video_table_is_video_stored (VideoTable* self, GFile* file);
void video_table_get_id (VideoTable* self, GFile* file, VideoID* result);
GeeArrayList* video_table_get_videos (VideoTable* self, GError** error);
static sqlite3_stmt* video_table_get_duplicate_stmt (VideoTable* self, GFile* file, const gchar* md5);
gboolean video_table_has_duplicate (VideoTable* self, GFile* file, const gchar* md5);
VideoID* video_table_get_duplicate_ids (VideoTable* self, GFile* file, const gchar* md5, int* result_length1);
static void _vala_array_add3 (VideoID** array, int* length, int* size, const VideoID* value);
GeeArrayList* video_table_get_event_source_ids (VideoTable* self, EventID* event_id);
void video_table_set_timestamp (VideoTable* self, VideoID* video_id, time_t timestamp, GError** error);
static void video_table_finalize (DatabaseTable* obj);


void video_id_init (VideoID *self, gint64 id) {
	memset (self, 0, sizeof (VideoID));
	(*self).id = id;
}


gboolean video_id_is_invalid (VideoID *self) {
	gboolean result = FALSE;
	result = (*self).id == VIDEO_ID_INVALID;
	return result;
}


gboolean video_id_is_valid (VideoID *self) {
	gboolean result = FALSE;
	result = (*self).id != VIDEO_ID_INVALID;
	return result;
}


guint video_id_hash (void* a) {
	guint result = 0U;
	guint _tmp0_;
	_tmp0_ = int64_hash (&(*((VideoID*) a)).id);
	result = _tmp0_;
	return result;
}


gboolean video_id_equal (void* a, void* b) {
	gboolean result = FALSE;
	result = (*((VideoID*) a)).id == (*((VideoID*) b)).id;
	return result;
}


gchar* video_id_upgrade_video_id_to_source_id (VideoID* video_id) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	_tmp0_ = g_strdup_printf ("%s-%016" G_GINT64_MODIFIER "x", VIDEO_TYPENAME, (*video_id).id);
	result = _tmp0_;
	return result;
}


VideoID* video_id_dup (const VideoID* self) {
	VideoID* dup;
	dup = g_new0 (VideoID, 1);
	memcpy (dup, self, sizeof (VideoID));
	return dup;
}


void video_id_free (VideoID* self) {
	g_free (self);
}


GType video_id_get_type (void) {
	static volatile gsize video_id_type_id__volatile = 0;
	if (g_once_init_enter (&video_id_type_id__volatile)) {
		GType video_id_type_id;
		video_id_type_id = g_boxed_type_register_static ("VideoID", (GBoxedCopyFunc) video_id_dup, (GBoxedFreeFunc) video_id_free);
		g_once_init_leave (&video_id_type_id__volatile, video_id_type_id);
	}
	return video_id_type_id__volatile;
}


void video_row_copy (const VideoRow* self, VideoRow* dest) {
	dest->video_id = self->video_id;
	dest->filepath = g_strdup (self->filepath);
	dest->filesize = self->filesize;
	dest->timestamp = self->timestamp;
	dest->width = self->width;
	dest->height = self->height;
	dest->clip_duration = self->clip_duration;
	dest->is_interpretable = self->is_interpretable;
	dest->exposure_time = self->exposure_time;
	dest->import_id = self->import_id;
	dest->event_id = self->event_id;
	dest->md5 = g_strdup (self->md5);
	dest->time_created = self->time_created;
	dest->rating = self->rating;
	dest->title = g_strdup (self->title);
	dest->backlinks = g_strdup (self->backlinks);
	dest->time_reimported = self->time_reimported;
	dest->flags = self->flags;
}


void video_row_destroy (VideoRow* self) {
	_g_free0 ((*self).filepath);
	_g_free0 ((*self).md5);
	_g_free0 ((*self).title);
	_g_free0 ((*self).backlinks);
}


VideoRow* video_row_dup (const VideoRow* self) {
	VideoRow* dup;
	dup = g_new0 (VideoRow, 1);
	video_row_copy (self, dup);
	return dup;
}


void video_row_free (VideoRow* self) {
	video_row_destroy (self);
	g_free (self);
}


GType video_row_get_type (void) {
	static volatile gsize video_row_type_id__volatile = 0;
	if (g_once_init_enter (&video_row_type_id__volatile)) {
		GType video_row_type_id;
		video_row_type_id = g_boxed_type_register_static ("VideoRow", (GBoxedCopyFunc) video_row_dup, (GBoxedFreeFunc) video_row_free);
		g_once_init_leave (&video_row_type_id__volatile, video_row_type_id);
	}
	return video_row_type_id__volatile;
}


static VideoTable* video_table_construct (GType object_type) {
	VideoTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gint _tmp2_;
	sqlite3_stmt* stmt2 = NULL;
	sqlite3_stmt* _tmp3_ = NULL;
	gint _tmp4_;
	gint res2;
	gint _tmp5_;
	self = (VideoTable*) database_table_construct (object_type);
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "CREATE TABLE IF NOT EXISTS VideoTable (" "id INTEGER PRIMARY KEY, " "filename TEXT UNIQUE NOT NULL, " "width INTEGER, " "height INTEGER, " "clip_duration REAL, " "is_interpretable INTEGER, " "filesize INTEGER, " "timestamp INTEGER, " "exposure_time INTEGER, " "import_id INTEGER, " "event_id INTEGER, " "md5 TEXT, " "time_created INTEGER, " "rating INTEGER DEFAULT 0, " "title TEXT, " "backlinks TEXT, " "time_reimported INTEGER, " "flags INTEGER DEFAULT 0 " ")", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = sqlite3_step (stmt);
	res = _tmp2_;
	if (res != SQLITE_DONE) {
		database_table_fatal ("VideoTable constructor", res);
	}
	_tmp4_ = sqlite3_prepare_v2 (database_table_db, "CREATE INDEX IF NOT EXISTS VideoEventIDIndex ON VideoTable (event_id)", -1, &_tmp3_, NULL);
	_sqlite3_finalize0 (stmt2);
	stmt2 = _tmp3_;
	res2 = _tmp4_;
	g_assert (res2 == SQLITE_OK);
	_tmp5_ = sqlite3_step (stmt2);
	res2 = _tmp5_;
	if (res2 != SQLITE_DONE) {
		database_table_fatal ("VideoTable constructor", res2);
	}
	database_table_set_table_name (DATABASE_TABLE (self), "VideoTable");
	_sqlite3_finalize0 (stmt2);
	_sqlite3_finalize0 (stmt);
	return self;
}


static VideoTable* video_table_new (void) {
	return video_table_construct (TYPE_VIDEO_TABLE);
}


static gpointer _database_table_ref0 (gpointer self) {
	return self ? database_table_ref (self) : NULL;
}


VideoTable* video_table_get_instance (void) {
	VideoTable* result = NULL;
	VideoTable* _tmp1_;
	if (video_table_instance == NULL) {
		VideoTable* _tmp0_ = NULL;
		_tmp0_ = video_table_new ();
		_database_table_unref0 (video_table_instance);
		video_table_instance = _tmp0_;
	}
	_tmp1_ = _database_table_ref0 (video_table_instance);
	result = _tmp1_;
	return result;
}


void video_table_add (VideoTable* self, VideoRow* video_row, VideoID* result, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gulong _tmp2_;
	gulong time_created;
	gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_ = 0;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gchar* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gchar* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint64 _tmp21_;
	VideoID _tmp22_ = {0};
	VideoID _tmp23_ = {0};
	EventID _tmp24_ = {0};
	EventID _tmp25_ = {0};
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_VIDEO_TABLE (self));
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "INSERT INTO VideoTable (filename, width, height, clip_duration, is_int" \
"erpretable, " "filesize, timestamp, exposure_time, import_id, event_id, md5, time_cre" \
"ated, title) " "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = now_sec ();
	time_created = _tmp2_;
	_tmp3_ = g_strdup ((*video_row).filepath);
	_tmp4_ = sqlite3_bind_text (stmt, 1, _tmp3_, -1, g_free);
	res = _tmp4_;
	g_assert (res == SQLITE_OK);
	_tmp5_ = sqlite3_bind_int (stmt, 2, (*video_row).width);
	res = _tmp5_;
	g_assert (res == SQLITE_OK);
	_tmp6_ = sqlite3_bind_int (stmt, 3, (*video_row).height);
	res = _tmp6_;
	g_assert (res == SQLITE_OK);
	_tmp7_ = sqlite3_bind_double (stmt, 4, (*video_row).clip_duration);
	res = _tmp7_;
	g_assert (res == SQLITE_OK);
	if ((*video_row).is_interpretable) {
		_tmp8_ = 1;
	} else {
		_tmp8_ = 0;
	}
	_tmp9_ = sqlite3_bind_int (stmt, 5, _tmp8_);
	res = _tmp9_;
	g_assert (res == SQLITE_OK);
	_tmp10_ = sqlite3_bind_int64 (stmt, 6, (*video_row).filesize);
	res = _tmp10_;
	g_assert (res == SQLITE_OK);
	_tmp11_ = sqlite3_bind_int64 (stmt, 7, (gint64) (*video_row).timestamp);
	res = _tmp11_;
	g_assert (res == SQLITE_OK);
	_tmp12_ = sqlite3_bind_int64 (stmt, 8, (gint64) (*video_row).exposure_time);
	res = _tmp12_;
	g_assert (res == SQLITE_OK);
	_tmp13_ = sqlite3_bind_int64 (stmt, 9, (*video_row).import_id.id);
	res = _tmp13_;
	g_assert (res == SQLITE_OK);
	_tmp14_ = sqlite3_bind_int64 (stmt, 10, EVENT_ID_INVALID);
	res = _tmp14_;
	g_assert (res == SQLITE_OK);
	_tmp15_ = g_strdup ((*video_row).md5);
	_tmp16_ = sqlite3_bind_text (stmt, 11, _tmp15_, -1, g_free);
	res = _tmp16_;
	g_assert (res == SQLITE_OK);
	_tmp17_ = sqlite3_bind_int64 (stmt, 12, (gint64) time_created);
	res = _tmp17_;
	g_assert (res == SQLITE_OK);
	_tmp18_ = g_strdup ((*video_row).title);
	_tmp19_ = sqlite3_bind_text (stmt, 13, _tmp18_, -1, g_free);
	res = _tmp19_;
	g_assert (res == SQLITE_OK);
	_tmp20_ = sqlite3_step (stmt);
	res = _tmp20_;
	if (res != SQLITE_DONE) {
		if (res != SQLITE_CONSTRAINT) {
			database_table_throw_error ("VideoTable.add", res, &_inner_error_);
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == DATABASE_ERROR) {
					g_propagate_error (error, _inner_error_);
					_sqlite3_finalize0 (stmt);
					return;
				} else {
					_sqlite3_finalize0 (stmt);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
			}
		}
	}
	_tmp21_ = sqlite3_last_insert_rowid (database_table_db);
	video_id_init (&_tmp22_, _tmp21_);
	_tmp23_ = _tmp22_;
	(*video_row).video_id = _tmp23_;
	event_id_init (&_tmp24_, EVENT_ID_INVALID);
	_tmp25_ = _tmp24_;
	(*video_row).event_id = _tmp25_;
	(*video_row).time_created = (time_t) time_created;
	(*video_row).flags = (guint64) 0;
	*result = (*video_row).video_id;
	_sqlite3_finalize0 (stmt);
	return;
}


gboolean video_table_drop_event (VideoTable* self, EventID* event_id) {
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	g_return_val_if_fail (IS_VIDEO_TABLE (self), FALSE);
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "UPDATE VideoTable SET event_id = ? WHERE event_id = ?", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = sqlite3_bind_int64 (stmt, 1, EVENT_ID_INVALID);
	res = _tmp2_;
	g_assert (res == SQLITE_OK);
	_tmp3_ = sqlite3_bind_int64 (stmt, 2, (*event_id).id);
	res = _tmp3_;
	g_assert (res == SQLITE_OK);
	_tmp4_ = sqlite3_step (stmt);
	res = _tmp4_;
	if (res != SQLITE_DONE) {
		database_table_fatal ("VideoTable.drop_event", res);
		result = FALSE;
		_sqlite3_finalize0 (stmt);
		return result;
	}
	result = TRUE;
	_sqlite3_finalize0 (stmt);
	return result;
}


static gpointer _video_row_dup0 (gpointer self) {
	return self ? video_row_dup (self) : NULL;
}


VideoRow* video_table_get_row (VideoTable* self, VideoID* video_id) {
	VideoRow* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gint _tmp2_;
	gint _tmp3_;
	VideoRow row = {0};
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gdouble _tmp8_;
	gint _tmp9_;
	gint64 _tmp10_;
	gint64 _tmp11_;
	gint64 _tmp12_;
	gint64 _tmp13_;
	gint64 _tmp14_;
	const gchar* _tmp15_ = NULL;
	gchar* _tmp16_;
	gint64 _tmp17_;
	gint _tmp18_;
	Rating _tmp19_;
	const gchar* _tmp20_ = NULL;
	gchar* _tmp21_;
	const gchar* _tmp22_ = NULL;
	gchar* _tmp23_;
	gint64 _tmp24_;
	gint64 _tmp25_;
	VideoRow _tmp26_;
	VideoRow* _tmp27_;
	VideoRow* _tmp28_;
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "SELECT filename, width, height, clip_duration, is_interpretable, files" \
"ize, timestamp, " "exposure_time, import_id, event_id, md5, time_created, rating, title, " \
"backlinks, " "time_reimported, flags FROM VideoTable WHERE id=?", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = sqlite3_bind_int64 (stmt, 1, (*video_id).id);
	res = _tmp2_;
	g_assert (res == SQLITE_OK);
	_tmp3_ = sqlite3_step (stmt);
	if (_tmp3_ != SQLITE_ROW) {
		result = NULL;
		_sqlite3_finalize0 (stmt);
		return result;
	}
	memset (&row, 0, sizeof (VideoRow));
	row.video_id = *video_id;
	_tmp4_ = sqlite3_column_text (stmt, 0);
	_tmp5_ = g_strdup (_tmp4_);
	_g_free0 (row.filepath);
	row.filepath = _tmp5_;
	_tmp6_ = sqlite3_column_int (stmt, 1);
	row.width = _tmp6_;
	_tmp7_ = sqlite3_column_int (stmt, 2);
	row.height = _tmp7_;
	_tmp8_ = sqlite3_column_double (stmt, 3);
	row.clip_duration = _tmp8_;
	_tmp9_ = sqlite3_column_int (stmt, 4);
	row.is_interpretable = _tmp9_ == 1;
	_tmp10_ = sqlite3_column_int64 (stmt, 5);
	row.filesize = _tmp10_;
	_tmp11_ = sqlite3_column_int64 (stmt, 6);
	row.timestamp = (time_t) _tmp11_;
	_tmp12_ = sqlite3_column_int64 (stmt, 7);
	row.exposure_time = (time_t) _tmp12_;
	_tmp13_ = sqlite3_column_int64 (stmt, 8);
	row.import_id.id = _tmp13_;
	_tmp14_ = sqlite3_column_int64 (stmt, 9);
	row.event_id.id = _tmp14_;
	_tmp15_ = sqlite3_column_text (stmt, 10);
	_tmp16_ = g_strdup (_tmp15_);
	_g_free0 (row.md5);
	row.md5 = _tmp16_;
	_tmp17_ = sqlite3_column_int64 (stmt, 11);
	row.time_created = (time_t) _tmp17_;
	_tmp18_ = sqlite3_column_int (stmt, 12);
	_tmp19_ = rating_unserialize (_tmp18_);
	row.rating = _tmp19_;
	_tmp20_ = sqlite3_column_text (stmt, 13);
	_tmp21_ = g_strdup (_tmp20_);
	_g_free0 (row.title);
	row.title = _tmp21_;
	_tmp22_ = sqlite3_column_text (stmt, 14);
	_tmp23_ = g_strdup (_tmp22_);
	_g_free0 (row.backlinks);
	row.backlinks = _tmp23_;
	_tmp24_ = sqlite3_column_int64 (stmt, 15);
	row.time_reimported = (time_t) _tmp24_;
	_tmp25_ = sqlite3_column_int64 (stmt, 16);
	row.flags = (guint64) _tmp25_;
	_tmp26_ = row;
	_tmp27_ = _video_row_dup0 (&_tmp26_);
	_tmp28_ = _tmp27_;
	video_row_destroy (&_tmp26_);
	result = _tmp28_;
	_sqlite3_finalize0 (stmt);
	return result;
}


GeeArrayList* video_table_get_all (VideoTable* self) {
	GeeArrayList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	GeeArrayList* _tmp2_ = NULL;
	GeeArrayList* all;
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "SELECT id, filename, width, height, clip_duration, is_interpretable, f" \
"ilesize, " "timestamp, exposure_time, import_id, event_id, md5, time_created, rati" \
"ng, title, " "backlinks, time_reimported, flags FROM VideoTable", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = gee_array_list_new (TYPE_VIDEO_ROW, (GBoxedCopyFunc) video_row_dup, video_row_free, NULL);
	all = _tmp2_;
	while (TRUE) {
		gint _tmp3_;
		VideoRow row = {0};
		gint64 _tmp4_;
		const gchar* _tmp5_ = NULL;
		gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gdouble _tmp9_;
		gint _tmp10_;
		gint64 _tmp11_;
		gint64 _tmp12_;
		gint64 _tmp13_;
		gint64 _tmp14_;
		gint64 _tmp15_;
		const gchar* _tmp16_ = NULL;
		gchar* _tmp17_;
		gint64 _tmp18_;
		gint _tmp19_;
		Rating _tmp20_;
		const gchar* _tmp21_ = NULL;
		gchar* _tmp22_;
		const gchar* _tmp23_ = NULL;
		gchar* _tmp24_;
		gint64 _tmp25_;
		gint64 _tmp26_;
		_tmp3_ = sqlite3_step (stmt);
		res = _tmp3_;
		if (!(res == SQLITE_ROW)) {
			break;
		}
		memset (&row, 0, sizeof (VideoRow));
		_tmp4_ = sqlite3_column_int64 (stmt, 0);
		row.video_id.id = _tmp4_;
		_tmp5_ = sqlite3_column_text (stmt, 1);
		_tmp6_ = g_strdup (_tmp5_);
		_g_free0 (row.filepath);
		row.filepath = _tmp6_;
		_tmp7_ = sqlite3_column_int (stmt, 2);
		row.width = _tmp7_;
		_tmp8_ = sqlite3_column_int (stmt, 3);
		row.height = _tmp8_;
		_tmp9_ = sqlite3_column_double (stmt, 4);
		row.clip_duration = _tmp9_;
		_tmp10_ = sqlite3_column_int (stmt, 5);
		row.is_interpretable = _tmp10_ == 1;
		_tmp11_ = sqlite3_column_int64 (stmt, 6);
		row.filesize = _tmp11_;
		_tmp12_ = sqlite3_column_int64 (stmt, 7);
		row.timestamp = (time_t) _tmp12_;
		_tmp13_ = sqlite3_column_int64 (stmt, 8);
		row.exposure_time = (time_t) _tmp13_;
		_tmp14_ = sqlite3_column_int64 (stmt, 9);
		row.import_id.id = _tmp14_;
		_tmp15_ = sqlite3_column_int64 (stmt, 10);
		row.event_id.id = _tmp15_;
		_tmp16_ = sqlite3_column_text (stmt, 11);
		_tmp17_ = g_strdup (_tmp16_);
		_g_free0 (row.md5);
		row.md5 = _tmp17_;
		_tmp18_ = sqlite3_column_int64 (stmt, 12);
		row.time_created = (time_t) _tmp18_;
		_tmp19_ = sqlite3_column_int (stmt, 13);
		_tmp20_ = rating_unserialize (_tmp19_);
		row.rating = _tmp20_;
		_tmp21_ = sqlite3_column_text (stmt, 14);
		_tmp22_ = g_strdup (_tmp21_);
		_g_free0 (row.title);
		row.title = _tmp22_;
		_tmp23_ = sqlite3_column_text (stmt, 15);
		_tmp24_ = g_strdup (_tmp23_);
		_g_free0 (row.backlinks);
		row.backlinks = _tmp24_;
		_tmp25_ = sqlite3_column_int64 (stmt, 16);
		row.time_reimported = (time_t) _tmp25_;
		_tmp26_ = sqlite3_column_int64 (stmt, 17);
		row.flags = (guint64) _tmp26_;
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (all), &row);
		video_row_destroy (&row);
	}
	result = all;
	_sqlite3_finalize0 (stmt);
	return result;
}


void video_table_set_filepath (VideoTable* self, VideoID* video_id, const gchar* filepath, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_VIDEO_TABLE (self));
	g_return_if_fail (filepath != NULL);
	database_table_update_text_by_id_2 (DATABASE_TABLE (self), (*video_id).id, "filename", filepath, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


void video_table_set_title (VideoTable* self, VideoID* video_id, const gchar* new_title, GError** error) {
	const gchar* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_VIDEO_TABLE (self));
	if (new_title != NULL) {
		_tmp0_ = new_title;
	} else {
		_tmp0_ = "";
	}
	database_table_update_text_by_id_2 (DATABASE_TABLE (self), (*video_id).id, "title", _tmp0_, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


void video_table_set_exposure_time (VideoTable* self, VideoID* video_id, time_t time, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_VIDEO_TABLE (self));
	database_table_update_int64_by_id_2 (DATABASE_TABLE (self), (*video_id).id, "exposure_time", (gint64) time, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


void video_table_set_rating (VideoTable* self, VideoID* video_id, Rating rating, GError** error) {
	gint _tmp0_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_VIDEO_TABLE (self));
	_tmp0_ = rating_serialize (rating);
	database_table_update_int64_by_id_2 (DATABASE_TABLE (self), (*video_id).id, "rating", (gint64) _tmp0_, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


void video_table_set_flags (VideoTable* self, VideoID* video_id, guint64 flags, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_VIDEO_TABLE (self));
	database_table_update_int64_by_id_2 (DATABASE_TABLE (self), (*video_id).id, "flags", (gint64) flags, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


void video_table_update_backlinks (VideoTable* self, VideoID* video_id, const gchar* backlinks, GError** error) {
	const gchar* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_VIDEO_TABLE (self));
	if (backlinks != NULL) {
		_tmp0_ = backlinks;
	} else {
		_tmp0_ = "";
	}
	database_table_update_text_by_id_2 (DATABASE_TABLE (self), (*video_id).id, "backlinks", _tmp0_, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


void video_table_update_is_interpretable (VideoTable* self, VideoID* video_id, gboolean is_interpretable, GError** error) {
	gint _tmp0_ = 0;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_VIDEO_TABLE (self));
	if (is_interpretable) {
		_tmp0_ = 1;
	} else {
		_tmp0_ = 0;
	}
	database_table_update_int_by_id_2 (DATABASE_TABLE (self), (*video_id).id, "is_interpretable", _tmp0_, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


gboolean video_table_set_event (VideoTable* self, VideoID* video_id, EventID* event_id) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (IS_VIDEO_TABLE (self), FALSE);
	_tmp0_ = database_table_update_int64_by_id (DATABASE_TABLE (self), (*video_id).id, "event_id", (*event_id).id);
	result = _tmp0_;
	return result;
}


void video_table_remove_by_file (VideoTable* self, GFile* file, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gchar* _tmp2_ = NULL;
	gint _tmp3_;
	gint _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_VIDEO_TABLE (self));
	g_return_if_fail (G_IS_FILE (file));
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "DELETE FROM VideoTable WHERE filename=?", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = g_file_get_path (file);
	_tmp3_ = sqlite3_bind_text (stmt, 1, _tmp2_, -1, g_free);
	res = _tmp3_;
	g_assert (res == SQLITE_OK);
	_tmp4_ = sqlite3_step (stmt);
	res = _tmp4_;
	if (res != SQLITE_DONE) {
		database_table_throw_error ("VideoTable.remove_by_file", res, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_sqlite3_finalize0 (stmt);
				return;
			} else {
				_sqlite3_finalize0 (stmt);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	_sqlite3_finalize0 (stmt);
}


void video_table_remove (VideoTable* self, VideoID* videoID, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gint _tmp2_;
	gint _tmp3_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_VIDEO_TABLE (self));
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "DELETE FROM VideoTable WHERE id=?", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = sqlite3_bind_int64 (stmt, 1, (*videoID).id);
	res = _tmp2_;
	g_assert (res == SQLITE_OK);
	_tmp3_ = sqlite3_step (stmt);
	res = _tmp3_;
	if (res != SQLITE_DONE) {
		database_table_throw_error ("VideoTable.remove", res, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				_sqlite3_finalize0 (stmt);
				return;
			} else {
				_sqlite3_finalize0 (stmt);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
		}
	}
	_sqlite3_finalize0 (stmt);
}


gboolean video_table_is_video_stored (VideoTable* self, GFile* file) {
	gboolean result = FALSE;
	VideoID _tmp0_ = {0};
	VideoID _tmp1_ = {0};
	gboolean _tmp2_;
	g_return_val_if_fail (IS_VIDEO_TABLE (self), FALSE);
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
	video_table_get_id (self, file, &_tmp0_);
	_tmp1_ = _tmp0_;
	_tmp2_ = video_id_is_valid (&_tmp1_);
	result = _tmp2_;
	return result;
}


void video_table_get_id (VideoTable* self, GFile* file, VideoID* result) {
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gchar* _tmp2_ = NULL;
	gint _tmp3_;
	gint _tmp4_;
	VideoID _tmp5_ = {0};
	g_return_if_fail (IS_VIDEO_TABLE (self));
	g_return_if_fail (G_IS_FILE (file));
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "SELECT ID FROM VideoTable WHERE filename=?", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = g_file_get_path (file);
	_tmp3_ = sqlite3_bind_text (stmt, 1, _tmp2_, -1, g_free);
	res = _tmp3_;
	g_assert (res == SQLITE_OK);
	_tmp4_ = sqlite3_step (stmt);
	res = _tmp4_;
	if (res == SQLITE_ROW) {
		gint64 _tmp6_;
		VideoID _tmp7_ = {0};
		VideoID _tmp8_ = {0};
		_tmp6_ = sqlite3_column_int64 (stmt, 0);
		video_id_init (&_tmp7_, _tmp6_);
		_tmp8_ = _tmp7_;
		_tmp5_ = _tmp8_;
	} else {
		VideoID _tmp9_ = {0};
		VideoID _tmp10_ = {0};
		video_id_init (&_tmp9_, VIDEO_ID_INVALID);
		_tmp10_ = _tmp9_;
		_tmp5_ = _tmp10_;
	}
	*result = _tmp5_;
	_sqlite3_finalize0 (stmt);
	return;
}


GeeArrayList* video_table_get_videos (VideoTable* self, GError** error) {
	GeeArrayList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	GeeArrayList* _tmp2_ = NULL;
	GeeArrayList* video_ids;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "SELECT id FROM VideoTable", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = gee_array_list_new (TYPE_VIDEO_ID, (GBoxedCopyFunc) video_id_dup, video_id_free, NULL);
	video_ids = _tmp2_;
	{
		gboolean _tmp3_;
		_tmp3_ = TRUE;
		while (TRUE) {
			gint _tmp4_;
			gint64 _tmp5_;
			VideoID _tmp6_ = {0};
			VideoID _tmp7_ = {0};
			if (!_tmp3_) {
			}
			_tmp3_ = FALSE;
			_tmp4_ = sqlite3_step (stmt);
			res = _tmp4_;
			if (res == SQLITE_DONE) {
				break;
			} else {
				if (res != SQLITE_ROW) {
					database_table_throw_error ("VideoTable.get_videos", res, &_inner_error_);
					if (_inner_error_ != NULL) {
						if (_inner_error_->domain == DATABASE_ERROR) {
							g_propagate_error (error, _inner_error_);
							_g_object_unref0 (video_ids);
							_sqlite3_finalize0 (stmt);
							return NULL;
						} else {
							_g_object_unref0 (video_ids);
							_sqlite3_finalize0 (stmt);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
							g_clear_error (&_inner_error_);
							return NULL;
						}
					}
				}
			}
			_tmp5_ = sqlite3_column_int64 (stmt, 0);
			video_id_init (&_tmp6_, _tmp5_);
			_tmp7_ = _tmp6_;
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (video_ids), &_tmp7_);
		}
	}
	result = video_ids;
	_sqlite3_finalize0 (stmt);
	return result;
}


static sqlite3_stmt* video_table_get_duplicate_stmt (VideoTable* self, GFile* file, const gchar* md5) {
	sqlite3_stmt* result = NULL;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp1_;
	gchar* sql;
	gboolean first;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp5_ = NULL;
	gint _tmp6_;
	gint res;
	gint col;
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), NULL);
	if (file != NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = md5 != NULL;
	}
	g_assert (_tmp0_);
	_tmp1_ = g_strdup ("SELECT id FROM VideoTable WHERE");
	sql = _tmp1_;
	first = TRUE;
	if (file != NULL) {
		gchar* _tmp2_;
		_tmp2_ = g_strconcat (sql, " filename=?", NULL);
		_g_free0 (sql);
		sql = _tmp2_;
		first = FALSE;
	}
	if (md5 != NULL) {
		gchar* _tmp4_;
		if (!first) {
			gchar* _tmp3_;
			_tmp3_ = g_strconcat (sql, " OR ", NULL);
			_g_free0 (sql);
			sql = _tmp3_;
		}
		_tmp4_ = g_strconcat (sql, " md5=?", NULL);
		_g_free0 (sql);
		sql = _tmp4_;
	}
	_tmp6_ = sqlite3_prepare_v2 (database_table_db, sql, -1, &_tmp5_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp5_;
	res = _tmp6_;
	g_assert (res == SQLITE_OK);
	col = 1;
	if (file != NULL) {
		gint _tmp7_;
		gchar* _tmp8_ = NULL;
		gint _tmp9_;
		_tmp7_ = col;
		col = _tmp7_ + 1;
		_tmp8_ = g_file_get_path (file);
		_tmp9_ = sqlite3_bind_text (stmt, _tmp7_, _tmp8_, -1, g_free);
		res = _tmp9_;
		g_assert (res == SQLITE_OK);
	}
	if (md5 != NULL) {
		gint _tmp10_;
		gchar* _tmp11_;
		gint _tmp12_;
		_tmp10_ = col;
		col = _tmp10_ + 1;
		_tmp11_ = g_strdup (md5);
		_tmp12_ = sqlite3_bind_text (stmt, _tmp10_, _tmp11_, -1, g_free);
		res = _tmp12_;
		g_assert (res == SQLITE_OK);
	}
	result = stmt;
	_g_free0 (sql);
	return result;
}


gboolean video_table_has_duplicate (VideoTable* self, GFile* file, const gchar* md5) {
	gboolean result = FALSE;
	sqlite3_stmt* _tmp0_ = NULL;
	sqlite3_stmt* stmt;
	gint _tmp1_;
	gint res;
	g_return_val_if_fail (IS_VIDEO_TABLE (self), FALSE);
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), FALSE);
	_tmp0_ = video_table_get_duplicate_stmt (self, file, md5);
	stmt = _tmp0_;
	_tmp1_ = sqlite3_step (stmt);
	res = _tmp1_;
	if (res == SQLITE_DONE) {
		result = FALSE;
		_sqlite3_finalize0 (stmt);
		return result;
	} else {
		if (res == SQLITE_ROW) {
			result = TRUE;
			_sqlite3_finalize0 (stmt);
			return result;
		} else {
			database_table_fatal ("VideoTable.has_duplicate", res);
		}
	}
	result = FALSE;
	_sqlite3_finalize0 (stmt);
	return result;
}


static void _vala_array_add3 (VideoID** array, int* length, int* size, const VideoID* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (VideoID, *array, *size);
	}
	(*array)[(*length)++] = *value;
}


VideoID* video_table_get_duplicate_ids (VideoTable* self, GFile* file, const gchar* md5, int* result_length1) {
	VideoID* result = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	sqlite3_stmt* stmt;
	VideoID* _tmp1_ = NULL;
	VideoID* ids;
	gint ids_length1;
	gint _ids_size_;
	gint _tmp2_;
	gint res;
	VideoID* _tmp7_;
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), NULL);
	_tmp0_ = video_table_get_duplicate_stmt (self, file, md5);
	stmt = _tmp0_;
	_tmp1_ = g_new0 (VideoID, 0);
	ids = _tmp1_;
	ids_length1 = 0;
	_ids_size_ = 0;
	_tmp2_ = sqlite3_step (stmt);
	res = _tmp2_;
	while (TRUE) {
		gint64 _tmp3_;
		VideoID _tmp4_ = {0};
		VideoID _tmp5_ = {0};
		gint _tmp6_;
		if (!(res == SQLITE_ROW)) {
			break;
		}
		_tmp3_ = sqlite3_column_int64 (stmt, 0);
		video_id_init (&_tmp4_, _tmp3_);
		_tmp5_ = _tmp4_;
		_vala_array_add3 (&ids, &ids_length1, &_ids_size_, &_tmp5_);
		_tmp6_ = sqlite3_step (stmt);
		res = _tmp6_;
	}
	_tmp7_ = ids;
	if (result_length1) {
		*result_length1 = ids_length1;
	}
	result = _tmp7_;
	_sqlite3_finalize0 (stmt);
	return result;
}


GeeArrayList* video_table_get_event_source_ids (VideoTable* self, EventID* event_id) {
	GeeArrayList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3_stmt* _tmp0_ = NULL;
	gint _tmp1_;
	gint res;
	gint _tmp2_;
	GeeArrayList* _tmp3_ = NULL;
	GeeArrayList* _result_;
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
	_tmp1_ = sqlite3_prepare_v2 (database_table_db, "SELECT id FROM VideoTable WHERE event_id = ?", -1, &_tmp0_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp0_;
	res = _tmp1_;
	g_assert (res == SQLITE_OK);
	_tmp2_ = sqlite3_bind_int64 (stmt, 1, (*event_id).id);
	res = _tmp2_;
	g_assert (res == SQLITE_OK);
	_tmp3_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
	_result_ = _tmp3_;
	{
		gboolean _tmp4_;
		_tmp4_ = TRUE;
		while (TRUE) {
			gint _tmp5_;
			gint64 _tmp6_;
			VideoID _tmp7_ = {0};
			VideoID _tmp8_ = {0};
			gchar* _tmp9_ = NULL;
			gchar* _tmp10_;
			if (!_tmp4_) {
			}
			_tmp4_ = FALSE;
			_tmp5_ = sqlite3_step (stmt);
			res = _tmp5_;
			if (res == SQLITE_DONE) {
				break;
			} else {
				if (res != SQLITE_ROW) {
					database_table_fatal ("get_event_source_ids", res);
					break;
				}
			}
			_tmp6_ = sqlite3_column_int64 (stmt, 0);
			video_id_init (&_tmp7_, _tmp6_);
			_tmp8_ = _tmp7_;
			_tmp9_ = video_id_upgrade_video_id_to_source_id (&_tmp8_);
			_tmp10_ = _tmp9_;
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_result_), _tmp10_);
			_g_free0 (_tmp10_);
		}
	}
	result = _result_;
	_sqlite3_finalize0 (stmt);
	return result;
}


void video_table_set_timestamp (VideoTable* self, VideoID* video_id, time_t timestamp, GError** error) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_VIDEO_TABLE (self));
	database_table_update_int64_by_id_2 (DATABASE_TABLE (self), (*video_id).id, "timestamp", (gint64) timestamp, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void video_table_class_init (VideoTableClass * klass) {
	video_table_parent_class = g_type_class_peek_parent (klass);
	DATABASE_TABLE_CLASS (klass)->finalize = video_table_finalize;
}


static void video_table_instance_init (VideoTable * self) {
}


static void video_table_finalize (DatabaseTable* obj) {
	VideoTable * self;
	self = VIDEO_TABLE (obj);
	DATABASE_TABLE_CLASS (video_table_parent_class)->finalize (obj);
}


GType video_table_get_type (void) {
	static volatile gsize video_table_type_id__volatile = 0;
	if (g_once_init_enter (&video_table_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VideoTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoTable), 0, (GInstanceInitFunc) video_table_instance_init, NULL };
		GType video_table_type_id;
		video_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "VideoTable", &g_define_type_info, 0);
		g_once_init_leave (&video_table_type_id__volatile, video_table_type_id);
	}
	return video_table_type_id__volatile;
}



