/* PhotoFileAdapter.c generated by valac 0.12.1, the Vala compiler
 * generated from PhotoFileAdapter.vala, do not modify */

/* Copyright 2010-2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */
/**/
/* PhotoFileAdapter*/
/**/
/* PhotoFileAdapter (and its immediate children, PhotoFileReader and PhotoFileWriter) are drivers*/
/* hiding details of reading and writing image files and their metadata.  They should keep*/
/* minimal state beyond the filename, if any stat at all.  In particular, they should avoid caching*/
/* values, especially the readers, as writers may be created at any time and invalidate that*/
/* information, unless the readers monitor the file for these changes.*/
/**/
/* PhotoFileAdapters should be entirely thread-safe.  They are not, however, responsible for*/
/* atomicity on the filesystem.*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gobject/gvaluecollector.h>


#define TYPE_PHOTO_FILE_ADAPTER (photo_file_adapter_get_type ())
#define PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter))
#define PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))
#define IS_PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_ADAPTER))
#define IS_PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_ADAPTER))
#define PHOTO_FILE_ADAPTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))

typedef struct _PhotoFileAdapter PhotoFileAdapter;
typedef struct _PhotoFileAdapterClass PhotoFileAdapterClass;
typedef struct _PhotoFileAdapterPrivate PhotoFileAdapterPrivate;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ParamSpecPhotoFileAdapter ParamSpecPhotoFileAdapter;

#define TYPE_PHOTO_FILE_READER (photo_file_reader_get_type ())
#define PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReader))
#define PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))
#define IS_PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_READER))
#define IS_PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_READER))
#define PHOTO_FILE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))

typedef struct _PhotoFileReader PhotoFileReader;
typedef struct _PhotoFileReaderClass PhotoFileReaderClass;
typedef struct _PhotoFileReaderPrivate PhotoFileReaderPrivate;

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_PHOTO_FILE_WRITER (photo_file_writer_get_type ())
#define PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriter))
#define PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))
#define IS_PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_WRITER))
#define IS_PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_WRITER))
#define PHOTO_FILE_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))

typedef struct _PhotoFileWriter PhotoFileWriter;
typedef struct _PhotoFileWriterClass PhotoFileWriterClass;

#define TYPE_PHOTO_FILE_METADATA_WRITER (photo_file_metadata_writer_get_type ())
#define PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriter))
#define PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))
#define IS_PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_METADATA_WRITER))
#define IS_PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_METADATA_WRITER))
#define PHOTO_FILE_METADATA_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))

typedef struct _PhotoFileMetadataWriter PhotoFileMetadataWriter;
typedef struct _PhotoFileMetadataWriterClass PhotoFileMetadataWriterClass;
typedef struct _PhotoFileWriterPrivate PhotoFileWriterPrivate;

#define JPEG_TYPE_QUALITY (jpeg_quality_get_type ())
typedef struct _PhotoFileMetadataWriterPrivate PhotoFileMetadataWriterPrivate;

struct _PhotoFileAdapter {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoFileAdapterPrivate * priv;
};

struct _PhotoFileAdapterClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoFileAdapter *self);
};

typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

struct _PhotoFileAdapterPrivate {
	gchar* filepath;
	PhotoFileFormat file_format;
	GFile* file;
	GStaticRecMutex __lock_file;
};

struct _ParamSpecPhotoFileAdapter {
	GParamSpec parent_instance;
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _PhotoFileReader {
	PhotoFileAdapter parent_instance;
	PhotoFileReaderPrivate * priv;
};

struct _PhotoFileReaderClass {
	PhotoFileAdapterClass parent_class;
	PhotoMetadata* (*read_metadata) (PhotoFileReader* self, GError** error);
	GdkPixbuf* (*unscaled_read) (PhotoFileReader* self, GError** error);
	GdkPixbuf* (*scaled_read) (PhotoFileReader* self, Dimensions* full, Dimensions* scaled, GError** error);
};

typedef enum  {
	PHOTO_FORMAT_ERROR_READ_ONLY
} PhotoFormatError;
#define PHOTO_FORMAT_ERROR photo_format_error_quark ()
typedef enum  {
	JPEG_QUALITY_LOW = 50,
	JPEG_QUALITY_MEDIUM = 75,
	JPEG_QUALITY_HIGH = 90,
	JPEG_QUALITY_MAXIMUM = 100
} JpegQuality;

struct _PhotoFileWriter {
	PhotoFileAdapter parent_instance;
	PhotoFileWriterPrivate * priv;
};

struct _PhotoFileWriterClass {
	PhotoFileAdapterClass parent_class;
	void (*write) (PhotoFileWriter* self, GdkPixbuf* pixbuf, JpegQuality quality, GError** error);
};

struct _PhotoFileMetadataWriter {
	PhotoFileAdapter parent_instance;
	PhotoFileMetadataWriterPrivate * priv;
};

struct _PhotoFileMetadataWriterClass {
	PhotoFileAdapterClass parent_class;
	void (*write_metadata) (PhotoFileMetadataWriter* self, PhotoMetadata* metadata, GError** error);
};


static gpointer photo_file_adapter_parent_class = NULL;
static gpointer photo_file_reader_parent_class = NULL;
static gpointer photo_file_writer_parent_class = NULL;
static gpointer photo_file_metadata_writer_parent_class = NULL;

gpointer photo_file_adapter_ref (gpointer instance);
void photo_file_adapter_unref (gpointer instance);
GParamSpec* param_spec_photo_file_adapter (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_file_adapter (GValue* value, gpointer v_object);
void value_take_photo_file_adapter (GValue* value, gpointer v_object);
gpointer value_get_photo_file_adapter (const GValue* value);
GType photo_file_adapter_get_type (void) G_GNUC_CONST;
GType photo_file_format_get_type (void) G_GNUC_CONST;
#define PHOTO_FILE_ADAPTER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterPrivate))
enum  {
	PHOTO_FILE_ADAPTER_DUMMY_PROPERTY
};
PhotoFileAdapter* photo_file_adapter_construct (GType object_type, const gchar* filepath, PhotoFileFormat file_format);
gboolean photo_file_adapter_file_exists (PhotoFileAdapter* self);
gchar* photo_file_adapter_get_filepath (PhotoFileAdapter* self);
GFile* photo_file_adapter_get_file (PhotoFileAdapter* self);
PhotoFileFormat photo_file_adapter_get_file_format (PhotoFileAdapter* self);
static void photo_file_adapter_finalize (PhotoFileAdapter* obj);
GType photo_file_reader_get_type (void) G_GNUC_CONST;
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_media_metadata (GValue* value, gpointer v_object);
void value_take_media_metadata (GValue* value, gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
GType photo_metadata_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
enum  {
	PHOTO_FILE_READER_DUMMY_PROPERTY
};
PhotoFileReader* photo_file_reader_construct (GType object_type, const gchar* filepath, PhotoFileFormat file_format);
GType photo_file_writer_get_type (void) G_GNUC_CONST;
GQuark photo_format_error_quark (void);
PhotoFileWriter* photo_file_reader_create_writer (PhotoFileReader* self, GError** error);
PhotoFileWriter* photo_file_format_create_writer (PhotoFileFormat self, const gchar* filepath, GError** error);
GType photo_file_metadata_writer_get_type (void) G_GNUC_CONST;
PhotoFileMetadataWriter* photo_file_reader_create_metadata_writer (PhotoFileReader* self, GError** error);
PhotoFileMetadataWriter* photo_file_format_create_metadata_writer (PhotoFileFormat self, const gchar* filepath, GError** error);
PhotoMetadata* photo_file_reader_read_metadata (PhotoFileReader* self, GError** error);
static PhotoMetadata* photo_file_reader_real_read_metadata (PhotoFileReader* self, GError** error);
GdkPixbuf* photo_file_reader_unscaled_read (PhotoFileReader* self, GError** error);
static GdkPixbuf* photo_file_reader_real_unscaled_read (PhotoFileReader* self, GError** error);
GdkPixbuf* photo_file_reader_scaled_read (PhotoFileReader* self, Dimensions* full, Dimensions* scaled, GError** error);
static GdkPixbuf* photo_file_reader_real_scaled_read (PhotoFileReader* self, Dimensions* full, Dimensions* scaled, GError** error);
GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf, Dimensions* resized, GdkInterpType interp);
GType jpeg_quality_get_type (void) G_GNUC_CONST;
enum  {
	PHOTO_FILE_WRITER_DUMMY_PROPERTY
};
PhotoFileWriter* photo_file_writer_construct (GType object_type, const gchar* filepath, PhotoFileFormat file_format);
PhotoFileReader* photo_file_writer_create_reader (PhotoFileWriter* self);
PhotoFileReader* photo_file_format_create_reader (PhotoFileFormat self, const gchar* filepath);
void photo_file_writer_write (PhotoFileWriter* self, GdkPixbuf* pixbuf, JpegQuality quality, GError** error);
static void photo_file_writer_real_write (PhotoFileWriter* self, GdkPixbuf* pixbuf, JpegQuality quality, GError** error);
enum  {
	PHOTO_FILE_METADATA_WRITER_DUMMY_PROPERTY
};
PhotoFileMetadataWriter* photo_file_metadata_writer_construct (GType object_type, const gchar* filepath, PhotoFileFormat file_format);
PhotoFileReader* photo_file_metadata_writer_create_reader (PhotoFileMetadataWriter* self);
void photo_file_metadata_writer_write_metadata (PhotoFileMetadataWriter* self, PhotoMetadata* metadata, GError** error);
static void photo_file_metadata_writer_real_write_metadata (PhotoFileMetadataWriter* self, PhotoMetadata* metadata, GError** error);


PhotoFileAdapter* photo_file_adapter_construct (GType object_type, const gchar* filepath, PhotoFileFormat file_format) {
	PhotoFileAdapter* self = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (filepath != NULL, NULL);
	self = (PhotoFileAdapter*) g_type_create_instance (object_type);
	_tmp0_ = g_strdup (filepath);
	_g_free0 (self->priv->filepath);
	self->priv->filepath = _tmp0_;
	self->priv->file_format = file_format;
	return self;
}


gboolean photo_file_adapter_file_exists (PhotoFileAdapter* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (IS_PHOTO_FILE_ADAPTER (self), FALSE);
	_tmp0_ = g_file_test (self->priv->filepath, G_FILE_TEST_IS_REGULAR);
	result = _tmp0_;
	return result;
}


gchar* photo_file_adapter_get_filepath (PhotoFileAdapter* self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (IS_PHOTO_FILE_ADAPTER (self), NULL);
	_tmp0_ = g_strdup (self->priv->filepath);
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


GFile* photo_file_adapter_get_file (PhotoFileAdapter* self) {
	GFile* result = NULL;
	GFile* _result_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO_FILE_ADAPTER (self), NULL);
	{
		GFile* _tmp1_;
		g_static_rec_mutex_lock (&self->priv->__lock_file);
		if (self->priv->file == NULL) {
			GFile* _tmp0_ = NULL;
			_tmp0_ = g_file_new_for_path (self->priv->filepath);
			_g_object_unref0 (self->priv->file);
			self->priv->file = _tmp0_;
		}
		_tmp1_ = _g_object_ref0 (self->priv->file);
		_g_object_unref0 (_result_);
		_result_ = _tmp1_;
		__finally22:
		g_static_rec_mutex_unlock (&self->priv->__lock_file);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (_result_);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	result = _result_;
	return result;
}


PhotoFileFormat photo_file_adapter_get_file_format (PhotoFileAdapter* self) {
	PhotoFileFormat result = 0;
	g_return_val_if_fail (IS_PHOTO_FILE_ADAPTER (self), 0);
	result = self->priv->file_format;
	return result;
}


static void value_photo_file_adapter_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void value_photo_file_adapter_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		photo_file_adapter_unref (value->data[0].v_pointer);
	}
}


static void value_photo_file_adapter_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = photo_file_adapter_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer value_photo_file_adapter_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* value_photo_file_adapter_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		PhotoFileAdapter* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = photo_file_adapter_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* value_photo_file_adapter_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoFileAdapter** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = photo_file_adapter_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* param_spec_photo_file_adapter (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecPhotoFileAdapter* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_FILE_ADAPTER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer value_get_photo_file_adapter (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_FILE_ADAPTER), NULL);
	return value->data[0].v_pointer;
}


void value_set_photo_file_adapter (GValue* value, gpointer v_object) {
	PhotoFileAdapter* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_FILE_ADAPTER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_FILE_ADAPTER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		photo_file_adapter_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		photo_file_adapter_unref (old);
	}
}


void value_take_photo_file_adapter (GValue* value, gpointer v_object) {
	PhotoFileAdapter* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_FILE_ADAPTER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_FILE_ADAPTER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		photo_file_adapter_unref (old);
	}
}


static void photo_file_adapter_class_init (PhotoFileAdapterClass * klass) {
	photo_file_adapter_parent_class = g_type_class_peek_parent (klass);
	PHOTO_FILE_ADAPTER_CLASS (klass)->finalize = photo_file_adapter_finalize;
	g_type_class_add_private (klass, sizeof (PhotoFileAdapterPrivate));
}


static void photo_file_adapter_instance_init (PhotoFileAdapter * self) {
	self->priv = PHOTO_FILE_ADAPTER_GET_PRIVATE (self);
	g_static_rec_mutex_init (&self->priv->__lock_file);
	self->priv->file = NULL;
	self->ref_count = 1;
}


static void photo_file_adapter_finalize (PhotoFileAdapter* obj) {
	PhotoFileAdapter * self;
	self = PHOTO_FILE_ADAPTER (obj);
	_g_free0 (self->priv->filepath);
	g_static_rec_mutex_free (&self->priv->__lock_file);
	_g_object_unref0 (self->priv->file);
}


GType photo_file_adapter_get_type (void) {
	static volatile gsize photo_file_adapter_type_id__volatile = 0;
	if (g_once_init_enter (&photo_file_adapter_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_photo_file_adapter_init, value_photo_file_adapter_free_value, value_photo_file_adapter_copy_value, value_photo_file_adapter_peek_pointer, "p", value_photo_file_adapter_collect_value, "p", value_photo_file_adapter_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoFileAdapterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_file_adapter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoFileAdapter), 0, (GInstanceInitFunc) photo_file_adapter_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_file_adapter_type_id;
		photo_file_adapter_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoFileAdapter", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_file_adapter_type_id__volatile, photo_file_adapter_type_id);
	}
	return photo_file_adapter_type_id__volatile;
}


gpointer photo_file_adapter_ref (gpointer instance) {
	PhotoFileAdapter* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void photo_file_adapter_unref (gpointer instance) {
	PhotoFileAdapter* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PHOTO_FILE_ADAPTER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


PhotoFileReader* photo_file_reader_construct (GType object_type, const gchar* filepath, PhotoFileFormat file_format) {
	PhotoFileReader* self = NULL;
	g_return_val_if_fail (filepath != NULL, NULL);
	self = (PhotoFileReader*) photo_file_adapter_construct (object_type, filepath, file_format);
	return self;
}


PhotoFileWriter* photo_file_reader_create_writer (PhotoFileReader* self, GError** error) {
	PhotoFileWriter* result = NULL;
	PhotoFileFormat _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	PhotoFileWriter* _tmp3_ = NULL;
	PhotoFileWriter* _tmp4_;
	PhotoFileWriter* _tmp5_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO_FILE_READER (self), NULL);
	_tmp0_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (self));
	_tmp1_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (self));
	_tmp2_ = _tmp1_;
	_tmp3_ = photo_file_format_create_writer (_tmp0_, _tmp2_, &_inner_error_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	_tmp5_ = _tmp4_;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == PHOTO_FORMAT_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	result = _tmp5_;
	return result;
}


PhotoFileMetadataWriter* photo_file_reader_create_metadata_writer (PhotoFileReader* self, GError** error) {
	PhotoFileMetadataWriter* result = NULL;
	PhotoFileFormat _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	PhotoFileMetadataWriter* _tmp3_ = NULL;
	PhotoFileMetadataWriter* _tmp4_;
	PhotoFileMetadataWriter* _tmp5_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO_FILE_READER (self), NULL);
	_tmp0_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (self));
	_tmp1_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (self));
	_tmp2_ = _tmp1_;
	_tmp3_ = photo_file_format_create_metadata_writer (_tmp0_, _tmp2_, &_inner_error_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	_tmp5_ = _tmp4_;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == PHOTO_FORMAT_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	result = _tmp5_;
	return result;
}


static PhotoMetadata* photo_file_reader_real_read_metadata (PhotoFileReader* self, GError** error) {
	g_return_val_if_fail (IS_PHOTO_FILE_READER (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `photo_file_reader_read_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


PhotoMetadata* photo_file_reader_read_metadata (PhotoFileReader* self, GError** error) {
	return PHOTO_FILE_READER_GET_CLASS (self)->read_metadata (self, error);
}


static GdkPixbuf* photo_file_reader_real_unscaled_read (PhotoFileReader* self, GError** error) {
	g_return_val_if_fail (IS_PHOTO_FILE_READER (self), NULL);
	g_critical ("Type `%s' does not implement abstract method `photo_file_reader_unscaled_read'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


GdkPixbuf* photo_file_reader_unscaled_read (PhotoFileReader* self, GError** error) {
	return PHOTO_FILE_READER_GET_CLASS (self)->unscaled_read (self, error);
}


static GdkPixbuf* photo_file_reader_real_scaled_read (PhotoFileReader* self, Dimensions* full, Dimensions* scaled, GError** error) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_ = NULL;
	GdkPixbuf* _tmp4_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_PHOTO_FILE_READER (self), NULL);
	_tmp0_ = photo_file_reader_unscaled_read (self, &_inner_error_);
	_tmp1_ = _tmp0_;
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	_tmp2_ = _tmp1_;
	_tmp3_ = resize_pixbuf (_tmp2_, scaled, GDK_INTERP_BILINEAR);
	_tmp4_ = _tmp3_;
	_g_object_unref0 (_tmp2_);
	result = _tmp4_;
	return result;
}


GdkPixbuf* photo_file_reader_scaled_read (PhotoFileReader* self, Dimensions* full, Dimensions* scaled, GError** error) {
	return PHOTO_FILE_READER_GET_CLASS (self)->scaled_read (self, full, scaled, error);
}


static void photo_file_reader_class_init (PhotoFileReaderClass * klass) {
	photo_file_reader_parent_class = g_type_class_peek_parent (klass);
	PHOTO_FILE_READER_CLASS (klass)->read_metadata = photo_file_reader_real_read_metadata;
	PHOTO_FILE_READER_CLASS (klass)->unscaled_read = photo_file_reader_real_unscaled_read;
	PHOTO_FILE_READER_CLASS (klass)->scaled_read = photo_file_reader_real_scaled_read;
}


static void photo_file_reader_instance_init (PhotoFileReader * self) {
}


GType photo_file_reader_get_type (void) {
	static volatile gsize photo_file_reader_type_id__volatile = 0;
	if (g_once_init_enter (&photo_file_reader_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoFileReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_file_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoFileReader), 0, (GInstanceInitFunc) photo_file_reader_instance_init, NULL };
		GType photo_file_reader_type_id;
		photo_file_reader_type_id = g_type_register_static (TYPE_PHOTO_FILE_ADAPTER, "PhotoFileReader", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_file_reader_type_id__volatile, photo_file_reader_type_id);
	}
	return photo_file_reader_type_id__volatile;
}


PhotoFileWriter* photo_file_writer_construct (GType object_type, const gchar* filepath, PhotoFileFormat file_format) {
	PhotoFileWriter* self = NULL;
	g_return_val_if_fail (filepath != NULL, NULL);
	self = (PhotoFileWriter*) photo_file_adapter_construct (object_type, filepath, file_format);
	return self;
}


PhotoFileReader* photo_file_writer_create_reader (PhotoFileWriter* self) {
	PhotoFileReader* result = NULL;
	PhotoFileFormat _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	PhotoFileReader* _tmp3_ = NULL;
	PhotoFileReader* _tmp4_;
	g_return_val_if_fail (IS_PHOTO_FILE_WRITER (self), NULL);
	_tmp0_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (self));
	_tmp1_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (self));
	_tmp2_ = _tmp1_;
	_tmp3_ = photo_file_format_create_reader (_tmp0_, _tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}


static void photo_file_writer_real_write (PhotoFileWriter* self, GdkPixbuf* pixbuf, JpegQuality quality, GError** error) {
	g_return_if_fail (IS_PHOTO_FILE_WRITER (self));
	g_critical ("Type `%s' does not implement abstract method `photo_file_writer_write'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void photo_file_writer_write (PhotoFileWriter* self, GdkPixbuf* pixbuf, JpegQuality quality, GError** error) {
	PHOTO_FILE_WRITER_GET_CLASS (self)->write (self, pixbuf, quality, error);
}


static void photo_file_writer_class_init (PhotoFileWriterClass * klass) {
	photo_file_writer_parent_class = g_type_class_peek_parent (klass);
	PHOTO_FILE_WRITER_CLASS (klass)->write = photo_file_writer_real_write;
}


static void photo_file_writer_instance_init (PhotoFileWriter * self) {
}


GType photo_file_writer_get_type (void) {
	static volatile gsize photo_file_writer_type_id__volatile = 0;
	if (g_once_init_enter (&photo_file_writer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoFileWriterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_file_writer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoFileWriter), 0, (GInstanceInitFunc) photo_file_writer_instance_init, NULL };
		GType photo_file_writer_type_id;
		photo_file_writer_type_id = g_type_register_static (TYPE_PHOTO_FILE_ADAPTER, "PhotoFileWriter", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_file_writer_type_id__volatile, photo_file_writer_type_id);
	}
	return photo_file_writer_type_id__volatile;
}


PhotoFileMetadataWriter* photo_file_metadata_writer_construct (GType object_type, const gchar* filepath, PhotoFileFormat file_format) {
	PhotoFileMetadataWriter* self = NULL;
	g_return_val_if_fail (filepath != NULL, NULL);
	self = (PhotoFileMetadataWriter*) photo_file_adapter_construct (object_type, filepath, file_format);
	return self;
}


PhotoFileReader* photo_file_metadata_writer_create_reader (PhotoFileMetadataWriter* self) {
	PhotoFileReader* result = NULL;
	PhotoFileFormat _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	PhotoFileReader* _tmp3_ = NULL;
	PhotoFileReader* _tmp4_;
	g_return_val_if_fail (IS_PHOTO_FILE_METADATA_WRITER (self), NULL);
	_tmp0_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (self));
	_tmp1_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (self));
	_tmp2_ = _tmp1_;
	_tmp3_ = photo_file_format_create_reader (_tmp0_, _tmp2_);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	result = _tmp4_;
	return result;
}


static void photo_file_metadata_writer_real_write_metadata (PhotoFileMetadataWriter* self, PhotoMetadata* metadata, GError** error) {
	g_return_if_fail (IS_PHOTO_FILE_METADATA_WRITER (self));
	g_critical ("Type `%s' does not implement abstract method `photo_file_metadata_writer_write_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


void photo_file_metadata_writer_write_metadata (PhotoFileMetadataWriter* self, PhotoMetadata* metadata, GError** error) {
	PHOTO_FILE_METADATA_WRITER_GET_CLASS (self)->write_metadata (self, metadata, error);
}


static void photo_file_metadata_writer_class_init (PhotoFileMetadataWriterClass * klass) {
	photo_file_metadata_writer_parent_class = g_type_class_peek_parent (klass);
	PHOTO_FILE_METADATA_WRITER_CLASS (klass)->write_metadata = photo_file_metadata_writer_real_write_metadata;
}


static void photo_file_metadata_writer_instance_init (PhotoFileMetadataWriter * self) {
}


GType photo_file_metadata_writer_get_type (void) {
	static volatile gsize photo_file_metadata_writer_type_id__volatile = 0;
	if (g_once_init_enter (&photo_file_metadata_writer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoFileMetadataWriterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_file_metadata_writer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoFileMetadataWriter), 0, (GInstanceInitFunc) photo_file_metadata_writer_instance_init, NULL };
		GType photo_file_metadata_writer_type_id;
		photo_file_metadata_writer_type_id = g_type_register_static (TYPE_PHOTO_FILE_ADAPTER, "PhotoFileMetadataWriter", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_file_metadata_writer_type_id__volatile, photo_file_metadata_writer_type_id);
	}
	return photo_file_metadata_writer_type_id__volatile;
}



