/* DirectoryMonitor.c generated by valac 0.12.1, the Vala compiler
 * generated from DirectoryMonitor.vala, do not modify */

/* Copyright 2009-2011 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/**/
/* DirectoryMonitor will monitor an entire directory for changes to all files and directories*/
/* within it.  It uses FileMonitor to monitor all directories it discovers at initialization*/
/* and reports changes to the files and directories just as FileMonitor reports them.  Subclasses*/
/* can override the notify_* methods to filter or monitor events before the signal is fired,*/
/* or can override the signals themselves to be notified afterwards.*/
/**/
/* start_discovery() must be called to initiate monitoring.  Directories and files will be reported*/
/* as they're discovered.  Directories will be monitored as they're discovered as well.  Discovery*/
/* can only be initiated once.*/
/**/
/* All signals are virtual and have a corresponding notify_* protected virtual function.*/
/* Subclasses can either override the notify or the signal to decide when they want to process*/
/* the event.*/
/**/
/* DirectoryMonitor also adds a level of intelligence to GLib's monitoring API.Because certain*/
/* file/directory events are decomposed by FileMonitor into more atomic events, it's difficult*/
/* to know when these "composed" events have occurred.  (For example, a file move is reported*/
/* as a DELETED event followed by a CREATED event, with no clue that the two are related.)  Later*/
/* versions added the MOVE event, but we can't rely on those being installed.  Also, documentation*/
/* suggests it's only available with certain back-ends.*/
/**/
/* DirectoryMonitor attempts to solve this by deducing when a set of events actually equals*/
/* a composite event.  It requires more memory in order to do this (i.e. it stores all files and*/
/* their information), but the trade-off is easier file/directory monitoring via familiar*/
/* semantics.*/
/**/
/* DirectoryMonitor also will synthesize events when normal monitor events don't produce expected*/
/* results.  For example, if a directory is moved out of DirectoryMonitor's root, it is reported*/
/* as a delete event, but none of its children are reported as deleted.  Similarly, a directory*/
/* rename can be captured as a move, but notifications for all its children are not fired and*/
/* are synthesized by DirectoryMonitor.  DirectoryMonitor will fire delete and move notifications*/
/* for all the directory's children in depth-first order.*/
/**/
/* In general, DirectoryMonitor attempts to preserve ordering of events, so that (for example) a*/
/* file-altered event doesn't fire before a file-created, and so on.*/
/**/
/* Because of these requirements, DirectoryMonitor maintains a FileInfo struct on all directories */
/* and files being monitored.  (It maintains the attributes gather during the discovery phase, i.e. */
/* SUPPLIED_ATTRIBUTES.)  This information can be retrieved via get_info(), get_file_id(), and*/
/* get_etag().  These calls can be made at any time; the information is stored before any signal*/
/* is fired.*/
/**/
/* Note that DirectoryMonitor currently only supports files and directories.  Other file types*/
/* (special, symbolic links, shortcuts, and mount points) are not supported.  It has been seen*/
/* when a temporary file is created for its file type to be reported as "unknown" and when it's*/
/* altered/deleted to be reported as a regular file.  This means it's possible for a file not to*/
/* be reported as discovered or created but to be reported as altered and/or deleted.*/
/**/
/* DirectoryMonitor can be configured to not recurse (in which case it only discovers/monitors*/
/* the root directory) and to not monitor (in which case only discovery occurs).*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DIRECTORY_MONITOR (directory_monitor_get_type ())
#define DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitor))
#define DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))
#define IS_DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DIRECTORY_MONITOR))
#define IS_DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DIRECTORY_MONITOR))
#define DIRECTORY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))

typedef struct _DirectoryMonitor DirectoryMonitor;
typedef struct _DirectoryMonitorClass DirectoryMonitorClass;
typedef struct _DirectoryMonitorPrivate DirectoryMonitorPrivate;

#define DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT (directory_monitor_query_info_queue_element_get_type ())
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElement))
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElementClass))
#define DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT))
#define DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT))
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElementClass))

typedef struct _DirectoryMonitorQueryInfoQueueElement DirectoryMonitorQueryInfoQueueElement;
typedef struct _DirectoryMonitorQueryInfoQueueElementClass DirectoryMonitorQueryInfoQueueElementClass;

#define DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP (directory_monitor_file_info_map_get_type ())
#define DIRECTORY_MONITOR_FILE_INFO_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMap))
#define DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMapClass))
#define DIRECTORY_MONITOR_IS_FILE_INFO_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP))
#define DIRECTORY_MONITOR_IS_FILE_INFO_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP))
#define DIRECTORY_MONITOR_FILE_INFO_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMapClass))

typedef struct _DirectoryMonitorFileInfoMap DirectoryMonitorFileInfoMap;
typedef struct _DirectoryMonitorFileInfoMapClass DirectoryMonitorFileInfoMapClass;

#define DIRECTORY_MONITOR_TYPE_FTYPE (directory_monitor_ftype_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _directory_monitor_file_info_map_unref0(var) ((var == NULL) ? NULL : (var = (directory_monitor_file_info_map_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _DirectoryMonitorAsyncInternalNotifyDirectoryMovedData DirectoryMonitorAsyncInternalNotifyDirectoryMovedData;
typedef struct _DirectoryMonitorAsyncNotifyDirectoryDeletedData DirectoryMonitorAsyncNotifyDirectoryDeletedData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
typedef struct _DirectoryMonitorExploreAsyncData DirectoryMonitorExploreAsyncData;
typedef struct _DirectoryMonitorNotifyDirectoryFilesData DirectoryMonitorNotifyDirectoryFilesData;
typedef struct _DirectoryMonitorQueryInfoQueueElementPrivate DirectoryMonitorQueryInfoQueueElementPrivate;
#define _directory_monitor_query_info_queue_element_unref0(var) ((var == NULL) ? NULL : (var = (directory_monitor_query_info_queue_element_unref (var), NULL)))
typedef struct _DirectoryMonitorParamSpecQueryInfoQueueElement DirectoryMonitorParamSpecQueryInfoQueueElement;
typedef struct _DirectoryMonitorFileInfoMapPrivate DirectoryMonitorFileInfoMapPrivate;
typedef struct _DirectoryMonitorParamSpecFileInfoMap DirectoryMonitorParamSpecFileInfoMap;

struct _DirectoryMonitor {
	GObject parent_instance;
	DirectoryMonitorPrivate * priv;
};

struct _DirectoryMonitorClass {
	GObjectClass parent_class;
	void (*notify_root_deleted) (DirectoryMonitor* self, GFile* root);
	void (*notify_root_moved) (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
	void (*notify_discovery_started) (DirectoryMonitor* self);
	void (*internal_notify_file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*internal_notify_directory_discovered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_discovered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_discovery_failed) (DirectoryMonitor* self, const gchar* reason);
	void (*notify_discovery_completed) (DirectoryMonitor* self);
	void (*notify_file_created) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_moved) (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
	void (*notify_file_altered) (DirectoryMonitor* self, GFile* file);
	void (*notify_file_alteration_completed) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_attributes_altered) (DirectoryMonitor* self, GFile* file);
	void (*notify_file_deleted) (DirectoryMonitor* self, GFile* file);
	void (*notify_directory_created) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_moved) (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
	void (*notify_directory_altered) (DirectoryMonitor* self, GFile* dir);
	void (*notify_directory_alteration_completed) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_attributes_altered) (DirectoryMonitor* self, GFile* dir);
	void (*notify_directory_deleted) (DirectoryMonitor* self, GFile* dir);
	void (*notify_closed) (DirectoryMonitor* self);
	void (*close) (DirectoryMonitor* self);
	void (*root_moved) (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
	void (*root_deleted) (DirectoryMonitor* self, GFile* root);
	void (*discovery_started) (DirectoryMonitor* self);
	void (*file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*directory_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*discovery_failed) (DirectoryMonitor* self, const gchar* reason);
	void (*discovery_completed) (DirectoryMonitor* self);
	void (*file_created) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_moved) (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
	void (*file_altered) (DirectoryMonitor* self, GFile* file);
	void (*file_alteration_completed) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_attributes_altered) (DirectoryMonitor* self, GFile* file);
	void (*file_deleted) (DirectoryMonitor* self, GFile* file);
	void (*directory_created) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_moved) (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
	void (*directory_altered) (DirectoryMonitor* self, GFile* dir);
	void (*directory_alteration_completed) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_attributes_altered) (DirectoryMonitor* self, GFile* dir);
	void (*directory_deleted) (DirectoryMonitor* self, GFile* dir);
	void (*closed) (DirectoryMonitor* self);
};

struct _DirectoryMonitorPrivate {
	GFile* root;
	gboolean recurse;
	gboolean monitoring;
	GeeHashMap* monitors;
	GeeQueue* query_info_queue;
	DirectoryMonitorFileInfoMap* files;
	DirectoryMonitorFileInfoMap* parent_moved;
	GCancellable* cancellable;
	gint outstanding_exploration_dirs;
	gboolean started;
	gboolean has_discovery_started;
	guint delete_timer_id;
};

typedef enum  {
	DIRECTORY_MONITOR_FTYPE_FILE,
	DIRECTORY_MONITOR_FTYPE_DIRECTORY,
	DIRECTORY_MONITOR_FTYPE_UNSUPPORTED
} DirectoryMonitorFType;

struct _DirectoryMonitorAsyncInternalNotifyDirectoryMovedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	DirectoryMonitor* self;
	GFile* old_dir;
	GFileInfo* old_dir_info;
	GFile* new_dir;
	GFileInfo* new_dir_info;
	GeeArrayList* _tmp0_;
	GeeArrayList* file_children;
	GeeArrayList* _tmp1_;
	GeeArrayList* dir_children;
	gint _tmp2_;
	gint count;
	GeeArrayList* _tmp3_;
	GeeArrayList* _dir_child_list;
	gint _tmp4_;
	gint _dir_child_size;
	gint _dir_child_index;
	gpointer _tmp5_;
	GFile* dir_child;
	GFileInfo* _tmp6_;
	GFileInfo* dir_info;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GeeArrayList* _tmp13_;
	GeeArrayList* _file_child_list;
	gint _tmp14_;
	gint _file_child_size;
	gint _file_child_index;
	gpointer _tmp15_;
	GFile* file_child;
	GFileInfo* _tmp16_;
	GFileInfo* file_info;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GFile* _tmp21_;
	GFile* _tmp22_;
	gboolean _tmp23_;
	gboolean updated;
};

struct _DirectoryMonitorAsyncNotifyDirectoryDeletedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	DirectoryMonitor* self;
	GFile* dir;
	gboolean already_removed;
	GeeArrayList* _tmp0_;
	GeeArrayList* file_children;
	GeeArrayList* _tmp1_;
	GeeArrayList* dir_children;
	gint _tmp2_;
	gint count;
	GeeArrayList* _tmp3_;
	GeeArrayList* _dir_child_list;
	gint _tmp4_;
	gint _dir_child_size;
	gint _dir_child_index;
	gpointer _tmp5_;
	GFile* dir_child;
	GeeArrayList* _tmp6_;
	GeeArrayList* _file_child_list;
	gint _tmp7_;
	gint _file_child_size;
	gint _file_child_index;
	gpointer _tmp8_;
	GFile* file_child;
};

struct _DirectoryMonitorExploreAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	DirectoryMonitor* self;
	GFile* dir;
	GFileInfo* dir_info;
	gboolean in_discovery;
	gboolean _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GFileInfo* _tmp3_;
	GFileInfo* local_dir_info;
	GFileInfo* _tmp4_;
	GFileInfo* _tmp5_;
	GError * err;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gboolean _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GFileType _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	GFileType _tmp20_;
	GEnumValue* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	GeeHashMap* dir_map;
	GeeHashMap* file_map;
	GFileEnumerator* _tmp24_;
	GFileEnumerator* enumerator;
	gboolean _tmp25_;
	GList* _tmp26_;
	GList* infos;
	GList* info_collection;
	GList* info_it;
	GFileInfo* _tmp27_;
	GFileInfo* info;
	gboolean _tmp28_;
	const gchar* _tmp29_;
	GFile* _tmp30_;
	GFile* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gboolean _tmp34_;
	GFileType _tmp35_;
	GeeHashMap* _tmp36_;
	const gchar* _tmp37_;
	GFile* _tmp38_;
	GFile* _tmp39_;
	GeeHashMap* _tmp40_;
	const gchar* _tmp41_;
	GFile* _tmp42_;
	GFile* _tmp43_;
	GError * err2;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gboolean _tmp46_;
	GeeSet* _tmp47_;
	GeeSet* _tmp48_;
	GeeIterator* _tmp49_;
	GeeIterator* _tmp50_;
	GeeIterator* _subdir_it;
	gboolean _tmp51_;
	gpointer _tmp52_;
	GFile* subdir;
	gpointer _tmp53_;
	GFileInfo* _tmp54_;
	gpointer _tmp55_;
	GFileInfo* _tmp56_;
	GError * _inner_error_;
};

struct _DirectoryMonitorNotifyDirectoryFilesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	DirectoryMonitor* self;
	GeeMap* map;
	gboolean in_discovery;
	GeeMapIterator* _tmp0_;
	GeeMapIterator* iter;
	gboolean _tmp1_;
	gpointer _tmp2_;
	GFile* _tmp3_;
	gpointer _tmp4_;
	GFileInfo* _tmp5_;
	gpointer _tmp6_;
	GFile* _tmp7_;
	gpointer _tmp8_;
	GFileInfo* _tmp9_;
};

struct _DirectoryMonitorQueryInfoQueueElement {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DirectoryMonitorQueryInfoQueueElementPrivate * priv;
	DirectoryMonitor* owner;
	GFile* file;
	GFile* other_file;
	GFileMonitorEvent event;
	guint position;
	gulong time_created_msec;
	GFileInfo* info;
	GError* err;
	gboolean completed;
};

struct _DirectoryMonitorQueryInfoQueueElementClass {
	GTypeClass parent_class;
	void (*finalize) (DirectoryMonitorQueryInfoQueueElement *self);
};

struct _DirectoryMonitorParamSpecQueryInfoQueueElement {
	GParamSpec parent_instance;
};

struct _DirectoryMonitorFileInfoMap {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DirectoryMonitorFileInfoMapPrivate * priv;
};

struct _DirectoryMonitorFileInfoMapClass {
	GTypeClass parent_class;
	void (*finalize) (DirectoryMonitorFileInfoMap *self);
};

struct _DirectoryMonitorFileInfoMapPrivate {
	GeeHashMap* map;
	GeeHashMap* id_map;
};

struct _DirectoryMonitorParamSpecFileInfoMap {
	GParamSpec parent_instance;
};


static gpointer directory_monitor_parent_class = NULL;
static gpointer directory_monitor_query_info_queue_element_parent_class = NULL;
static guint directory_monitor_query_info_queue_element_current;
static guint directory_monitor_query_info_queue_element_current = (guint) 0;
static gpointer directory_monitor_file_info_map_parent_class = NULL;

GType directory_monitor_get_type (void) G_GNUC_CONST;
static gpointer directory_monitor_query_info_queue_element_ref (gpointer instance);
static void directory_monitor_query_info_queue_element_unref (gpointer instance);
static GParamSpec* directory_monitor_param_spec_query_info_queue_element (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void directory_monitor_value_set_query_info_queue_element (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void directory_monitor_value_take_query_info_queue_element (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer directory_monitor_value_get_query_info_queue_element (const GValue* value) G_GNUC_UNUSED;
static GType directory_monitor_query_info_queue_element_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gpointer directory_monitor_file_info_map_ref (gpointer instance);
static void directory_monitor_file_info_map_unref (gpointer instance);
static GParamSpec* directory_monitor_param_spec_file_info_map (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void directory_monitor_value_set_file_info_map (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void directory_monitor_value_take_file_info_map (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer directory_monitor_value_get_file_info_map (const GValue* value) G_GNUC_UNUSED;
static GType directory_monitor_file_info_map_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define DIRECTORY_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DIRECTORY_MONITOR, DirectoryMonitorPrivate))
enum  {
	DIRECTORY_MONITOR_DUMMY_PROPERTY
};
static GType directory_monitor_ftype_get_type (void) G_GNUC_UNUSED;
static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_new (void);
static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_construct (GType object_type);
#define DIRECTORY_MONITOR_DEFAULT_PRIORITY G_PRIORITY_LOW
#define DIRECTORY_MONITOR_DIR_INFO_FLAGS G_FILE_QUERY_INFO_NONE
#define DIRECTORY_MONITOR_FILE_INFO_FLAGS G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS
#define DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS G_FILE_QUERY_INFO_NONE
#define DIRECTORY_MONITOR_SUPPORT_DIR_SYMLINKS TRUE
#define DIRECTORY_MONITOR_SUPPORT_FILE_SYMLINKS FALSE
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
#define DIRECTORY_MONITOR_FILE_MONITOR_FLAGS G_FILE_MONITOR_SEND_MOVED
#define DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC ((guint) 500)
#define DIRECTORY_MONITOR_MAX_EXPLORATION_DIRS 5
DirectoryMonitor* directory_monitor_new (GFile* root, gboolean recurse, gboolean monitoring);
DirectoryMonitor* directory_monitor_construct (GType object_type, GFile* root, gboolean recurse, gboolean monitoring);
void directory_monitor_mdbg (const gchar* msg);
gboolean directory_monitor_is_recursive (DirectoryMonitor* self);
gboolean directory_monitor_is_monitoring (DirectoryMonitor* self);
void directory_monitor_notify_root_deleted (DirectoryMonitor* self, GFile* root);
static void directory_monitor_real_notify_root_deleted (DirectoryMonitor* self, GFile* root);
static void directory_monitor_internal_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
static gboolean directory_monitor_file_info_map_remove (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
static gboolean directory_monitor_file_info_map_update (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
static void directory_monitor_real_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
void directory_monitor_notify_discovery_started (DirectoryMonitor* self);
static void directory_monitor_real_notify_discovery_started (DirectoryMonitor* self);
void directory_monitor_internal_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_internal_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_internal_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_internal_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_discovery_failed (DirectoryMonitor* self, const gchar* reason);
static void directory_monitor_real_notify_discovery_failed (DirectoryMonitor* self, const gchar* reason);
void directory_monitor_notify_discovery_completed (DirectoryMonitor* self);
static void directory_monitor_real_notify_discovery_completed (DirectoryMonitor* self);
static void directory_monitor_internal_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static gboolean directory_monitor_is_file_create_move (DirectoryMonitor* self, GFile* file, GFileInfo* info, GFile** old_file, GFileInfo** old_file_info);
static void directory_monitor_internal_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
void directory_monitor_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
static void directory_monitor_real_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
void directory_monitor_notify_file_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_notify_file_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_internal_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_internal_notify_file_deleted (DirectoryMonitor* self, GFile* file);
void directory_monitor_notify_file_deleted (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_notify_file_deleted (DirectoryMonitor* self, GFile* file);
static void directory_monitor_internal_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_file_info_map_remove_descendents (DirectoryMonitorFileInfoMap* self, GFile* root, DirectoryMonitorFileInfoMap* descendents);
static void directory_monitor_internal_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFileInfo* old_dir_info, GFile* new_dir, GFileInfo* new_dir_info);
void directory_monitor_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_async_internal_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFileInfo* old_dir_info, GFile* new_dir, GFileInfo* new_dir_info, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void directory_monitor_async_internal_notify_directory_moved_finish (DirectoryMonitor* self, GAsyncResult* _res_);
static void directory_monitor_async_internal_notify_directory_moved_data_free (gpointer _data);
static gboolean directory_monitor_async_internal_notify_directory_moved_co (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* data);
static gint directory_monitor_file_info_map_get_children (DirectoryMonitorFileInfoMap* self, GFile* root, GeeCollection* files, GeeCollection* dirs);
static GFileInfo* directory_monitor_file_info_map_get_info (DirectoryMonitorFileInfoMap* self, GFile* file);
static void directory_monitor_async_internal_notify_directory_moved_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gboolean _directory_monitor_async_internal_notify_directory_moved_co_gsource_func (gpointer self);
static gboolean directory_monitor_remove_monitor (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static gboolean directory_monitor_add_monitor (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
static void directory_monitor_real_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
void directory_monitor_notify_directory_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_notify_directory_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_internal_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_directory_attributes_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_notify_directory_attributes_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_internal_notify_directory_deleted (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_async_notify_directory_deleted (DirectoryMonitor* self, GFile* dir, gboolean already_removed, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void directory_monitor_async_notify_directory_deleted_finish (DirectoryMonitor* self, GAsyncResult* _res_);
static void directory_monitor_async_notify_directory_deleted_data_free (gpointer _data);
static gboolean directory_monitor_async_notify_directory_deleted_co (DirectoryMonitorAsyncNotifyDirectoryDeletedData* data);
static void directory_monitor_async_notify_directory_deleted_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gboolean _directory_monitor_async_notify_directory_deleted_co_gsource_func (gpointer self);
void directory_monitor_notify_directory_deleted (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_notify_directory_deleted (DirectoryMonitor* self, GFile* dir);
void directory_monitor_notify_closed (DirectoryMonitor* self);
static void directory_monitor_real_notify_closed (DirectoryMonitor* self);
GFile* directory_monitor_get_root (DirectoryMonitor* self);
gboolean directory_monitor_is_in_root (DirectoryMonitor* self, GFile* file);
gboolean directory_monitor_has_started (DirectoryMonitor* self);
void directory_monitor_start_discovery (DirectoryMonitor* self);
static void directory_monitor_explore_async (DirectoryMonitor* self, GFile* dir, GFileInfo* dir_info, gboolean in_discovery, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void directory_monitor_explore_finish (DirectoryMonitor* self, GAsyncResult* _res_);
void directory_monitor_close (DirectoryMonitor* self);
static void directory_monitor_real_close (DirectoryMonitor* self);
static void directory_monitor_cancel_monitor (DirectoryMonitor* self, GFileMonitor* monitor);
static DirectoryMonitorFType directory_monitor_get_ftype (GFileInfo* info);
const gchar* g_file_type_to_string (GFileType self);
static void directory_monitor_explore_async_data_free (gpointer _data);
static gboolean directory_monitor_explore_async_co (DirectoryMonitorExploreAsyncData* data);
static gboolean directory_monitor_file_info_map_contains (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
static void directory_monitor_explore_directory_completed (DirectoryMonitor* self, gboolean in_discovery);
static void directory_monitor_explore_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
gchar* get_file_info_id (GFileInfo* info);
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
gboolean directory_monitor_is_file_symlink_supported (GFileInfo* info);
static void directory_monitor_notify_directory_files (DirectoryMonitor* self, GeeMap* map, gboolean in_discovery, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void directory_monitor_notify_directory_files_finish (DirectoryMonitor* self, GAsyncResult* _res_);
static void directory_monitor_notify_directory_files_data_free (gpointer _data);
static gboolean directory_monitor_notify_directory_files_co (DirectoryMonitorNotifyDirectoryFilesData* data);
static gboolean _directory_monitor_notify_directory_files_co_gsource_func (gpointer self);
static gchar* directory_monitor_file_info_map_get_id (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
static void directory_monitor_on_monitor_notification (DirectoryMonitor* self, GFile* file, GFile* other_file, GFileMonitorEvent event);
static void _directory_monitor_on_monitor_notification_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self);
const gchar* g_file_monitor_event_to_string (GFileMonitorEvent self);
static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_new (DirectoryMonitor* owner, GFile* file, GFile* other_file, GFileMonitorEvent event);
static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_construct (GType object_type, DirectoryMonitor* owner, GFile* file, GFile* other_file, GFileMonitorEvent event);
static void directory_monitor_query_info_queue_element_on_completed (DirectoryMonitorQueryInfoQueueElement* self, GObject* source, GAsyncResult* aresult);
static void _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static gboolean directory_monitor_check_for_expired_delete_events (DirectoryMonitor* self);
static gboolean _directory_monitor_check_for_expired_delete_events_gsource_func (gpointer self);
static void directory_monitor_process_query_queue (DirectoryMonitor* self, DirectoryMonitorQueryInfoQueueElement* query_info);
static GFile* directory_monitor_file_info_map_find_match (DirectoryMonitorFileInfoMap* self, GFileInfo* match);
static void directory_monitor_on_monitor_notification_ready (DirectoryMonitor* self, GFile* file, GFile* other_file, GFileInfo* info, GFileMonitorEvent event);
GFileInfo* directory_monitor_get_file_info (DirectoryMonitor* self, GFile* file);
gulong now_ms (void);
GeeCollection* directory_monitor_get_files (DirectoryMonitor* self);
static GeeCollection* directory_monitor_file_info_map_get_all (DirectoryMonitorFileInfoMap* self);
GFileInfo* directory_monitor_query_file_info (DirectoryMonitor* self, GFile* file);
static GFileInfo* directory_monitor_file_info_map_query_info (DirectoryMonitorFileInfoMap* self, GFile* file, GCancellable* cancellable);
void directory_monitor_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
static void directory_monitor_real_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
void directory_monitor_root_deleted (DirectoryMonitor* self, GFile* root);
static void directory_monitor_real_root_deleted (DirectoryMonitor* self, GFile* root);
void directory_monitor_discovery_started (DirectoryMonitor* self);
static void directory_monitor_real_discovery_started (DirectoryMonitor* self);
void directory_monitor_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
void directory_monitor_directory_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_directory_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_discovery_failed (DirectoryMonitor* self, const gchar* reason);
static void directory_monitor_real_discovery_failed (DirectoryMonitor* self, const gchar* reason);
void directory_monitor_discovery_completed (DirectoryMonitor* self);
static void directory_monitor_real_discovery_completed (DirectoryMonitor* self);
void directory_monitor_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
static void directory_monitor_real_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
void directory_monitor_file_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_file_altered (DirectoryMonitor* self, GFile* file);
void directory_monitor_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_file_attributes_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_file_attributes_altered (DirectoryMonitor* self, GFile* file);
void directory_monitor_file_deleted (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_file_deleted (DirectoryMonitor* self, GFile* file);
void directory_monitor_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
static void directory_monitor_real_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
void directory_monitor_directory_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_directory_altered (DirectoryMonitor* self, GFile* dir);
void directory_monitor_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_directory_attributes_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_directory_attributes_altered (DirectoryMonitor* self, GFile* dir);
void directory_monitor_directory_deleted (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_directory_deleted (DirectoryMonitor* self, GFile* dir);
void directory_monitor_closed (DirectoryMonitor* self);
static void directory_monitor_real_closed (DirectoryMonitor* self);
enum  {
	DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_DUMMY_PROPERTY
};
static void directory_monitor_query_info_queue_element_finalize (DirectoryMonitorQueryInfoQueueElement* obj);
#define DIRECTORY_MONITOR_FILE_INFO_MAP_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMapPrivate))
enum  {
	DIRECTORY_MONITOR_FILE_INFO_MAP_DUMMY_PROPERTY
};
static gboolean directory_monitor_file_info_map_normalize_file (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info, GFile** normalized, gchar** id);
static void directory_monitor_file_info_map_remove_all (DirectoryMonitorFileInfoMap* self, GeeCollection* files);
static void directory_monitor_file_info_map_finalize (DirectoryMonitorFileInfoMap* obj);
static void directory_monitor_finalize (GObject* obj);


static GType directory_monitor_ftype_get_type (void) {
	static volatile gsize directory_monitor_ftype_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_ftype_type_id__volatile)) {
		static const GEnumValue values[] = {{DIRECTORY_MONITOR_FTYPE_FILE, "DIRECTORY_MONITOR_FTYPE_FILE", "file"}, {DIRECTORY_MONITOR_FTYPE_DIRECTORY, "DIRECTORY_MONITOR_FTYPE_DIRECTORY", "directory"}, {DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "DIRECTORY_MONITOR_FTYPE_UNSUPPORTED", "unsupported"}, {0, NULL, NULL}};
		GType directory_monitor_ftype_type_id;
		directory_monitor_ftype_type_id = g_enum_register_static ("DirectoryMonitorFType", values);
		g_once_init_leave (&directory_monitor_ftype_type_id__volatile, directory_monitor_ftype_type_id);
	}
	return directory_monitor_ftype_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


DirectoryMonitor* directory_monitor_construct (GType object_type, GFile* root, gboolean recurse, gboolean monitoring) {
	DirectoryMonitor * self = NULL;
	GFile* _tmp0_;
	g_return_val_if_fail (G_IS_FILE (root), NULL);
	self = (DirectoryMonitor*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (root);
	_g_object_unref0 (self->priv->root);
	self->priv->root = _tmp0_;
	self->priv->recurse = recurse;
	self->priv->monitoring = monitoring;
	return self;
}


DirectoryMonitor* directory_monitor_new (GFile* root, gboolean recurse, gboolean monitoring) {
	return directory_monitor_construct (TYPE_DIRECTORY_MONITOR, root, recurse, monitoring);
}


void directory_monitor_mdbg (const gchar* msg) {
	g_return_if_fail (msg != NULL);
}


gboolean directory_monitor_is_recursive (DirectoryMonitor* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
	result = self->priv->recurse;
	return result;
}


gboolean directory_monitor_is_monitoring (DirectoryMonitor* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
	result = self->priv->monitoring;
	return result;
}


static void directory_monitor_real_notify_root_deleted (DirectoryMonitor* self, GFile* root) {
	gboolean _tmp0_;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (root));
	_tmp0_ = g_file_equal (self->priv->root, root);
	g_assert (_tmp0_);
	directory_monitor_mdbg ("root deleted");
	g_signal_emit_by_name (self, "root-deleted", root);
}


void directory_monitor_notify_root_deleted (DirectoryMonitor* self, GFile* root) {
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_root_deleted (self, root);
}


static void directory_monitor_internal_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info) {
	gboolean _tmp0_;
	gboolean removed;
	gboolean _tmp1_;
	gboolean updated;
	GFile* _tmp2_;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (old_root));
	g_return_if_fail (G_IS_FILE (new_root));
	g_return_if_fail (G_IS_FILE_INFO (new_root_info));
	_tmp0_ = directory_monitor_file_info_map_remove (self->priv->files, old_root, NULL);
	removed = _tmp0_;
	g_assert (removed);
	_tmp1_ = directory_monitor_file_info_map_update (self->priv->files, new_root, new_root_info);
	updated = _tmp1_;
	g_assert (updated);
	_tmp2_ = _g_object_ref0 (new_root);
	_g_object_unref0 (self->priv->root);
	self->priv->root = _tmp2_;
	directory_monitor_notify_root_moved (self, old_root, new_root, new_root_info);
}


static void directory_monitor_real_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info) {
	gboolean _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (old_root));
	g_return_if_fail (G_IS_FILE (new_root));
	g_return_if_fail (G_IS_FILE_INFO (new_root_info));
	_tmp0_ = g_file_equal (self->priv->root, old_root);
	g_assert (_tmp0_);
	_tmp1_ = g_file_get_path (old_root);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_file_get_path (new_root);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strdup_printf ("root moved: %s -> %s", _tmp2_, _tmp4_);
	_tmp6_ = _tmp5_;
	directory_monitor_mdbg (_tmp6_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	g_signal_emit_by_name (self, "root-moved", old_root, new_root, new_root_info);
}


void directory_monitor_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info) {
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_root_moved (self, old_root, new_root, new_root_info);
}


static void directory_monitor_real_notify_discovery_started (DirectoryMonitor* self) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	directory_monitor_mdbg ("discovery started");
	g_signal_emit_by_name (self, "discovery-started");
}


void directory_monitor_notify_discovery_started (DirectoryMonitor* self) {
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_discovery_started (self);
}


static void directory_monitor_real_internal_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	gboolean _tmp0_;
	gboolean updated;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (file));
	g_return_if_fail (G_IS_FILE_INFO (info));
	_tmp0_ = directory_monitor_file_info_map_update (self->priv->files, file, info);
	updated = _tmp0_;
	g_assert (updated);
	directory_monitor_notify_file_discovered (self, file, info);
}


void directory_monitor_internal_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	DIRECTORY_MONITOR_GET_CLASS (self)->internal_notify_file_discovered (self, file, info);
}


static void directory_monitor_real_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (file));
	g_return_if_fail (G_IS_FILE_INFO (info));
	_tmp0_ = g_file_get_path (file);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("file discovered: %s", _tmp1_);
	_tmp3_ = _tmp2_;
	directory_monitor_mdbg (_tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	g_signal_emit_by_name (self, "file-discovered", file, info);
}


void directory_monitor_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_discovered (self, file, info);
}


static void directory_monitor_real_internal_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	gboolean _tmp0_;
	gboolean updated;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (dir));
	g_return_if_fail (G_IS_FILE_INFO (info));
	_tmp0_ = directory_monitor_file_info_map_update (self->priv->files, dir, info);
	updated = _tmp0_;
	g_assert (updated);
	directory_monitor_notify_directory_discovered (self, dir, info);
}


void directory_monitor_internal_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	DIRECTORY_MONITOR_GET_CLASS (self)->internal_notify_directory_discovered (self, dir, info);
}


static void directory_monitor_real_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (dir));
	g_return_if_fail (G_IS_FILE_INFO (info));
	_tmp0_ = g_file_get_path (dir);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("directory discovered: %s", _tmp1_);
	_tmp3_ = _tmp2_;
	directory_monitor_mdbg (_tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	g_signal_emit_by_name (self, "directory-discovered", dir, info);
}


void directory_monitor_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_discovered (self, dir, info);
}


static void directory_monitor_real_notify_discovery_failed (DirectoryMonitor* self, const gchar* reason) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (reason != NULL);
	g_warning ("DirectoryMonitor.vala:528: discovery failed: %s", reason);
	g_signal_emit_by_name (self, "discovery-failed", reason);
}


void directory_monitor_notify_discovery_failed (DirectoryMonitor* self, const gchar* reason) {
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_discovery_failed (self, reason);
}


static void directory_monitor_real_notify_discovery_completed (DirectoryMonitor* self) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_signal_emit_by_name (self, "discovery-completed");
}


void directory_monitor_notify_discovery_completed (DirectoryMonitor* self) {
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_discovery_completed (self);
}


static void directory_monitor_internal_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	GFile* old_file = NULL;
	GFileInfo* old_file_info = NULL;
	GFile* _tmp0_ = NULL;
	GFileInfo* _tmp1_ = NULL;
	gboolean _tmp2_;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (file));
	g_return_if_fail (G_IS_FILE_INFO (info));
	_tmp2_ = directory_monitor_is_file_create_move (self, file, info, &_tmp0_, &_tmp1_);
	_g_object_unref0 (old_file);
	old_file = _tmp0_;
	_g_object_unref0 (old_file_info);
	old_file_info = _tmp1_;
	if (_tmp2_) {
		directory_monitor_internal_notify_file_moved (self, old_file, file, info);
	} else {
		gboolean _tmp3_;
		gboolean updated;
		_tmp3_ = directory_monitor_file_info_map_update (self->priv->files, file, info);
		updated = _tmp3_;
		g_assert (updated);
		directory_monitor_notify_file_created (self, file, info);
	}
	_g_object_unref0 (old_file_info);
	_g_object_unref0 (old_file);
}


static void directory_monitor_real_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (file));
	g_return_if_fail (G_IS_FILE_INFO (info));
	_tmp0_ = g_file_get_path (file);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("file created: %s", _tmp1_);
	_tmp3_ = _tmp2_;
	directory_monitor_mdbg (_tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	g_signal_emit_by_name (self, "file-created", file, info);
}


void directory_monitor_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_created (self, file, info);
}


static void directory_monitor_internal_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info) {
	gboolean _tmp0_;
	gboolean updated;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (old_file));
	g_return_if_fail (G_IS_FILE (new_file));
	g_return_if_fail (G_IS_FILE_INFO (new_file_info));
	directory_monitor_file_info_map_remove (self->priv->files, old_file, NULL);
	_tmp0_ = directory_monitor_file_info_map_update (self->priv->files, new_file, new_file_info);
	updated = _tmp0_;
	g_assert (updated);
	directory_monitor_notify_file_moved (self, old_file, new_file, new_file_info);
}


static void directory_monitor_real_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (old_file));
	g_return_if_fail (G_IS_FILE (new_file));
	g_return_if_fail (G_IS_FILE_INFO (new_file_info));
	_tmp0_ = g_file_get_path (old_file);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_file_get_path (new_file);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strdup_printf ("file moved: %s -> %s", _tmp1_, _tmp3_);
	_tmp5_ = _tmp4_;
	directory_monitor_mdbg (_tmp5_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	g_signal_emit_by_name (self, "file-moved", old_file, new_file, new_file_info);
}


void directory_monitor_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info) {
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_moved (self, old_file, new_file, new_file_info);
}


static void directory_monitor_real_notify_file_altered (DirectoryMonitor* self, GFile* file) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (file));
	_tmp0_ = g_file_get_path (file);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("file altered: %s", _tmp1_);
	_tmp3_ = _tmp2_;
	directory_monitor_mdbg (_tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	g_signal_emit_by_name (self, "file-altered", file);
}


void directory_monitor_notify_file_altered (DirectoryMonitor* self, GFile* file) {
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_altered (self, file);
}


static void directory_monitor_internal_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	gboolean _tmp0_;
	gboolean updated;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (file));
	g_return_if_fail (G_IS_FILE_INFO (info));
	_tmp0_ = directory_monitor_file_info_map_update (self->priv->files, file, info);
	updated = _tmp0_;
	g_assert (updated);
	directory_monitor_notify_file_alteration_completed (self, file, info);
}


static void directory_monitor_real_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (file));
	g_return_if_fail (G_IS_FILE_INFO (info));
	_tmp0_ = g_file_get_path (file);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("file alteration completed: %s", _tmp1_);
	_tmp3_ = _tmp2_;
	directory_monitor_mdbg (_tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	g_signal_emit_by_name (self, "file-alteration-completed", file, info);
}


void directory_monitor_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_alteration_completed (self, file, info);
}


static void directory_monitor_real_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (file));
	_tmp0_ = g_file_get_path (file);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("file attributes altered: %s", _tmp1_);
	_tmp3_ = _tmp2_;
	directory_monitor_mdbg (_tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	g_signal_emit_by_name (self, "file-attributes-altered", file);
}


void directory_monitor_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file) {
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_attributes_altered (self, file);
}


static void directory_monitor_internal_notify_file_deleted (DirectoryMonitor* self, GFile* file) {
	gboolean _tmp0_;
	gboolean removed;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (file));
	_tmp0_ = directory_monitor_file_info_map_remove (self->priv->files, file, NULL);
	removed = _tmp0_;
	g_assert (removed);
	directory_monitor_notify_file_deleted (self, file);
}


static void directory_monitor_real_notify_file_deleted (DirectoryMonitor* self, GFile* file) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (file));
	_tmp0_ = g_file_get_path (file);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("file deleted: %s", _tmp1_);
	_tmp3_ = _tmp2_;
	directory_monitor_mdbg (_tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	g_signal_emit_by_name (self, "file-deleted", file);
}


void directory_monitor_notify_file_deleted (DirectoryMonitor* self, GFile* file) {
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_deleted (self, file);
}


static void directory_monitor_internal_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	GFile* old_dir = NULL;
	GFileInfo* old_dir_info = NULL;
	GFile* _tmp0_ = NULL;
	GFileInfo* _tmp1_ = NULL;
	gboolean _tmp2_;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (dir));
	g_return_if_fail (G_IS_FILE_INFO (info));
	_tmp2_ = directory_monitor_is_file_create_move (self, dir, info, &_tmp0_, &_tmp1_);
	_g_object_unref0 (old_dir);
	old_dir = _tmp0_;
	_g_object_unref0 (old_dir_info);
	old_dir_info = _tmp1_;
	if (_tmp2_) {
		directory_monitor_file_info_map_remove_descendents (self->priv->files, old_dir, self->priv->parent_moved);
		directory_monitor_internal_notify_directory_moved (self, old_dir, old_dir_info, dir, info);
	} else {
		gboolean _tmp3_;
		gboolean updated;
		_tmp3_ = directory_monitor_file_info_map_update (self->priv->files, dir, info);
		updated = _tmp3_;
		g_assert (updated);
		directory_monitor_notify_directory_created (self, dir, info);
	}
	_g_object_unref0 (old_dir_info);
	_g_object_unref0 (old_dir);
}


static void directory_monitor_real_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (dir));
	g_return_if_fail (G_IS_FILE_INFO (info));
	_tmp0_ = g_file_get_path (dir);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("directory created: %s", _tmp1_);
	_tmp3_ = _tmp2_;
	directory_monitor_mdbg (_tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	g_signal_emit_by_name (self, "directory-created", dir, info);
}


void directory_monitor_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_created (self, dir, info);
}


static void directory_monitor_internal_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFileInfo* old_dir_info, GFile* new_dir, GFileInfo* new_dir_info) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (old_dir));
	g_return_if_fail (G_IS_FILE_INFO (old_dir_info));
	g_return_if_fail (G_IS_FILE (new_dir));
	g_return_if_fail (G_IS_FILE_INFO (new_dir_info));
	directory_monitor_async_internal_notify_directory_moved (self, old_dir, old_dir_info, new_dir, new_dir_info, NULL, NULL);
}


static void directory_monitor_async_internal_notify_directory_moved_data_free (gpointer _data) {
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* data;
	data = _data;
	_g_object_unref0 (data->old_dir);
	_g_object_unref0 (data->old_dir_info);
	_g_object_unref0 (data->new_dir);
	_g_object_unref0 (data->new_dir_info);
	_g_object_unref0 (data->self);
	g_slice_free (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData, data);
}


static void directory_monitor_async_internal_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFileInfo* old_dir_info, GFile* new_dir, GFileInfo* new_dir_info, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
	_data_ = g_slice_new0 (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, directory_monitor_async_internal_notify_directory_moved);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, directory_monitor_async_internal_notify_directory_moved_data_free);
	_data_->self = _g_object_ref0 (self);
	_data_->old_dir = _g_object_ref0 (old_dir);
	_data_->old_dir_info = _g_object_ref0 (old_dir_info);
	_data_->new_dir = _g_object_ref0 (new_dir);
	_data_->new_dir_info = _g_object_ref0 (new_dir_info);
	directory_monitor_async_internal_notify_directory_moved_co (_data_);
}


static void directory_monitor_async_internal_notify_directory_moved_finish (DirectoryMonitor* self, GAsyncResult* _res_) {
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void directory_monitor_async_internal_notify_directory_moved_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* data;
	data = _user_data_;
	data->_source_object_ = source_object;
	data->_res_ = _res_;
	directory_monitor_async_internal_notify_directory_moved_co (data);
}


static gboolean _directory_monitor_async_internal_notify_directory_moved_co_gsource_func (gpointer self) {
	gboolean result;
	result = directory_monitor_async_internal_notify_directory_moved_co (self);
	return result;
}


static gboolean directory_monitor_async_internal_notify_directory_moved_co (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* data) {
	switch (data->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	data->_tmp0_ = NULL;
	data->_tmp0_ = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_equal);
	data->file_children = data->_tmp0_;
	data->_tmp1_ = NULL;
	data->_tmp1_ = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_equal);
	data->dir_children = data->_tmp1_;
	data->_tmp2_ = directory_monitor_file_info_map_get_children (data->self->priv->files, data->old_dir, GEE_COLLECTION (data->file_children), GEE_COLLECTION (data->dir_children));
	data->count = data->_tmp2_;
	if (data->count > 0) {
		{
			data->_tmp3_ = _g_object_ref0 (data->dir_children);
			data->_dir_child_list = data->_tmp3_;
			data->_tmp4_ = gee_collection_get_size (GEE_COLLECTION (data->_dir_child_list));
			data->_dir_child_size = data->_tmp4_;
			data->_dir_child_index = -1;
			while (TRUE) {
				data->_dir_child_index = data->_dir_child_index + 1;
				if (!(data->_dir_child_index < data->_dir_child_size)) {
					break;
				}
				data->_tmp5_ = NULL;
				data->_tmp5_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (data->_dir_child_list), data->_dir_child_index);
				data->dir_child = (GFile*) data->_tmp5_;
				data->_tmp6_ = NULL;
				data->_tmp6_ = directory_monitor_file_info_map_get_info (data->self->priv->files, data->dir_child);
				data->dir_info = data->_tmp6_;
				if (data->dir_info == NULL) {
					data->_tmp7_ = NULL;
					data->_tmp7_ = g_file_get_path (data->dir_child);
					data->_tmp8_ = data->_tmp7_;
					g_warning ("DirectoryMonitor.vala:646: Unable to retrieve directory-moved info for" \
" %s", data->_tmp8_);
					_g_free0 (data->_tmp8_);
					_g_object_unref0 (data->dir_info);
					_g_object_unref0 (data->dir_child);
					continue;
				}
				data->_tmp9_ = NULL;
				data->_tmp9_ = g_file_get_basename (data->dir_child);
				data->_tmp10_ = data->_tmp9_;
				data->_tmp11_ = NULL;
				data->_tmp11_ = g_file_get_child (data->new_dir, data->_tmp10_);
				data->_tmp12_ = data->_tmp11_;
				data->_state_ = 1;
				directory_monitor_async_internal_notify_directory_moved (data->self, data->dir_child, data->dir_info, data->_tmp12_, data->dir_info, directory_monitor_async_internal_notify_directory_moved_ready, data);
				return FALSE;
				_state_1:
				directory_monitor_async_internal_notify_directory_moved_finish (data->self, data->_res_);
				_g_object_unref0 (data->_tmp12_);
				_g_free0 (data->_tmp10_);
				_g_object_unref0 (data->dir_info);
				_g_object_unref0 (data->dir_child);
			}
			_g_object_unref0 (data->_dir_child_list);
		}
		{
			data->_tmp13_ = _g_object_ref0 (data->file_children);
			data->_file_child_list = data->_tmp13_;
			data->_tmp14_ = gee_collection_get_size (GEE_COLLECTION (data->_file_child_list));
			data->_file_child_size = data->_tmp14_;
			data->_file_child_index = -1;
			while (TRUE) {
				data->_file_child_index = data->_file_child_index + 1;
				if (!(data->_file_child_index < data->_file_child_size)) {
					break;
				}
				data->_tmp15_ = NULL;
				data->_tmp15_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (data->_file_child_list), data->_file_child_index);
				data->file_child = (GFile*) data->_tmp15_;
				data->_tmp16_ = NULL;
				data->_tmp16_ = directory_monitor_file_info_map_get_info (data->self->priv->files, data->file_child);
				data->file_info = data->_tmp16_;
				if (data->file_info == NULL) {
					data->_tmp17_ = NULL;
					data->_tmp17_ = g_file_get_path (data->file_child);
					data->_tmp18_ = data->_tmp17_;
					g_warning ("DirectoryMonitor.vala:659: Unable to retrieve directory-moved info for" \
" %s", data->_tmp18_);
					_g_free0 (data->_tmp18_);
					_g_object_unref0 (data->file_info);
					_g_object_unref0 (data->file_child);
					continue;
				}
				data->_tmp19_ = NULL;
				data->_tmp19_ = g_file_get_basename (data->file_child);
				data->_tmp20_ = data->_tmp19_;
				data->_tmp21_ = NULL;
				data->_tmp21_ = g_file_get_child (data->new_dir, data->_tmp20_);
				data->_tmp22_ = data->_tmp21_;
				directory_monitor_internal_notify_file_moved (data->self, data->file_child, data->_tmp22_, data->file_info);
				_g_object_unref0 (data->_tmp22_);
				_g_free0 (data->_tmp20_);
				g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _directory_monitor_async_internal_notify_directory_moved_co_gsource_func, data, NULL);
				data->_state_ = 2;
				return FALSE;
				_state_2:
				;
				_g_object_unref0 (data->file_info);
				_g_object_unref0 (data->file_child);
			}
			_g_object_unref0 (data->_file_child_list);
		}
	}
	directory_monitor_file_info_map_remove (data->self->priv->files, data->old_dir, NULL);
	data->_tmp23_ = directory_monitor_file_info_map_update (data->self->priv->files, data->new_dir, data->new_dir_info);
	data->updated = data->_tmp23_;
	g_assert (data->updated);
	directory_monitor_remove_monitor (data->self, data->old_dir, data->old_dir_info);
	directory_monitor_add_monitor (data->self, data->new_dir, data->new_dir_info);
	directory_monitor_notify_directory_moved (data->self, data->old_dir, data->new_dir, data->new_dir_info);
	_g_object_unref0 (data->dir_children);
	_g_object_unref0 (data->file_children);
	if (data->_state_ == 0) {
		g_simple_async_result_complete_in_idle (data->_async_result);
	} else {
		g_simple_async_result_complete (data->_async_result);
	}
	g_object_unref (data->_async_result);
	return FALSE;
}


static void directory_monitor_real_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gboolean _tmp6_;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (old_dir));
	g_return_if_fail (G_IS_FILE (new_dir));
	g_return_if_fail (G_IS_FILE_INFO (new_dir_info));
	_tmp0_ = g_file_get_path (old_dir);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_file_get_path (new_dir);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strdup_printf ("directory moved: %s -> %s", _tmp1_, _tmp3_);
	_tmp5_ = _tmp4_;
	directory_monitor_mdbg (_tmp5_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	g_signal_emit_by_name (self, "directory-moved", old_dir, new_dir, new_dir_info);
	_tmp6_ = g_file_equal (old_dir, self->priv->root);
	if (_tmp6_) {
		directory_monitor_internal_notify_root_moved (self, old_dir, new_dir, new_dir_info);
	}
}


void directory_monitor_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info) {
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_moved (self, old_dir, new_dir, new_dir_info);
}


static void directory_monitor_real_notify_directory_altered (DirectoryMonitor* self, GFile* dir) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (dir));
	_tmp0_ = g_file_get_path (dir);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("directory altered: %s", _tmp1_);
	_tmp3_ = _tmp2_;
	directory_monitor_mdbg (_tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	g_signal_emit_by_name (self, "directory-altered", dir);
}


void directory_monitor_notify_directory_altered (DirectoryMonitor* self, GFile* dir) {
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_altered (self, dir);
}


static void directory_monitor_internal_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	gboolean _tmp0_;
	gboolean updated;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (dir));
	g_return_if_fail (G_IS_FILE_INFO (info));
	_tmp0_ = directory_monitor_file_info_map_update (self->priv->files, dir, info);
	updated = _tmp0_;
	g_assert (updated);
	directory_monitor_notify_directory_alteration_completed (self, dir, info);
}


static void directory_monitor_real_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (dir));
	g_return_if_fail (G_IS_FILE_INFO (info));
	_tmp0_ = g_file_get_path (dir);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("directory alteration completed: %s", _tmp1_);
	_tmp3_ = _tmp2_;
	directory_monitor_mdbg (_tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	g_signal_emit_by_name (self, "directory-alteration-completed", dir, info);
}


void directory_monitor_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_alteration_completed (self, dir, info);
}


static void directory_monitor_real_notify_directory_attributes_altered (DirectoryMonitor* self, GFile* dir) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (dir));
	_tmp0_ = g_file_get_path (dir);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("directory attributes altered: %s", _tmp1_);
	_tmp3_ = _tmp2_;
	directory_monitor_mdbg (_tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	g_signal_emit_by_name (self, "directory-attributes-altered", dir);
}


void directory_monitor_notify_directory_attributes_altered (DirectoryMonitor* self, GFile* dir) {
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_attributes_altered (self, dir);
}


static void directory_monitor_internal_notify_directory_deleted (DirectoryMonitor* self, GFile* dir) {
	GFileInfo* _tmp0_ = NULL;
	GFileInfo* info;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (dir));
	_tmp0_ = directory_monitor_file_info_map_get_info (self->priv->files, dir);
	info = _tmp0_;
	g_assert (info != NULL);
	directory_monitor_remove_monitor (self, dir, info);
	directory_monitor_async_notify_directory_deleted (self, dir, FALSE, NULL, NULL);
	_g_object_unref0 (info);
}


static void directory_monitor_async_notify_directory_deleted_data_free (gpointer _data) {
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* data;
	data = _data;
	_g_object_unref0 (data->dir);
	_g_object_unref0 (data->self);
	g_slice_free (DirectoryMonitorAsyncNotifyDirectoryDeletedData, data);
}


static void directory_monitor_async_notify_directory_deleted (DirectoryMonitor* self, GFile* dir, gboolean already_removed, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
	_data_ = g_slice_new0 (DirectoryMonitorAsyncNotifyDirectoryDeletedData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, directory_monitor_async_notify_directory_deleted);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, directory_monitor_async_notify_directory_deleted_data_free);
	_data_->self = _g_object_ref0 (self);
	_data_->dir = _g_object_ref0 (dir);
	_data_->already_removed = already_removed;
	directory_monitor_async_notify_directory_deleted_co (_data_);
}


static void directory_monitor_async_notify_directory_deleted_finish (DirectoryMonitor* self, GAsyncResult* _res_) {
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void directory_monitor_async_notify_directory_deleted_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* data;
	data = _user_data_;
	data->_source_object_ = source_object;
	data->_res_ = _res_;
	directory_monitor_async_notify_directory_deleted_co (data);
}


static gboolean _directory_monitor_async_notify_directory_deleted_co_gsource_func (gpointer self) {
	gboolean result;
	result = directory_monitor_async_notify_directory_deleted_co (self);
	return result;
}


static gboolean directory_monitor_async_notify_directory_deleted_co (DirectoryMonitorAsyncNotifyDirectoryDeletedData* data) {
	switch (data->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	data->_tmp0_ = NULL;
	data->_tmp0_ = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_equal);
	data->file_children = data->_tmp0_;
	data->_tmp1_ = NULL;
	data->_tmp1_ = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_equal);
	data->dir_children = data->_tmp1_;
	data->_tmp2_ = directory_monitor_file_info_map_get_children (data->self->priv->files, data->dir, GEE_COLLECTION (data->file_children), GEE_COLLECTION (data->dir_children));
	data->count = data->_tmp2_;
	if (data->count > 0) {
		{
			data->_tmp3_ = _g_object_ref0 (data->dir_children);
			data->_dir_child_list = data->_tmp3_;
			data->_tmp4_ = gee_collection_get_size (GEE_COLLECTION (data->_dir_child_list));
			data->_dir_child_size = data->_tmp4_;
			data->_dir_child_index = -1;
			while (TRUE) {
				data->_dir_child_index = data->_dir_child_index + 1;
				if (!(data->_dir_child_index < data->_dir_child_size)) {
					break;
				}
				data->_tmp5_ = NULL;
				data->_tmp5_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (data->_dir_child_list), data->_dir_child_index);
				data->dir_child = (GFile*) data->_tmp5_;
				data->_state_ = 1;
				directory_monitor_async_notify_directory_deleted (data->self, data->dir_child, FALSE, directory_monitor_async_notify_directory_deleted_ready, data);
				return FALSE;
				_state_1:
				directory_monitor_async_notify_directory_deleted_finish (data->self, data->_res_);
				_g_object_unref0 (data->dir_child);
			}
			_g_object_unref0 (data->_dir_child_list);
		}
		{
			data->_tmp6_ = _g_object_ref0 (data->file_children);
			data->_file_child_list = data->_tmp6_;
			data->_tmp7_ = gee_collection_get_size (GEE_COLLECTION (data->_file_child_list));
			data->_file_child_size = data->_tmp7_;
			data->_file_child_index = -1;
			while (TRUE) {
				data->_file_child_index = data->_file_child_index + 1;
				if (!(data->_file_child_index < data->_file_child_size)) {
					break;
				}
				data->_tmp8_ = NULL;
				data->_tmp8_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (data->_file_child_list), data->_file_child_index);
				data->file_child = (GFile*) data->_tmp8_;
				directory_monitor_file_info_map_remove (data->self->priv->files, data->file_child, NULL);
				directory_monitor_notify_file_deleted (data->self, data->file_child);
				g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _directory_monitor_async_notify_directory_deleted_co_gsource_func, data, NULL);
				data->_state_ = 2;
				return FALSE;
				_state_2:
				;
				_g_object_unref0 (data->file_child);
			}
			_g_object_unref0 (data->_file_child_list);
		}
	}
	if (!data->already_removed) {
		directory_monitor_file_info_map_remove (data->self->priv->files, data->dir, NULL);
	}
	directory_monitor_notify_directory_deleted (data->self, data->dir);
	_g_object_unref0 (data->dir_children);
	_g_object_unref0 (data->file_children);
	if (data->_state_ == 0) {
		g_simple_async_result_complete_in_idle (data->_async_result);
	} else {
		g_simple_async_result_complete (data->_async_result);
	}
	g_object_unref (data->_async_result);
	return FALSE;
}


static void directory_monitor_real_notify_directory_deleted (DirectoryMonitor* self, GFile* dir) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gboolean _tmp4_;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (dir));
	_tmp0_ = g_file_get_path (dir);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("directory deleted: %s", _tmp1_);
	_tmp3_ = _tmp2_;
	directory_monitor_mdbg (_tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	g_signal_emit_by_name (self, "directory-deleted", dir);
	_tmp4_ = g_file_equal (dir, self->priv->root);
	if (_tmp4_) {
		directory_monitor_notify_root_deleted (self, dir);
	}
}


void directory_monitor_notify_directory_deleted (DirectoryMonitor* self, GFile* dir) {
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_deleted (self, dir);
}


static void directory_monitor_real_notify_closed (DirectoryMonitor* self) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	_tmp0_ = g_file_get_path (self->priv->root);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("monitoring of %s closed", _tmp1_);
	_tmp3_ = _tmp2_;
	directory_monitor_mdbg (_tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	g_signal_emit_by_name (self, "closed");
}


void directory_monitor_notify_closed (DirectoryMonitor* self) {
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_closed (self);
}


GFile* directory_monitor_get_root (DirectoryMonitor* self) {
	GFile* result = NULL;
	GFile* _tmp0_;
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
	_tmp0_ = _g_object_ref0 (self->priv->root);
	result = _tmp0_;
	return result;
}


gboolean directory_monitor_is_in_root (DirectoryMonitor* self, GFile* file) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
	_tmp0_ = g_file_has_prefix (file, self->priv->root);
	result = _tmp0_;
	return result;
}


gboolean directory_monitor_has_started (DirectoryMonitor* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
	result = self->priv->started;
	return result;
}


void directory_monitor_start_discovery (DirectoryMonitor* self) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_assert (!self->priv->started);
	self->priv->has_discovery_started = TRUE;
	self->priv->started = TRUE;
	directory_monitor_notify_discovery_started (self);
	self->priv->outstanding_exploration_dirs = 1;
	directory_monitor_explore_async (self, self->priv->root, NULL, TRUE, NULL, NULL);
}


static void directory_monitor_real_close (DirectoryMonitor* self) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_cancellable_cancel (self->priv->cancellable);
	{
		GeeCollection* _tmp0_ = NULL;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_ = NULL;
		GeeIterator* _tmp3_;
		GeeIterator* _monitor_it;
		_tmp0_ = gee_map_get_values (GEE_MAP (self->priv->monitors));
		_tmp1_ = _tmp0_;
		_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_));
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_monitor_it = _tmp3_;
		while (TRUE) {
			gboolean _tmp4_;
			gpointer _tmp5_ = NULL;
			GFileMonitor* monitor;
			_tmp4_ = gee_iterator_next (_monitor_it);
			if (!_tmp4_) {
				break;
			}
			_tmp5_ = gee_iterator_get (_monitor_it);
			monitor = (GFileMonitor*) _tmp5_;
			directory_monitor_cancel_monitor (self, monitor);
			_g_object_unref0 (monitor);
		}
		_g_object_unref0 (_monitor_it);
	}
	gee_abstract_map_clear (GEE_ABSTRACT_MAP (self->priv->monitors));
	directory_monitor_notify_closed (self);
}


void directory_monitor_close (DirectoryMonitor* self) {
	DIRECTORY_MONITOR_GET_CLASS (self)->close (self);
}


static DirectoryMonitorFType directory_monitor_get_ftype (GFileInfo* info) {
	DirectoryMonitorFType result = 0;
	GFileType _tmp0_;
	GFileType file_type;
	g_return_val_if_fail (G_IS_FILE_INFO (info), 0);
	_tmp0_ = g_file_info_get_file_type (info);
	file_type = _tmp0_;
	switch (file_type) {
		case G_FILE_TYPE_REGULAR:
		{
			result = DIRECTORY_MONITOR_FTYPE_FILE;
			return result;
		}
		case G_FILE_TYPE_DIRECTORY:
		{
			result = DIRECTORY_MONITOR_FTYPE_DIRECTORY;
			return result;
		}
		default:
		{
			GEnumValue* _tmp1_;
			gchar* _tmp2_ = NULL;
			gchar* _tmp3_;
			_tmp1_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_TYPE), file_type);
			_tmp2_ = g_strdup_printf ("query_ftype: Unknown file type %s", (_tmp1_ != NULL) ? _tmp1_->value_name : NULL);
			_tmp3_ = _tmp2_;
			directory_monitor_mdbg (_tmp3_);
			_g_free0 (_tmp3_);
			result = DIRECTORY_MONITOR_FTYPE_UNSUPPORTED;
			return result;
		}
	}
}


static void directory_monitor_explore_async_data_free (gpointer _data) {
	DirectoryMonitorExploreAsyncData* data;
	data = _data;
	_g_object_unref0 (data->dir);
	_g_object_unref0 (data->dir_info);
	_g_object_unref0 (data->self);
	g_slice_free (DirectoryMonitorExploreAsyncData, data);
}


static void directory_monitor_explore_async (DirectoryMonitor* self, GFile* dir, GFileInfo* dir_info, gboolean in_discovery, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DirectoryMonitorExploreAsyncData* _data_;
	_data_ = g_slice_new0 (DirectoryMonitorExploreAsyncData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, directory_monitor_explore_async);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, directory_monitor_explore_async_data_free);
	_data_->self = _g_object_ref0 (self);
	_data_->dir = _g_object_ref0 (dir);
	_data_->dir_info = _g_object_ref0 (dir_info);
	_data_->in_discovery = in_discovery;
	directory_monitor_explore_async_co (_data_);
}


static void directory_monitor_explore_finish (DirectoryMonitor* self, GAsyncResult* _res_) {
	DirectoryMonitorExploreAsyncData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void directory_monitor_explore_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	DirectoryMonitorExploreAsyncData* data;
	data = _user_data_;
	data->_source_object_ = source_object;
	data->_res_ = _res_;
	directory_monitor_explore_async_co (data);
}


static void _g_object_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static void _g_list_free__g_object_unref0_ (GList* self) {
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
	g_list_free (self);
}


static gboolean directory_monitor_explore_async_co (DirectoryMonitorExploreAsyncData* data) {
	switch (data->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		case 3:
		goto _state_3;
		case 4:
		goto _state_4;
		case 5:
		goto _state_5;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	data->_tmp0_ = directory_monitor_file_info_map_contains (data->self->priv->files, data->dir, data->dir_info);
	if (data->_tmp0_) {
		data->_tmp1_ = NULL;
		data->_tmp1_ = g_file_get_path (data->dir);
		data->_tmp2_ = data->_tmp1_;
		g_warning ("DirectoryMonitor.vala:836: Directory loop detected at %s, not explorin" \
"g", data->_tmp2_);
		_g_free0 (data->_tmp2_);
		directory_monitor_explore_directory_completed (data->self, data->in_discovery);
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
	data->_tmp3_ = _g_object_ref0 (data->dir_info);
	data->local_dir_info = data->_tmp3_;
	if (data->local_dir_info == NULL) {
		data->_state_ = 1;
		g_file_query_info_async (data->dir, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_DIR_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, data->self->priv->cancellable, directory_monitor_explore_async_ready, data);
		return FALSE;
		_state_1:
		data->_tmp4_ = NULL;
		data->_tmp4_ = g_file_query_info_finish (data->dir, data->_res_, &data->_inner_error_);
		data->_tmp5_ = data->_tmp4_;
		if (data->_inner_error_ != NULL) {
			goto __catch310_g_error;
		}
		_g_object_unref0 (data->local_dir_info);
		data->local_dir_info = data->_tmp5_;
		goto __finally310;
		__catch310_g_error:
		{
			data->err = data->_inner_error_;
			data->_inner_error_ = NULL;
			data->_tmp6_ = NULL;
			data->_tmp6_ = g_file_get_path (data->dir);
			data->_tmp7_ = data->_tmp6_;
			g_warning ("DirectoryMonitor.vala:850: Unable to retrieve info on %s: %s", data->_tmp7_, data->err->message);
			_g_free0 (data->_tmp7_);
			directory_monitor_explore_directory_completed (data->self, data->in_discovery);
			_g_error_free0 (data->err);
			_g_object_unref0 (data->local_dir_info);
			if (data->_state_ == 0) {
				g_simple_async_result_complete_in_idle (data->_async_result);
			} else {
				g_simple_async_result_complete (data->_async_result);
			}
			g_object_unref (data->_async_result);
			return FALSE;
		}
		__finally310:
		if (data->_inner_error_ != NULL) {
			_g_object_unref0 (data->local_dir_info);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, data->_inner_error_->message, g_quark_to_string (data->_inner_error_->domain), data->_inner_error_->code);
			g_clear_error (&data->_inner_error_);
			return FALSE;
		}
	}
	data->_tmp8_ = g_file_info_get_is_hidden (data->local_dir_info);
	if (data->_tmp8_) {
		data->_tmp9_ = NULL;
		data->_tmp9_ = g_file_get_path (data->dir);
		data->_tmp10_ = data->_tmp9_;
		g_warning ("DirectoryMonitor.vala:859: Ignoring hidden directory %s", data->_tmp10_);
		_g_free0 (data->_tmp10_);
		directory_monitor_explore_directory_completed (data->self, data->in_discovery);
		_g_object_unref0 (data->local_dir_info);
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
	data->_tmp11_ = NULL;
	data->_tmp11_ = get_file_info_id (data->local_dir_info);
	data->_tmp12_ = data->_tmp11_;
	data->_tmp13_ = data->_tmp12_ == NULL;
	_g_free0 (data->_tmp12_);
	if (data->_tmp13_) {
		data->_tmp14_ = NULL;
		data->_tmp14_ = g_file_get_path (data->dir);
		data->_tmp15_ = data->_tmp14_;
		g_warning ("DirectoryMonitor.vala:870: Unable to retrieve file ID on %s: skipping", data->_tmp15_);
		_g_free0 (data->_tmp15_);
		directory_monitor_explore_directory_completed (data->self, data->in_discovery);
		_g_object_unref0 (data->local_dir_info);
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
	data->_tmp16_ = g_file_info_get_file_type (data->local_dir_info);
	if (data->_tmp16_ != G_FILE_TYPE_DIRECTORY) {
		data->_tmp17_ = NULL;
		data->_tmp17_ = _ ("Unable to monitor %s: Not a directory (%s)");
		data->_tmp18_ = NULL;
		data->_tmp18_ = g_file_get_path (data->dir);
		data->_tmp19_ = data->_tmp18_;
		data->_tmp20_ = g_file_info_get_file_type (data->local_dir_info);
		data->_tmp21_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_TYPE), data->_tmp20_);
		data->_tmp22_ = NULL;
		data->_tmp22_ = g_strdup_printf (data->_tmp17_, data->_tmp19_, (data->_tmp21_ != NULL) ? data->_tmp21_->value_name : NULL);
		data->_tmp23_ = data->_tmp22_;
		directory_monitor_notify_discovery_failed (data->self, data->_tmp23_);
		_g_free0 (data->_tmp23_);
		_g_free0 (data->_tmp19_);
		directory_monitor_explore_directory_completed (data->self, data->in_discovery);
		_g_object_unref0 (data->local_dir_info);
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
	data->dir_map = NULL;
	data->file_map = NULL;
	data->_state_ = 2;
	g_file_enumerate_children_async (data->dir, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, data->self->priv->cancellable, directory_monitor_explore_async_ready, data);
	return FALSE;
	_state_2:
	data->_tmp24_ = NULL;
	data->_tmp24_ = g_file_enumerate_children_finish (data->dir, data->_res_, &data->_inner_error_);
	data->enumerator = data->_tmp24_;
	if (data->_inner_error_ != NULL) {
		goto __catch311_g_error;
	}
	{
		data->_tmp25_ = TRUE;
		while (TRUE) {
			if (!data->_tmp25_) {
			}
			data->_tmp25_ = FALSE;
			data->_state_ = 3;
			g_file_enumerator_next_files_async (data->enumerator, 10, DIRECTORY_MONITOR_DEFAULT_PRIORITY, data->self->priv->cancellable, directory_monitor_explore_async_ready, data);
			return FALSE;
			_state_3:
			data->_tmp26_ = NULL;
			data->_tmp26_ = g_file_enumerator_next_files_finish (data->enumerator, data->_res_, &data->_inner_error_);
			data->infos = data->_tmp26_;
			if (data->_inner_error_ != NULL) {
				_g_object_unref0 (data->enumerator);
				goto __catch311_g_error;
			}
			if (data->infos == NULL) {
				__g_list_free__g_object_unref0_0 (data->infos);
				break;
			}
			{
				data->info_collection = data->infos;
				for (data->info_it = data->info_collection; data->info_it != NULL; data->info_it = data->info_it->next) {
					data->_tmp27_ = _g_object_ref0 ((GFileInfo*) data->info_it->data);
					data->info = data->_tmp27_;
					{
						data->_tmp28_ = g_file_info_get_is_hidden (data->info);
						if (data->_tmp28_) {
							data->_tmp29_ = NULL;
							data->_tmp29_ = g_file_info_get_name (data->info);
							data->_tmp30_ = NULL;
							data->_tmp30_ = g_file_get_child (data->dir, data->_tmp29_);
							data->_tmp31_ = data->_tmp30_;
							data->_tmp32_ = NULL;
							data->_tmp32_ = g_file_get_path (data->_tmp31_);
							data->_tmp33_ = data->_tmp32_;
							g_warning ("DirectoryMonitor.vala:906: Skipping hidden file/directory %s", data->_tmp33_);
							_g_free0 (data->_tmp33_);
							_g_object_unref0 (data->_tmp31_);
							_g_object_unref0 (data->info);
							continue;
						}
						data->_tmp34_ = directory_monitor_is_file_symlink_supported (data->info);
						if (!data->_tmp34_) {
							_g_object_unref0 (data->info);
							continue;
						}
						data->_tmp35_ = g_file_info_get_file_type (data->info);
						switch (data->_tmp35_) {
							case G_FILE_TYPE_REGULAR:
							{
								if (data->file_map == NULL) {
									data->_tmp36_ = NULL;
									data->_tmp36_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_FILE_INFO, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_hash, g_file_equal, NULL);
									_g_object_unref0 (data->file_map);
									data->file_map = data->_tmp36_;
								}
								data->_tmp37_ = NULL;
								data->_tmp37_ = g_file_info_get_name (data->info);
								data->_tmp38_ = NULL;
								data->_tmp38_ = g_file_get_child (data->dir, data->_tmp37_);
								data->_tmp39_ = data->_tmp38_;
								gee_abstract_map_set (GEE_ABSTRACT_MAP (data->file_map), data->_tmp39_, data->info);
								_g_object_unref0 (data->_tmp39_);
								break;
							}
							case G_FILE_TYPE_DIRECTORY:
							{
								if (data->dir_map == NULL) {
									data->_tmp40_ = NULL;
									data->_tmp40_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_FILE_INFO, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_hash, g_file_equal, NULL);
									_g_object_unref0 (data->dir_map);
									data->dir_map = data->_tmp40_;
								}
								data->_tmp41_ = NULL;
								data->_tmp41_ = g_file_info_get_name (data->info);
								data->_tmp42_ = NULL;
								data->_tmp42_ = g_file_get_child (data->dir, data->_tmp41_);
								data->_tmp43_ = data->_tmp42_;
								gee_abstract_map_set (GEE_ABSTRACT_MAP (data->dir_map), data->_tmp43_, data->info);
								_g_object_unref0 (data->_tmp43_);
								break;
							}
							default:
							{
								break;
							}
						}
						_g_object_unref0 (data->info);
					}
				}
			}
			__g_list_free__g_object_unref0_0 (data->infos);
		}
	}
	_g_object_unref0 (data->enumerator);
	goto __finally311;
	__catch311_g_error:
	{
		data->err2 = data->_inner_error_;
		data->_inner_error_ = NULL;
		data->_tmp44_ = NULL;
		data->_tmp44_ = g_file_get_path (data->dir);
		data->_tmp45_ = data->_tmp44_;
		g_warning ("DirectoryMonitor.vala:938: Aborted directory traversal of %s: %s", data->_tmp45_, data->err2->message);
		_g_free0 (data->_tmp45_);
		directory_monitor_explore_directory_completed (data->self, data->in_discovery);
		_g_error_free0 (data->err2);
		_g_object_unref0 (data->file_map);
		_g_object_unref0 (data->dir_map);
		_g_object_unref0 (data->local_dir_info);
		if (data->_state_ == 0) {
			g_simple_async_result_complete_in_idle (data->_async_result);
		} else {
			g_simple_async_result_complete (data->_async_result);
		}
		g_object_unref (data->_async_result);
		return FALSE;
	}
	__finally311:
	if (data->_inner_error_ != NULL) {
		_g_object_unref0 (data->file_map);
		_g_object_unref0 (data->dir_map);
		_g_object_unref0 (data->local_dir_info);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, data->_inner_error_->message, g_quark_to_string (data->_inner_error_->domain), data->_inner_error_->code);
		g_clear_error (&data->_inner_error_);
		return FALSE;
	}
	if (data->in_discovery) {
		directory_monitor_internal_notify_directory_discovered (data->self, data->dir, data->local_dir_info);
	} else {
		directory_monitor_internal_notify_directory_created (data->self, data->dir, data->local_dir_info);
	}
	directory_monitor_add_monitor (data->self, data->dir, data->local_dir_info);
	if (data->file_map != NULL) {
		data->_state_ = 4;
		directory_monitor_notify_directory_files (data->self, GEE_MAP (data->file_map), data->in_discovery, directory_monitor_explore_async_ready, data);
		return FALSE;
		_state_4:
		directory_monitor_notify_directory_files_finish (data->self, data->_res_);
	}
	if (data->self->priv->recurse) {
		data->_tmp46_ = data->dir_map != NULL;
	} else {
		data->_tmp46_ = FALSE;
	}
	if (data->_tmp46_) {
		{
			data->_tmp47_ = NULL;
			data->_tmp47_ = gee_map_get_keys (GEE_MAP (data->dir_map));
			data->_tmp48_ = data->_tmp47_;
			data->_tmp49_ = NULL;
			data->_tmp49_ = gee_iterable_iterator (GEE_ITERABLE (data->_tmp48_));
			data->_tmp50_ = data->_tmp49_;
			_g_object_unref0 (data->_tmp48_);
			data->_subdir_it = data->_tmp50_;
			while (TRUE) {
				data->_tmp51_ = gee_iterator_next (data->_subdir_it);
				if (!data->_tmp51_) {
					break;
				}
				data->_tmp52_ = NULL;
				data->_tmp52_ = gee_iterator_get (data->_subdir_it);
				data->subdir = (GFile*) data->_tmp52_;
				data->self->priv->outstanding_exploration_dirs = data->self->priv->outstanding_exploration_dirs + 1;
				if (data->self->priv->outstanding_exploration_dirs > DIRECTORY_MONITOR_MAX_EXPLORATION_DIRS) {
					data->_tmp53_ = NULL;
					data->_tmp53_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (data->dir_map), data->subdir);
					data->_tmp54_ = (GFileInfo*) data->_tmp53_;
					data->_state_ = 5;
					directory_monitor_explore_async (data->self, data->subdir, data->_tmp54_, data->in_discovery, directory_monitor_explore_async_ready, data);
					return FALSE;
					_state_5:
					directory_monitor_explore_finish (data->self, data->_res_);
					_g_object_unref0 (data->_tmp54_);
				} else {
					data->_tmp55_ = NULL;
					data->_tmp55_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (data->dir_map), data->subdir);
					data->_tmp56_ = (GFileInfo*) data->_tmp55_;
					directory_monitor_explore_async (data->self, data->subdir, data->_tmp56_, data->in_discovery, NULL, NULL);
					_g_object_unref0 (data->_tmp56_);
				}
				_g_object_unref0 (data->subdir);
			}
			_g_object_unref0 (data->_subdir_it);
		}
	}
	directory_monitor_explore_directory_completed (data->self, data->in_discovery);
	_g_object_unref0 (data->file_map);
	_g_object_unref0 (data->dir_map);
	_g_object_unref0 (data->local_dir_info);
	if (data->_state_ == 0) {
		g_simple_async_result_complete_in_idle (data->_async_result);
	} else {
		g_simple_async_result_complete (data->_async_result);
	}
	g_object_unref (data->_async_result);
	return FALSE;
}


static void directory_monitor_notify_directory_files_data_free (gpointer _data) {
	DirectoryMonitorNotifyDirectoryFilesData* data;
	data = _data;
	_g_object_unref0 (data->map);
	_g_object_unref0 (data->self);
	g_slice_free (DirectoryMonitorNotifyDirectoryFilesData, data);
}


static void directory_monitor_notify_directory_files (DirectoryMonitor* self, GeeMap* map, gboolean in_discovery, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DirectoryMonitorNotifyDirectoryFilesData* _data_;
	_data_ = g_slice_new0 (DirectoryMonitorNotifyDirectoryFilesData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, directory_monitor_notify_directory_files);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, directory_monitor_notify_directory_files_data_free);
	_data_->self = _g_object_ref0 (self);
	_data_->map = _g_object_ref0 (map);
	_data_->in_discovery = in_discovery;
	directory_monitor_notify_directory_files_co (_data_);
}


static void directory_monitor_notify_directory_files_finish (DirectoryMonitor* self, GAsyncResult* _res_) {
	DirectoryMonitorNotifyDirectoryFilesData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static gboolean _directory_monitor_notify_directory_files_co_gsource_func (gpointer self) {
	gboolean result;
	result = directory_monitor_notify_directory_files_co (self);
	return result;
}


static gboolean directory_monitor_notify_directory_files_co (DirectoryMonitorNotifyDirectoryFilesData* data) {
	switch (data->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	data->_tmp0_ = NULL;
	data->_tmp0_ = gee_map_map_iterator (data->map);
	data->iter = data->_tmp0_;
	while (TRUE) {
		data->_tmp1_ = gee_map_iterator_next (data->iter);
		if (!data->_tmp1_) {
			break;
		}
		if (data->in_discovery) {
			data->_tmp2_ = NULL;
			data->_tmp2_ = gee_map_iterator_get_key (data->iter);
			data->_tmp3_ = (GFile*) data->_tmp2_;
			data->_tmp4_ = NULL;
			data->_tmp4_ = gee_map_iterator_get_value (data->iter);
			data->_tmp5_ = (GFileInfo*) data->_tmp4_;
			directory_monitor_internal_notify_file_discovered (data->self, data->_tmp3_, data->_tmp5_);
			_g_object_unref0 (data->_tmp5_);
			_g_object_unref0 (data->_tmp3_);
		} else {
			data->_tmp6_ = NULL;
			data->_tmp6_ = gee_map_iterator_get_key (data->iter);
			data->_tmp7_ = (GFile*) data->_tmp6_;
			data->_tmp8_ = NULL;
			data->_tmp8_ = gee_map_iterator_get_value (data->iter);
			data->_tmp9_ = (GFileInfo*) data->_tmp8_;
			directory_monitor_internal_notify_file_created (data->self, data->_tmp7_, data->_tmp9_);
			_g_object_unref0 (data->_tmp9_);
			_g_object_unref0 (data->_tmp7_);
		}
		g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _directory_monitor_notify_directory_files_co_gsource_func, data, NULL);
		data->_state_ = 1;
		return FALSE;
		_state_1:
		;
	}
	_g_object_unref0 (data->iter);
	if (data->_state_ == 0) {
		g_simple_async_result_complete_in_idle (data->_async_result);
	} else {
		g_simple_async_result_complete (data->_async_result);
	}
	g_object_unref (data->_async_result);
	return FALSE;
}


static void directory_monitor_explore_directory_completed (DirectoryMonitor* self, gboolean in_discovery) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_assert (self->priv->outstanding_exploration_dirs > 0);
	self->priv->outstanding_exploration_dirs--;
	if (in_discovery) {
		_tmp0_ = self->priv->outstanding_exploration_dirs == 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		directory_monitor_notify_discovery_completed (self);
	}
}


static void _directory_monitor_on_monitor_notification_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self) {
	directory_monitor_on_monitor_notification (self, file, other_file, event_type);
}


static gboolean directory_monitor_add_monitor (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	gboolean result = FALSE;
	gchar* _tmp0_ = NULL;
	gchar* id;
	gboolean _tmp1_;
	GFileMonitor* monitor;
	GFileMonitor* _tmp2_ = NULL;
	GFileMonitor* _tmp3_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
	g_return_val_if_fail (G_IS_FILE (dir), FALSE);
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
	if (!self->priv->monitoring) {
		result = FALSE;
		return result;
	}
	_tmp0_ = directory_monitor_file_info_map_get_id (self->priv->files, dir, info);
	id = _tmp0_;
	if (id == NULL) {
		result = FALSE;
		_g_free0 (id);
		return result;
	}
	_tmp1_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->monitors), id);
	if (_tmp1_) {
		result = FALSE;
		_g_free0 (id);
		return result;
	}
	monitor = NULL;
	_tmp2_ = g_file_monitor_directory (dir, DIRECTORY_MONITOR_FILE_MONITOR_FLAGS, NULL, &_inner_error_);
	_tmp3_ = _tmp2_;
	if (_inner_error_ != NULL) {
		goto __catch312_g_error;
	}
	_g_object_unref0 (monitor);
	monitor = _tmp3_;
	goto __finally312;
	__catch312_g_error:
	{
		GError * err;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp4_ = g_file_get_path (dir);
		_tmp5_ = _tmp4_;
		g_warning ("DirectoryMonitor.vala:1014: Unable to monitor %s: %s", _tmp5_, err->message);
		_g_free0 (_tmp5_);
		result = FALSE;
		_g_error_free0 (err);
		_g_object_unref0 (monitor);
		_g_free0 (id);
		return result;
	}
	__finally312:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (monitor);
		_g_free0 (id);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->monitors), id, monitor);
	g_signal_connect_object (monitor, "changed", (GCallback) _directory_monitor_on_monitor_notification_g_file_monitor_changed, self, 0);
	_tmp6_ = g_file_get_path (dir);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strdup_printf ("Added monitor for %s", _tmp7_);
	_tmp9_ = _tmp8_;
	directory_monitor_mdbg (_tmp9_);
	_g_free0 (_tmp9_);
	_g_free0 (_tmp7_);
	result = TRUE;
	_g_object_unref0 (monitor);
	_g_free0 (id);
	return result;
}


static gboolean directory_monitor_remove_monitor (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	gboolean result = FALSE;
	gchar* _tmp0_ = NULL;
	gchar* id;
	gpointer _tmp1_ = NULL;
	GFileMonitor* monitor;
	gboolean _tmp2_;
	gboolean removed;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_;
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
	g_return_val_if_fail (G_IS_FILE (dir), FALSE);
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
	if (!self->priv->monitoring) {
		result = FALSE;
		return result;
	}
	_tmp0_ = directory_monitor_file_info_map_get_id (self->priv->files, dir, info);
	id = _tmp0_;
	if (id == NULL) {
		result = FALSE;
		_g_free0 (id);
		return result;
	}
	_tmp1_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->monitors), id);
	monitor = (GFileMonitor*) _tmp1_;
	if (monitor == NULL) {
		result = FALSE;
		_g_object_unref0 (monitor);
		_g_free0 (id);
		return result;
	}
	_tmp2_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->monitors), id, NULL);
	removed = _tmp2_;
	g_assert (removed);
	directory_monitor_cancel_monitor (self, monitor);
	_tmp3_ = g_file_get_path (dir);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strdup_printf ("Removed monitor for %s", _tmp4_);
	_tmp6_ = _tmp5_;
	directory_monitor_mdbg (_tmp6_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	result = TRUE;
	_g_object_unref0 (monitor);
	_g_free0 (id);
	return result;
}


static void directory_monitor_cancel_monitor (DirectoryMonitor* self, GFileMonitor* monitor) {
	guint _tmp0_;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE_MONITOR (monitor));
	g_signal_parse_name ("changed", G_TYPE_FILE_MONITOR, &_tmp0_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (monitor, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _directory_monitor_on_monitor_notification_g_file_monitor_changed, self);
	g_file_monitor_cancel (monitor);
}


static void _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
	directory_monitor_query_info_queue_element_on_completed (self, source_object, res);
	directory_monitor_query_info_queue_element_unref (self);
}


static gboolean _directory_monitor_check_for_expired_delete_events_gsource_func (gpointer self) {
	gboolean result;
	result = directory_monitor_check_for_expired_delete_events (self);
	return result;
}


static void directory_monitor_on_monitor_notification (DirectoryMonitor* self, GFile* file, GFile* other_file, GFileMonitorEvent event) {
	gchar* _tmp0_ = NULL;
	GEnumValue* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_;
	DirectoryMonitorQueryInfoQueueElement* _tmp8_ = NULL;
	DirectoryMonitorQueryInfoQueueElement* query_info;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (file));
	g_return_if_fail ((other_file == NULL) || G_IS_FILE (other_file));
	if (other_file != NULL) {
		gchar* _tmp1_ = NULL;
		_tmp1_ = g_file_get_path (other_file);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp1_;
	} else {
		gchar* _tmp2_;
		_tmp2_ = g_strdup ("(none)");
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp2_;
	}
	_tmp3_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), event);
	_tmp4_ = g_file_get_path (file);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strdup_printf ("NOTIFY %s: file=%s other_file=%s", (_tmp3_ != NULL) ? _tmp3_->value_name : NULL, _tmp5_, _tmp0_);
	_tmp7_ = _tmp6_;
	directory_monitor_mdbg (_tmp7_);
	_g_free0 (_tmp7_);
	_g_free0 (_tmp5_);
	_tmp8_ = directory_monitor_query_info_queue_element_new (self, file, other_file, event);
	query_info = _tmp8_;
	gee_queue_offer (self->priv->query_info_queue, query_info);
	switch (event) {
		case G_FILE_MONITOR_EVENT_CREATED:
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
		{
			g_file_query_info_async (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, self->priv->cancellable, _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback, directory_monitor_query_info_queue_element_ref (query_info));
			break;
		}
		case G_FILE_MONITOR_EVENT_DELETED:
		{
			if (self->priv->delete_timer_id == 0) {
				guint _tmp9_;
				_tmp9_ = g_timeout_add_full (G_PRIORITY_DEFAULT, DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC / 2, _directory_monitor_check_for_expired_delete_events_gsource_func, g_object_ref (self), g_object_unref);
				self->priv->delete_timer_id = _tmp9_;
			}
			break;
		}
		case G_FILE_MONITOR_EVENT_MOVED:
		{
			if (other_file != NULL) {
				g_file_query_info_async (other_file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, self->priv->cancellable, _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback, directory_monitor_query_info_queue_element_ref (query_info));
			} else {
				g_warning ("DirectoryMonitor.vala:1091: Unable to process MOVED event: no other_fi" \
"le");
				gee_collection_remove (GEE_COLLECTION (self->priv->query_info_queue), query_info);
			}
			break;
		}
		default:
		{
			query_info->completed = TRUE;
			directory_monitor_process_query_queue (self, query_info);
			break;
		}
	}
	_directory_monitor_query_info_queue_element_unref0 (query_info);
	_g_free0 (_tmp0_);
}


static void directory_monitor_process_query_queue (DirectoryMonitor* self, DirectoryMonitorQueryInfoQueueElement* query_info) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail ((query_info == NULL) || DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT (query_info));
	if (query_info != NULL) {
		_tmp1_ = query_info->info != NULL;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		_tmp0_ = query_info->event == G_FILE_MONITOR_EVENT_CREATED;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GFile* _tmp2_ = NULL;
		GFile* match;
		_tmp2_ = directory_monitor_file_info_map_find_match (self->priv->files, query_info->info);
		match = _tmp2_;
		if (match != NULL) {
			gboolean matched;
			matched = FALSE;
			{
				GeeIterator* _tmp3_ = NULL;
				GeeIterator* _enqueued_it;
				_tmp3_ = gee_iterable_iterator (GEE_ITERABLE (self->priv->query_info_queue));
				_enqueued_it = _tmp3_;
				while (TRUE) {
					gboolean _tmp4_;
					gpointer _tmp5_ = NULL;
					DirectoryMonitorQueryInfoQueueElement* enqueued;
					gboolean _tmp6_ = FALSE;
					gboolean _tmp7_ = FALSE;
					gchar* _tmp9_ = NULL;
					gchar* _tmp10_;
					gchar* _tmp11_ = NULL;
					gchar* _tmp12_;
					gchar* _tmp13_ = NULL;
					gchar* _tmp14_;
					GFile* _tmp15_;
					GFileInfo* _tmp16_;
					_tmp4_ = gee_iterator_next (_enqueued_it);
					if (!_tmp4_) {
						break;
					}
					_tmp5_ = gee_iterator_get (_enqueued_it);
					enqueued = (DirectoryMonitorQueryInfoQueueElement*) _tmp5_;
					if (enqueued->event != G_FILE_MONITOR_EVENT_DELETED) {
						_tmp7_ = TRUE;
					} else {
						_tmp7_ = enqueued->completed;
					}
					if (_tmp7_) {
						_tmp6_ = TRUE;
					} else {
						gboolean _tmp8_;
						_tmp8_ = g_file_equal (match, enqueued->file);
						_tmp6_ = !_tmp8_;
					}
					if (_tmp6_) {
						_directory_monitor_query_info_queue_element_unref0 (enqueued);
						continue;
					}
					_tmp9_ = g_file_get_path (query_info->file);
					_tmp10_ = _tmp9_;
					_tmp11_ = g_file_get_path (enqueued->file);
					_tmp12_ = _tmp11_;
					_tmp13_ = g_strdup_printf ("Matching CREATED %s to DELETED %s for MOVED", _tmp10_, _tmp12_);
					_tmp14_ = _tmp13_;
					directory_monitor_mdbg (_tmp14_);
					_g_free0 (_tmp14_);
					_g_free0 (_tmp12_);
					_g_free0 (_tmp10_);
					enqueued->event = G_FILE_MONITOR_EVENT_MOVED;
					_tmp15_ = _g_object_ref0 (query_info->file);
					_g_object_unref0 (enqueued->other_file);
					enqueued->other_file = _tmp15_;
					_tmp16_ = _g_object_ref0 (query_info->info);
					_g_object_unref0 (enqueued->info);
					enqueued->info = _tmp16_;
					enqueued->completed = TRUE;
					matched = TRUE;
					_directory_monitor_query_info_queue_element_unref0 (enqueued);
					break;
				}
				_g_object_unref0 (_enqueued_it);
			}
			if (matched) {
				gee_collection_remove (GEE_COLLECTION (self->priv->query_info_queue), query_info);
			}
		}
		_g_object_unref0 (match);
	}
	{
		gboolean _tmp17_;
		_tmp17_ = TRUE;
		while (TRUE) {
			gpointer _tmp18_ = NULL;
			DirectoryMonitorQueryInfoQueueElement* next;
			gboolean _tmp19_ = FALSE;
			gpointer _tmp20_ = NULL;
			DirectoryMonitorQueryInfoQueueElement* n;
			GEnumValue* _tmp21_;
			gchar* _tmp22_ = NULL;
			gchar* _tmp23_;
			gchar* _tmp24_ = NULL;
			gchar* _tmp25_;
			gboolean _tmp31_ = FALSE;
			gboolean _tmp39_ = FALSE;
			if (!_tmp17_) {
			}
			_tmp17_ = FALSE;
			_tmp18_ = gee_queue_peek (self->priv->query_info_queue);
			next = (DirectoryMonitorQueryInfoQueueElement*) _tmp18_;
			if (next == NULL) {
				_tmp19_ = TRUE;
			} else {
				_tmp19_ = !next->completed;
			}
			if (_tmp19_) {
				_directory_monitor_query_info_queue_element_unref0 (next);
				break;
			}
			_tmp20_ = gee_queue_poll (self->priv->query_info_queue);
			n = (DirectoryMonitorQueryInfoQueueElement*) _tmp20_;
			g_assert (next == n);
			_tmp21_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), next->event);
			_tmp22_ = g_file_get_path (next->file);
			_tmp23_ = _tmp22_;
			_tmp24_ = g_strdup_printf ("Completed info query %u for %s on %s", next->position, (_tmp21_ != NULL) ? _tmp21_->value_name : NULL, _tmp23_);
			_tmp25_ = _tmp24_;
			directory_monitor_mdbg (_tmp25_);
			_g_free0 (_tmp25_);
			_g_free0 (_tmp23_);
			if (next->err != NULL) {
				gchar* _tmp26_ = NULL;
				gchar* _tmp27_;
				GEnumValue* _tmp28_;
				gchar* _tmp29_ = NULL;
				gchar* _tmp30_;
				_tmp26_ = g_file_get_path (next->file);
				_tmp27_ = _tmp26_;
				_tmp28_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), next->event);
				_tmp29_ = g_strdup_printf ("Unable to retrieve file information for %s, dropping %s: %s", _tmp27_, (_tmp28_ != NULL) ? _tmp28_->value_name : NULL, next->err->message);
				_tmp30_ = _tmp29_;
				directory_monitor_mdbg (_tmp30_);
				_g_free0 (_tmp30_);
				_g_free0 (_tmp27_);
				_directory_monitor_query_info_queue_element_unref0 (n);
				_directory_monitor_query_info_queue_element_unref0 (next);
				continue;
			}
			if (next->info != NULL) {
				gchar* _tmp32_ = NULL;
				gchar* _tmp33_;
				_tmp32_ = get_file_info_id (next->info);
				_tmp33_ = _tmp32_;
				_tmp31_ = _tmp33_ == NULL;
				_g_free0 (_tmp33_);
			} else {
				_tmp31_ = FALSE;
			}
			if (_tmp31_) {
				gchar* _tmp34_ = NULL;
				gchar* _tmp35_;
				GEnumValue* _tmp36_;
				gchar* _tmp37_ = NULL;
				gchar* _tmp38_;
				_tmp34_ = g_file_get_path (next->file);
				_tmp35_ = _tmp34_;
				_tmp36_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), next->event);
				_tmp37_ = g_strdup_printf ("Unable to retrieve file ID for %s, dropping %s", _tmp35_, (_tmp36_ != NULL) ? _tmp36_->value_name : NULL);
				_tmp38_ = _tmp37_;
				directory_monitor_mdbg (_tmp38_);
				_g_free0 (_tmp38_);
				_g_free0 (_tmp35_);
				_directory_monitor_query_info_queue_element_unref0 (n);
				_directory_monitor_query_info_queue_element_unref0 (next);
				continue;
			}
			if (next->info != NULL) {
				gboolean _tmp40_;
				_tmp40_ = directory_monitor_is_file_symlink_supported (next->info);
				_tmp39_ = !_tmp40_;
			} else {
				_tmp39_ = FALSE;
			}
			if (_tmp39_) {
				gchar* _tmp41_ = NULL;
				gchar* _tmp42_;
				GEnumValue* _tmp43_;
				gchar* _tmp44_ = NULL;
				gchar* _tmp45_;
				_tmp41_ = g_file_get_path (next->file);
				_tmp42_ = _tmp41_;
				_tmp43_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), next->event);
				_tmp44_ = g_strdup_printf ("No symlink support for %s, dropping %s", _tmp42_, (_tmp43_ != NULL) ? _tmp43_->value_name : NULL);
				_tmp45_ = _tmp44_;
				directory_monitor_mdbg (_tmp45_);
				_g_free0 (_tmp45_);
				_g_free0 (_tmp42_);
				_directory_monitor_query_info_queue_element_unref0 (n);
				_directory_monitor_query_info_queue_element_unref0 (next);
				continue;
			}
			directory_monitor_on_monitor_notification_ready (self, next->file, next->other_file, next->info, next->event);
			_directory_monitor_query_info_queue_element_unref0 (n);
			_directory_monitor_query_info_queue_element_unref0 (next);
		}
	}
}


static void directory_monitor_on_monitor_notification_ready (DirectoryMonitor* self, GFile* file, GFile* other_file, GFileInfo* info, GFileMonitorEvent event) {
	gchar* _tmp0_ = NULL;
	GEnumValue* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_;
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (file));
	g_return_if_fail ((other_file == NULL) || G_IS_FILE (other_file));
	g_return_if_fail ((info == NULL) || G_IS_FILE_INFO (info));
	if (other_file != NULL) {
		gchar* _tmp1_ = NULL;
		_tmp1_ = g_file_get_path (other_file);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp1_;
	} else {
		gchar* _tmp2_;
		_tmp2_ = g_strdup ("(null)");
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp2_;
	}
	_tmp3_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), event);
	_tmp4_ = g_file_get_path (file);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strdup_printf ("READY %s: file=%s other_file=%s", (_tmp3_ != NULL) ? _tmp3_->value_name : NULL, _tmp5_, _tmp0_);
	_tmp7_ = _tmp6_;
	directory_monitor_mdbg (_tmp7_);
	_g_free0 (_tmp7_);
	_g_free0 (_tmp5_);
	switch (event) {
		case G_FILE_MONITOR_EVENT_CREATED:
		{
			DirectoryMonitorFType _tmp8_;
			DirectoryMonitorFType ftype;
			g_assert (info != NULL);
			_tmp8_ = directory_monitor_get_ftype (info);
			ftype = _tmp8_;
			switch (ftype) {
				case DIRECTORY_MONITOR_FTYPE_FILE:
				{
					directory_monitor_internal_notify_file_created (self, file, info);
					break;
				}
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
				{
					self->priv->outstanding_exploration_dirs++;
					directory_monitor_explore_async (self, file, info, FALSE, NULL, NULL);
					break;
				}
				default:
				{
					g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
					break;
				}
			}
			break;
		}
		case G_FILE_MONITOR_EVENT_CHANGED:
		{
			GFileInfo* _tmp9_ = NULL;
			GFileInfo* local_info;
			DirectoryMonitorFType _tmp14_;
			DirectoryMonitorFType ftype;
			g_assert (info == NULL);
			_tmp9_ = directory_monitor_get_file_info (self, file);
			local_info = _tmp9_;
			if (local_info == NULL) {
				gchar* _tmp10_ = NULL;
				gchar* _tmp11_;
				gchar* _tmp12_ = NULL;
				gchar* _tmp13_;
				_tmp10_ = g_file_get_path (file);
				_tmp11_ = _tmp10_;
				_tmp12_ = g_strdup_printf ("Changed event for unknown file %s", _tmp11_);
				_tmp13_ = _tmp12_;
				directory_monitor_mdbg (_tmp13_);
				_g_free0 (_tmp13_);
				_g_free0 (_tmp11_);
				_g_object_unref0 (local_info);
				break;
			}
			_tmp14_ = directory_monitor_get_ftype (local_info);
			ftype = _tmp14_;
			switch (ftype) {
				case DIRECTORY_MONITOR_FTYPE_FILE:
				{
					directory_monitor_notify_file_altered (self, file);
					break;
				}
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
				{
					directory_monitor_notify_directory_altered (self, file);
					break;
				}
				default:
				{
					g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
					break;
				}
			}
			_g_object_unref0 (local_info);
			break;
		}
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
		{
			DirectoryMonitorFType _tmp15_;
			DirectoryMonitorFType ftype;
			g_assert (info != NULL);
			_tmp15_ = directory_monitor_get_ftype (info);
			ftype = _tmp15_;
			switch (ftype) {
				case DIRECTORY_MONITOR_FTYPE_FILE:
				{
					directory_monitor_internal_notify_file_alteration_completed (self, file, info);
					break;
				}
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
				{
					directory_monitor_internal_notify_directory_alteration_completed (self, file, info);
					break;
				}
				default:
				{
					g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
					break;
				}
			}
			break;
		}
		case G_FILE_MONITOR_EVENT_MOVED:
		{
			DirectoryMonitorFType _tmp16_;
			DirectoryMonitorFType ftype;
			g_assert (info != NULL);
			g_assert (other_file != NULL);
			_tmp16_ = directory_monitor_get_ftype (info);
			ftype = _tmp16_;
			switch (ftype) {
				case DIRECTORY_MONITOR_FTYPE_FILE:
				{
					directory_monitor_internal_notify_file_moved (self, file, other_file, info);
					break;
				}
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
				{
					GFileInfo* _tmp17_ = NULL;
					GFileInfo* old_dir_info;
					_tmp17_ = directory_monitor_file_info_map_get_info (self->priv->files, file);
					old_dir_info = _tmp17_;
					if (old_dir_info == NULL) {
						gchar* _tmp18_ = NULL;
						gchar* _tmp19_;
						_tmp18_ = g_file_get_path (file);
						_tmp19_ = _tmp18_;
						g_warning ("DirectoryMonitor.vala:1273: Directory moved event for unknown file %s", _tmp19_);
						_g_free0 (_tmp19_);
						_g_object_unref0 (old_dir_info);
						break;
					}
					directory_monitor_internal_notify_directory_moved (self, file, old_dir_info, other_file, info);
					_g_object_unref0 (old_dir_info);
					break;
				}
				default:
				{
					g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
					break;
				}
			}
			break;
		}
		case G_FILE_MONITOR_EVENT_DELETED:
		{
			GFileInfo* _tmp20_ = NULL;
			GFileInfo* local_info;
			DirectoryMonitorFType _tmp23_;
			DirectoryMonitorFType ftype;
			g_assert (info == NULL);
			_tmp20_ = directory_monitor_get_file_info (self, file);
			local_info = _tmp20_;
			if (local_info == NULL) {
				gchar* _tmp21_ = NULL;
				gchar* _tmp22_;
				_tmp21_ = g_file_get_path (file);
				_tmp22_ = _tmp21_;
				g_warning ("DirectoryMonitor.vala:1292: Deleted event for unknown file %s", _tmp22_);
				_g_free0 (_tmp22_);
				_g_object_unref0 (local_info);
				break;
			}
			_tmp23_ = directory_monitor_get_ftype (local_info);
			ftype = _tmp23_;
			switch (ftype) {
				case DIRECTORY_MONITOR_FTYPE_FILE:
				{
					directory_monitor_internal_notify_file_deleted (self, file);
					break;
				}
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
				{
					directory_monitor_internal_notify_directory_deleted (self, file);
					break;
				}
				default:
				{
					g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
					break;
				}
			}
			_g_object_unref0 (local_info);
			break;
		}
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
		{
			GFileInfo* _tmp24_ = NULL;
			GFileInfo* local_info;
			DirectoryMonitorFType _tmp27_;
			DirectoryMonitorFType ftype;
			g_assert (info == NULL);
			_tmp24_ = directory_monitor_get_file_info (self, file);
			local_info = _tmp24_;
			if (local_info == NULL) {
				gchar* _tmp25_ = NULL;
				gchar* _tmp26_;
				_tmp25_ = g_file_get_path (file);
				_tmp26_ = _tmp25_;
				g_warning ("DirectoryMonitor.vala:1319: Attribute changed event for unknown file %" \
"s", _tmp26_);
				_g_free0 (_tmp26_);
				_g_object_unref0 (local_info);
				break;
			}
			_tmp27_ = directory_monitor_get_ftype (local_info);
			ftype = _tmp27_;
			switch (ftype) {
				case DIRECTORY_MONITOR_FTYPE_FILE:
				{
					directory_monitor_notify_file_attributes_altered (self, file);
					break;
				}
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
				{
					directory_monitor_notify_directory_attributes_altered (self, file);
					break;
				}
				default:
				{
					g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
					break;
				}
			}
			_g_object_unref0 (local_info);
			break;
		}
		case G_FILE_MONITOR_EVENT_PRE_UNMOUNT:
		case G_FILE_MONITOR_EVENT_UNMOUNTED:
		{
			break;
		}
		default:
		{
			GEnumValue* _tmp28_;
			_tmp28_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), event);
			g_warning ("DirectoryMonitor.vala:1346: Unknown directory monitor event %s", (_tmp28_ != NULL) ? _tmp28_->value_name : NULL);
			break;
		}
	}
	_g_free0 (_tmp0_);
}


static gboolean directory_monitor_is_file_create_move (DirectoryMonitor* self, GFile* file, GFileInfo* info, GFile** old_file, GFileInfo** old_file_info) {
	GFile* _old_file = NULL;
	GFileInfo* _old_file_info = NULL;
	gboolean result = FALSE;
	GFile* _tmp0_ = NULL;
	GFile* match;
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
	_tmp0_ = directory_monitor_file_info_map_find_match (self->priv->parent_moved, info);
	match = _tmp0_;
	if (match != NULL) {
		GFile* _tmp1_;
		GFileInfo* _tmp2_ = NULL;
		_tmp1_ = _g_object_ref0 (match);
		_g_object_unref0 (_old_file);
		_old_file = _tmp1_;
		_tmp2_ = directory_monitor_file_info_map_get_info (self->priv->parent_moved, match);
		_g_object_unref0 (_old_file_info);
		_old_file_info = _tmp2_;
		directory_monitor_file_info_map_remove (self->priv->parent_moved, match, info);
		result = TRUE;
		_g_object_unref0 (match);
		if (old_file) {
			*old_file = _old_file;
		} else {
			_g_object_unref0 (_old_file);
		}
		if (old_file_info) {
			*old_file_info = _old_file_info;
		} else {
			_g_object_unref0 (_old_file_info);
		}
		return result;
	}
	result = FALSE;
	_g_object_unref0 (match);
	if (old_file) {
		*old_file = _old_file;
	} else {
		_g_object_unref0 (_old_file);
	}
	if (old_file_info) {
		*old_file_info = _old_file_info;
	} else {
		_g_object_unref0 (_old_file_info);
	}
	return result;
}


static gboolean directory_monitor_check_for_expired_delete_events (DirectoryMonitor* self) {
	gboolean result = FALSE;
	gulong _tmp0_;
	gulong expiration;
	gboolean any_deleted;
	gboolean any_expired;
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
	_tmp0_ = now_ms ();
	expiration = _tmp0_ - DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC;
	any_deleted = FALSE;
	any_expired = FALSE;
	{
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _element_it;
		_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (self->priv->query_info_queue));
		_element_it = _tmp1_;
		while (TRUE) {
			gboolean _tmp2_;
			gpointer _tmp3_ = NULL;
			DirectoryMonitorQueryInfoQueueElement* element;
			_tmp2_ = gee_iterator_next (_element_it);
			if (!_tmp2_) {
				break;
			}
			_tmp3_ = gee_iterator_get (_element_it);
			element = (DirectoryMonitorQueryInfoQueueElement*) _tmp3_;
			if (element->event != G_FILE_MONITOR_EVENT_DELETED) {
				_directory_monitor_query_info_queue_element_unref0 (element);
				continue;
			}
			any_deleted = TRUE;
			if (element->time_created_msec > expiration) {
				_directory_monitor_query_info_queue_element_unref0 (element);
				continue;
			}
			element->completed = TRUE;
			any_expired = TRUE;
			_directory_monitor_query_info_queue_element_unref0 (element);
		}
		_g_object_unref0 (_element_it);
	}
	if (any_expired) {
		directory_monitor_process_query_queue (self, NULL);
	}
	if (!any_deleted) {
		self->priv->delete_timer_id = (guint) 0;
	}
	result = any_deleted;
	return result;
}


GFileInfo* directory_monitor_get_file_info (DirectoryMonitor* self, GFile* file) {
	GFileInfo* result = NULL;
	GFileInfo* _tmp0_ = NULL;
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
	g_return_val_if_fail (G_IS_FILE (file), NULL);
	_tmp0_ = directory_monitor_file_info_map_get_info (self->priv->files, file);
	result = _tmp0_;
	return result;
}


GeeCollection* directory_monitor_get_files (DirectoryMonitor* self) {
	GeeCollection* result = NULL;
	GeeCollection* _tmp0_ = NULL;
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
	_tmp0_ = directory_monitor_file_info_map_get_all (self->priv->files);
	result = _tmp0_;
	return result;
}


GFileInfo* directory_monitor_query_file_info (DirectoryMonitor* self, GFile* file) {
	GFileInfo* result = NULL;
	GFileInfo* _tmp0_ = NULL;
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
	g_return_val_if_fail (G_IS_FILE (file), NULL);
	_tmp0_ = directory_monitor_file_info_map_query_info (self->priv->files, file, self->priv->cancellable);
	result = _tmp0_;
	return result;
}


gboolean directory_monitor_is_file_symlink_supported (GFileInfo* info) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	DirectoryMonitorFType _tmp1_;
	DirectoryMonitorFType ftype;
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
	_tmp0_ = g_file_info_get_is_symlink (info);
	if (!_tmp0_) {
		result = TRUE;
		return result;
	}
	_tmp1_ = directory_monitor_get_ftype (info);
	ftype = _tmp1_;
	switch (ftype) {
		case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
		{
			result = DIRECTORY_MONITOR_SUPPORT_DIR_SYMLINKS;
			return result;
		}
		case DIRECTORY_MONITOR_FTYPE_FILE:
		{
			result = DIRECTORY_MONITOR_SUPPORT_FILE_SYMLINKS;
			return result;
		}
		default:
		{
			g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
			result = FALSE;
			return result;
		}
	}
}


static void directory_monitor_real_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (old_root));
	g_return_if_fail (G_IS_FILE (new_root));
	g_return_if_fail (G_IS_FILE_INFO (new_root_info));
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_object (param_values + 3), data2);
}


static void directory_monitor_real_root_deleted (DirectoryMonitor* self, GFile* root) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (root));
}


static void directory_monitor_real_discovery_started (DirectoryMonitor* self) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
}


static void directory_monitor_real_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (file));
	g_return_if_fail (G_IS_FILE_INFO (info));
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
}


static void directory_monitor_real_directory_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (file));
	g_return_if_fail (G_IS_FILE_INFO (info));
}


static void directory_monitor_real_discovery_failed (DirectoryMonitor* self, const gchar* reason) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (reason != NULL);
}


static void directory_monitor_real_discovery_completed (DirectoryMonitor* self) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	self->priv->has_discovery_started = FALSE;
	directory_monitor_mdbg ("discovery completed");
}


static void directory_monitor_real_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (file));
	g_return_if_fail (G_IS_FILE_INFO (info));
}


static void directory_monitor_real_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (old_file));
	g_return_if_fail (G_IS_FILE (new_file));
	g_return_if_fail (G_IS_FILE_INFO (new_file_info));
}


static void directory_monitor_real_file_altered (DirectoryMonitor* self, GFile* file) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (file));
}


static void directory_monitor_real_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (file));
	g_return_if_fail (G_IS_FILE_INFO (info));
}


static void directory_monitor_real_file_attributes_altered (DirectoryMonitor* self, GFile* file) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (file));
}


static void directory_monitor_real_file_deleted (DirectoryMonitor* self, GFile* file) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (file));
}


static void directory_monitor_real_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (dir));
	g_return_if_fail (G_IS_FILE_INFO (info));
}


static void directory_monitor_real_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (old_dir));
	g_return_if_fail (G_IS_FILE (new_dir));
	g_return_if_fail (G_IS_FILE_INFO (new_dir_info));
}


static void directory_monitor_real_directory_altered (DirectoryMonitor* self, GFile* dir) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (dir));
}


static void directory_monitor_real_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (dir));
	g_return_if_fail (G_IS_FILE_INFO (info));
}


static void directory_monitor_real_directory_attributes_altered (DirectoryMonitor* self, GFile* dir) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (dir));
}


static void directory_monitor_real_directory_deleted (DirectoryMonitor* self, GFile* dir) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
	g_return_if_fail (G_IS_FILE (dir));
}


static void directory_monitor_real_closed (DirectoryMonitor* self) {
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
}


static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_construct (GType object_type, DirectoryMonitor* owner, GFile* file, GFile* other_file, GFileMonitorEvent event) {
	DirectoryMonitorQueryInfoQueueElement* self = NULL;
	DirectoryMonitor* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	guint _tmp3_;
	gulong _tmp4_;
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (owner), NULL);
	g_return_val_if_fail (G_IS_FILE (file), NULL);
	g_return_val_if_fail ((other_file == NULL) || G_IS_FILE (other_file), NULL);
	self = (DirectoryMonitorQueryInfoQueueElement*) g_type_create_instance (object_type);
	_tmp0_ = _g_object_ref0 (owner);
	_g_object_unref0 (self->owner);
	self->owner = _tmp0_;
	_tmp1_ = _g_object_ref0 (file);
	_g_object_unref0 (self->file);
	self->file = _tmp1_;
	_tmp2_ = _g_object_ref0 (other_file);
	_g_object_unref0 (self->other_file);
	self->other_file = _tmp2_;
	self->event = event;
	_tmp3_ = directory_monitor_query_info_queue_element_current;
	directory_monitor_query_info_queue_element_current = _tmp3_ + 1;
	self->position = _tmp3_;
	_tmp4_ = now_ms ();
	self->time_created_msec = _tmp4_;
	return self;
}


static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_new (DirectoryMonitor* owner, GFile* file, GFile* other_file, GFileMonitorEvent event) {
	return directory_monitor_query_info_queue_element_construct (DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, owner, file, other_file, event);
}


static gpointer _g_error_copy0 (gpointer self) {
	return self ? g_error_copy (self) : NULL;
}


static void directory_monitor_query_info_queue_element_on_completed (DirectoryMonitorQueryInfoQueueElement* self, GObject* source, GAsyncResult* aresult) {
	GFile* _tmp0_;
	GFile* source_file;
	GFileInfo* _tmp1_ = NULL;
	GFileInfo* _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT (self));
	g_return_if_fail ((source == NULL) || G_IS_OBJECT (source));
	g_return_if_fail (G_IS_ASYNC_RESULT (aresult));
	_tmp0_ = _g_object_ref0 (G_FILE (source));
	source_file = _tmp0_;
	_tmp1_ = g_file_query_info_finish (source_file, aresult, &_inner_error_);
	_tmp2_ = _tmp1_;
	if (_inner_error_ != NULL) {
		goto __catch313_g_error;
	}
	_g_object_unref0 (self->info);
	self->info = _tmp2_;
	goto __finally313;
	__catch313_g_error:
	{
		GError * err;
		GError* _tmp3_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = _g_error_copy0 (err);
		_g_error_free0 (self->err);
		self->err = _tmp3_;
		_g_error_free0 (err);
	}
	__finally313:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (source_file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	self->completed = TRUE;
	directory_monitor_process_query_queue (self->owner, self);
	_g_object_unref0 (source_file);
}


static void directory_monitor_value_query_info_queue_element_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void directory_monitor_value_query_info_queue_element_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		directory_monitor_query_info_queue_element_unref (value->data[0].v_pointer);
	}
}


static void directory_monitor_value_query_info_queue_element_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = directory_monitor_query_info_queue_element_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer directory_monitor_value_query_info_queue_element_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* directory_monitor_value_query_info_queue_element_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DirectoryMonitorQueryInfoQueueElement* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = directory_monitor_query_info_queue_element_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* directory_monitor_value_query_info_queue_element_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DirectoryMonitorQueryInfoQueueElement** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = directory_monitor_query_info_queue_element_ref (value->data[0].v_pointer);
	}
	return NULL;
}


static GParamSpec* directory_monitor_param_spec_query_info_queue_element (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DirectoryMonitorParamSpecQueryInfoQueueElement* spec;
	g_return_val_if_fail (g_type_is_a (object_type, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


static gpointer directory_monitor_value_get_query_info_queue_element (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT), NULL);
	return value->data[0].v_pointer;
}


static void directory_monitor_value_set_query_info_queue_element (GValue* value, gpointer v_object) {
	DirectoryMonitorQueryInfoQueueElement* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		directory_monitor_query_info_queue_element_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		directory_monitor_query_info_queue_element_unref (old);
	}
}


static void directory_monitor_value_take_query_info_queue_element (GValue* value, gpointer v_object) {
	DirectoryMonitorQueryInfoQueueElement* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		directory_monitor_query_info_queue_element_unref (old);
	}
}


static void directory_monitor_query_info_queue_element_class_init (DirectoryMonitorQueryInfoQueueElementClass * klass) {
	directory_monitor_query_info_queue_element_parent_class = g_type_class_peek_parent (klass);
	DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_CLASS (klass)->finalize = directory_monitor_query_info_queue_element_finalize;
}


static void directory_monitor_query_info_queue_element_instance_init (DirectoryMonitorQueryInfoQueueElement * self) {
	self->info = NULL;
	self->err = NULL;
	self->completed = FALSE;
	self->ref_count = 1;
}


static void directory_monitor_query_info_queue_element_finalize (DirectoryMonitorQueryInfoQueueElement* obj) {
	DirectoryMonitorQueryInfoQueueElement * self;
	self = DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT (obj);
	_g_object_unref0 (self->owner);
	_g_object_unref0 (self->file);
	_g_object_unref0 (self->other_file);
	_g_object_unref0 (self->info);
	_g_error_free0 (self->err);
}


static GType directory_monitor_query_info_queue_element_get_type (void) {
	static volatile gsize directory_monitor_query_info_queue_element_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_query_info_queue_element_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { directory_monitor_value_query_info_queue_element_init, directory_monitor_value_query_info_queue_element_free_value, directory_monitor_value_query_info_queue_element_copy_value, directory_monitor_value_query_info_queue_element_peek_pointer, "p", directory_monitor_value_query_info_queue_element_collect_value, "p", directory_monitor_value_query_info_queue_element_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorQueryInfoQueueElementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_query_info_queue_element_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitorQueryInfoQueueElement), 0, (GInstanceInitFunc) directory_monitor_query_info_queue_element_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType directory_monitor_query_info_queue_element_type_id;
		directory_monitor_query_info_queue_element_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DirectoryMonitorQueryInfoQueueElement", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&directory_monitor_query_info_queue_element_type_id__volatile, directory_monitor_query_info_queue_element_type_id);
	}
	return directory_monitor_query_info_queue_element_type_id__volatile;
}


static gpointer directory_monitor_query_info_queue_element_ref (gpointer instance) {
	DirectoryMonitorQueryInfoQueueElement* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


static void directory_monitor_query_info_queue_element_unref (gpointer instance) {
	DirectoryMonitorQueryInfoQueueElement* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_construct (GType object_type) {
	DirectoryMonitorFileInfoMap* self = NULL;
	self = (DirectoryMonitorFileInfoMap*) g_type_create_instance (object_type);
	return self;
}


static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_new (void) {
	return directory_monitor_file_info_map_construct (DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP);
}


static gboolean directory_monitor_file_info_map_normalize_file (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info, GFile** normalized, gchar** id) {
	GFile* _normalized = NULL;
	gchar* _id = NULL;
	gboolean result = FALSE;
	GFileInfo* _tmp0_;
	GFileInfo* local_info;
	gchar* _tmp2_ = NULL;
	gchar* file_id;
	gpointer _tmp3_ = NULL;
	GFile* known_file;
	gchar* _tmp4_;
	GFile* _tmp5_ = NULL;
	GFile* _tmp6_;
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
	g_return_val_if_fail ((info == NULL) || G_IS_FILE_INFO (info), FALSE);
	_tmp0_ = _g_object_ref0 (info);
	local_info = _tmp0_;
	if (local_info == NULL) {
		gpointer _tmp1_ = NULL;
		_tmp1_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), file);
		_g_object_unref0 (local_info);
		local_info = (GFileInfo*) _tmp1_;
		if (local_info == NULL) {
			result = FALSE;
			_g_object_unref0 (local_info);
			if (normalized) {
				*normalized = _normalized;
			} else {
				_g_object_unref0 (_normalized);
			}
			if (id) {
				*id = _id;
			} else {
				_g_free0 (_id);
			}
			return result;
		}
	}
	_tmp2_ = get_file_info_id (local_info);
	file_id = _tmp2_;
	if (file_id == NULL) {
		result = FALSE;
		_g_free0 (file_id);
		_g_object_unref0 (local_info);
		if (normalized) {
			*normalized = _normalized;
		} else {
			_g_object_unref0 (_normalized);
		}
		if (id) {
			*id = _id;
		} else {
			_g_free0 (_id);
		}
		return result;
	}
	_tmp3_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->id_map), file_id);
	known_file = (GFile*) _tmp3_;
	_tmp4_ = g_strdup ((const gchar*) file_id);
	_g_free0 (_id);
	_id = _tmp4_;
	if (known_file != NULL) {
		_tmp5_ = known_file;
	} else {
		_tmp5_ = file;
	}
	_tmp6_ = _g_object_ref0 (_tmp5_);
	_g_object_unref0 (_normalized);
	_normalized = _tmp6_;
	result = TRUE;
	_g_object_unref0 (known_file);
	_g_free0 (file_id);
	_g_object_unref0 (local_info);
	if (normalized) {
		*normalized = _normalized;
	} else {
		_g_object_unref0 (_normalized);
	}
	if (id) {
		*id = _id;
	} else {
		_g_free0 (_id);
	}
	return result;
}


static gboolean directory_monitor_file_info_map_update (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	gchar* _tmp2_ = NULL;
	gchar* existing_id;
	gboolean _tmp3_ = FALSE;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gboolean _tmp8_;
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
	_tmp0_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->map), file);
	if (_tmp0_) {
		gboolean _tmp1_;
		gboolean removed;
		_tmp1_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->map), file, NULL);
		removed = _tmp1_;
		g_assert (removed);
	}
	_tmp2_ = get_file_info_id (info);
	existing_id = _tmp2_;
	if (existing_id != NULL) {
		gboolean _tmp4_;
		_tmp4_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->id_map), existing_id);
		_tmp3_ = _tmp4_;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		gboolean _tmp5_;
		gboolean removed;
		_tmp5_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->id_map), existing_id, NULL);
		removed = _tmp5_;
		g_assert (removed);
	}
	_tmp8_ = directory_monitor_file_info_map_normalize_file (self, file, info, &_tmp6_, &_tmp7_);
	_g_object_unref0 (normalized);
	normalized = _tmp6_;
	_g_free0 (id);
	id = _tmp7_;
	if (!_tmp8_) {
		result = FALSE;
		_g_object_unref0 (normalized);
		_g_free0 (id);
		_g_free0 (existing_id);
		return result;
	}
	gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->map), normalized, info);
	gee_abstract_map_set (GEE_ABSTRACT_MAP (self->priv->id_map), id, normalized);
	result = TRUE;
	_g_object_unref0 (normalized);
	_g_free0 (id);
	_g_free0 (existing_id);
	return result;
}


static gboolean directory_monitor_file_info_map_remove (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info) {
	gboolean result = FALSE;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_;
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
	g_return_val_if_fail ((info == NULL) || G_IS_FILE_INFO (info), FALSE);
	_tmp2_ = directory_monitor_file_info_map_normalize_file (self, file, info, &_tmp0_, &_tmp1_);
	_g_object_unref0 (normalized);
	normalized = _tmp0_;
	_g_free0 (id);
	id = _tmp1_;
	if (!_tmp2_) {
		result = FALSE;
		_g_object_unref0 (normalized);
		_g_free0 (id);
		return result;
	}
	gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->map), normalized, NULL);
	gee_abstract_map_unset (GEE_ABSTRACT_MAP (self->priv->id_map), id, NULL);
	result = TRUE;
	_g_object_unref0 (normalized);
	_g_free0 (id);
	return result;
}


static void directory_monitor_file_info_map_remove_all (DirectoryMonitorFileInfoMap* self, GeeCollection* files) {
	g_return_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self));
	g_return_if_fail (GEE_IS_COLLECTION (files));
	{
		GeeIterator* _tmp0_ = NULL;
		GeeIterator* _file_it;
		_tmp0_ = gee_iterable_iterator (GEE_ITERABLE (files));
		_file_it = _tmp0_;
		while (TRUE) {
			gboolean _tmp1_;
			gpointer _tmp2_ = NULL;
			GFile* file;
			_tmp1_ = gee_iterator_next (_file_it);
			if (!_tmp1_) {
				break;
			}
			_tmp2_ = gee_iterator_get (_file_it);
			file = (GFile*) _tmp2_;
			directory_monitor_file_info_map_remove (self, file, NULL);
			_g_object_unref0 (file);
		}
		_g_object_unref0 (_file_it);
	}
}


static gboolean directory_monitor_file_info_map_contains (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info) {
	gboolean result = FALSE;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
	g_return_val_if_fail ((info == NULL) || G_IS_FILE_INFO (info), FALSE);
	_tmp2_ = directory_monitor_file_info_map_normalize_file (self, file, info, &_tmp0_, &_tmp1_);
	_g_object_unref0 (normalized);
	normalized = _tmp0_;
	_g_free0 (id);
	id = _tmp1_;
	if (!_tmp2_) {
		result = FALSE;
		_g_object_unref0 (normalized);
		_g_free0 (id);
		return result;
	}
	_tmp3_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (self->priv->id_map), id);
	result = _tmp3_;
	_g_object_unref0 (normalized);
	_g_free0 (id);
	return result;
}


static gchar* directory_monitor_file_info_map_get_id (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info) {
	gchar* result = NULL;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gboolean _tmp3_;
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
	g_return_val_if_fail (G_IS_FILE (file), NULL);
	g_return_val_if_fail ((info == NULL) || G_IS_FILE_INFO (info), NULL);
	if (info != NULL) {
		gchar* _tmp0_ = NULL;
		_tmp0_ = get_file_info_id (info);
		result = _tmp0_;
		return result;
	}
	_tmp3_ = directory_monitor_file_info_map_normalize_file (self, file, NULL, &_tmp1_, &_tmp2_);
	_g_object_unref0 (normalized);
	normalized = _tmp1_;
	_g_free0 (id);
	id = _tmp2_;
	if (!_tmp3_) {
		result = NULL;
		_g_object_unref0 (normalized);
		_g_free0 (id);
		return result;
	}
	result = id;
	_g_object_unref0 (normalized);
	return result;
}


static GeeCollection* directory_monitor_file_info_map_get_all (DirectoryMonitorFileInfoMap* self) {
	GeeCollection* result = NULL;
	GeeSet* _tmp0_ = NULL;
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
	_tmp0_ = gee_map_get_keys (GEE_MAP (self->priv->map));
	result = GEE_COLLECTION (_tmp0_);
	return result;
}


static GFileInfo* directory_monitor_file_info_map_get_info (DirectoryMonitorFileInfoMap* self, GFile* file) {
	GFileInfo* result = NULL;
	gpointer _tmp0_ = NULL;
	GFileInfo* info;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gboolean _tmp3_;
	gpointer _tmp4_ = NULL;
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
	g_return_val_if_fail (G_IS_FILE (file), NULL);
	_tmp0_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), file);
	info = (GFileInfo*) _tmp0_;
	if (info != NULL) {
		result = info;
		return result;
	}
	_tmp3_ = directory_monitor_file_info_map_normalize_file (self, file, NULL, &_tmp1_, &_tmp2_);
	_g_object_unref0 (normalized);
	normalized = _tmp1_;
	_g_free0 (id);
	id = _tmp2_;
	if (!_tmp3_) {
		result = NULL;
		_g_object_unref0 (normalized);
		_g_free0 (id);
		_g_object_unref0 (info);
		return result;
	}
	_tmp4_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), normalized);
	result = (GFileInfo*) _tmp4_;
	_g_object_unref0 (normalized);
	_g_free0 (id);
	_g_object_unref0 (info);
	return result;
}


static GFileInfo* directory_monitor_file_info_map_query_info (DirectoryMonitorFileInfoMap* self, GFile* file, GCancellable* cancellable) {
	GFileInfo* result = NULL;
	GFileInfo* _tmp0_ = NULL;
	GFileInfo* info;
	GFileInfo* _tmp1_ = NULL;
	GFileInfo* _tmp2_;
	gboolean _tmp5_;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp7_;
	gchar* id;
	gpointer _tmp8_ = NULL;
	GFile* normalized;
	gpointer _tmp9_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
	g_return_val_if_fail (G_IS_FILE (file), NULL);
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), NULL);
	_tmp0_ = directory_monitor_file_info_map_get_info (self, file);
	info = _tmp0_;
	if (info != NULL) {
		result = info;
		return result;
	}
	_tmp1_ = g_file_query_info (file, G_FILE_ATTRIBUTE_ID_FILE, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, cancellable, &_inner_error_);
	_tmp2_ = _tmp1_;
	if (_inner_error_ != NULL) {
		goto __catch314_g_error;
	}
	_g_object_unref0 (info);
	info = _tmp2_;
	goto __finally314;
	__catch314_g_error:
	{
		GError * err;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = g_file_get_path (file);
		_tmp4_ = _tmp3_;
		g_warning ("DirectoryMonitor.vala:253: Unable to query file ID of %s: %s", _tmp4_, err->message);
		_g_free0 (_tmp4_);
		result = NULL;
		_g_error_free0 (err);
		_g_object_unref0 (info);
		return result;
	}
	__finally314:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (info);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp5_ = directory_monitor_is_file_symlink_supported (info);
	if (!_tmp5_) {
		result = NULL;
		_g_object_unref0 (info);
		return result;
	}
	_tmp6_ = g_file_info_get_attribute_string (info, G_FILE_ATTRIBUTE_ID_FILE);
	_tmp7_ = g_strdup (_tmp6_);
	id = _tmp7_;
	if (id == NULL) {
		result = NULL;
		_g_free0 (id);
		_g_object_unref0 (info);
		return result;
	}
	_tmp8_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->id_map), id);
	normalized = (GFile*) _tmp8_;
	if (normalized == NULL) {
		result = NULL;
		_g_object_unref0 (normalized);
		_g_free0 (id);
		_g_object_unref0 (info);
		return result;
	}
	_tmp9_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), file);
	result = (GFileInfo*) _tmp9_;
	_g_object_unref0 (normalized);
	_g_free0 (id);
	_g_object_unref0 (info);
	return result;
}


static GFile* directory_monitor_file_info_map_find_match (DirectoryMonitorFileInfoMap* self, GFileInfo* match) {
	GFile* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* match_id;
	gint64 _tmp1_;
	gint64 match_size;
	GTimeVal match_time = {0};
	GTimeVal _tmp2_ = {0};
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
	g_return_val_if_fail (G_IS_FILE_INFO (match), NULL);
	_tmp0_ = get_file_info_id (match);
	match_id = _tmp0_;
	if (match_id == NULL) {
		result = NULL;
		_g_free0 (match_id);
		return result;
	}
	_tmp1_ = g_file_info_get_size (match);
	match_size = _tmp1_;
	g_file_info_get_modification_time (match, &_tmp2_);
	match_time = _tmp2_;
	{
		GeeSet* _tmp3_ = NULL;
		GeeSet* _tmp4_;
		GeeIterator* _tmp5_ = NULL;
		GeeIterator* _tmp6_;
		GeeIterator* _file_it;
		_tmp3_ = gee_map_get_keys (GEE_MAP (self->priv->map));
		_tmp4_ = _tmp3_;
		_tmp5_ = gee_iterable_iterator (GEE_ITERABLE (_tmp4_));
		_tmp6_ = _tmp5_;
		_g_object_unref0 (_tmp4_);
		_file_it = _tmp6_;
		while (TRUE) {
			gboolean _tmp7_;
			gpointer _tmp8_ = NULL;
			GFile* file;
			gpointer _tmp9_ = NULL;
			GFileInfo* info;
			gchar* _tmp10_ = NULL;
			gchar* _tmp11_;
			gboolean _tmp12_;
			gint64 _tmp13_;
			GTimeVal time = {0};
			GTimeVal _tmp14_ = {0};
			_tmp7_ = gee_iterator_next (_file_it);
			if (!_tmp7_) {
				break;
			}
			_tmp8_ = gee_iterator_get (_file_it);
			file = (GFile*) _tmp8_;
			_tmp9_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), file);
			info = (GFileInfo*) _tmp9_;
			_tmp10_ = get_file_info_id (info);
			_tmp11_ = _tmp10_;
			_tmp12_ = g_strcmp0 (_tmp11_, match_id) == 0;
			_g_free0 (_tmp11_);
			if (_tmp12_) {
				result = file;
				_g_object_unref0 (info);
				_g_object_unref0 (_file_it);
				_g_free0 (match_id);
				return result;
			}
			_tmp13_ = g_file_info_get_size (info);
			if (match_size != _tmp13_) {
				_g_object_unref0 (info);
				_g_object_unref0 (file);
				continue;
			}
			g_file_info_get_modification_time (info, &_tmp14_);
			time = _tmp14_;
			if (time.tv_sec != match_time.tv_sec) {
				_g_object_unref0 (info);
				_g_object_unref0 (file);
				continue;
			}
			result = file;
			_g_object_unref0 (info);
			_g_object_unref0 (_file_it);
			_g_free0 (match_id);
			return result;
		}
		_g_object_unref0 (_file_it);
	}
	result = NULL;
	_g_free0 (match_id);
	return result;
}


static void directory_monitor_file_info_map_remove_descendents (DirectoryMonitorFileInfoMap* self, GFile* root, DirectoryMonitorFileInfoMap* descendents) {
	GeeArrayList* pruned;
	g_return_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self));
	g_return_if_fail (G_IS_FILE (root));
	g_return_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (descendents));
	pruned = NULL;
	{
		GeeSet* _tmp0_ = NULL;
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_ = NULL;
		GeeIterator* _tmp3_;
		GeeIterator* _file_it;
		_tmp0_ = gee_map_get_keys (GEE_MAP (self->priv->map));
		_tmp1_ = _tmp0_;
		_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_));
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_file_it = _tmp3_;
		while (TRUE) {
			gboolean _tmp4_;
			gpointer _tmp5_ = NULL;
			GFile* file;
			GFile* _tmp6_ = NULL;
			GFile* parent;
			_tmp4_ = gee_iterator_next (_file_it);
			if (!_tmp4_) {
				break;
			}
			_tmp5_ = gee_iterator_get (_file_it);
			file = (GFile*) _tmp5_;
			_tmp6_ = g_file_get_parent (file);
			parent = _tmp6_;
			while (TRUE) {
				gboolean _tmp7_;
				GFile* _tmp11_ = NULL;
				if (!(parent != NULL)) {
					break;
				}
				_tmp7_ = g_file_equal (parent, root);
				if (_tmp7_) {
					gpointer _tmp9_ = NULL;
					GFileInfo* _tmp10_;
					if (pruned == NULL) {
						GeeArrayList* _tmp8_ = NULL;
						_tmp8_ = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
						_g_object_unref0 (pruned);
						pruned = _tmp8_;
					}
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (pruned), file);
					_tmp9_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), file);
					_tmp10_ = (GFileInfo*) _tmp9_;
					directory_monitor_file_info_map_update (descendents, file, _tmp10_);
					_g_object_unref0 (_tmp10_);
					break;
				}
				_tmp11_ = g_file_get_parent (parent);
				_g_object_unref0 (parent);
				parent = _tmp11_;
			}
			_g_object_unref0 (parent);
			_g_object_unref0 (file);
		}
		_g_object_unref0 (_file_it);
	}
	if (pruned != NULL) {
		directory_monitor_file_info_map_remove_all (self, GEE_COLLECTION (pruned));
	}
	_g_object_unref0 (pruned);
}


static gint directory_monitor_file_info_map_get_children (DirectoryMonitorFileInfoMap* self, GFile* root, GeeCollection* files, GeeCollection* dirs) {
	gint result = 0;
	gint count;
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), 0);
	g_return_val_if_fail (G_IS_FILE (root), 0);
	g_return_val_if_fail (GEE_IS_COLLECTION (files), 0);
	g_return_val_if_fail (GEE_IS_COLLECTION (dirs), 0);
	count = 0;
	{
		GeeSet* _tmp0_ = NULL;
		GeeSet* _tmp1_;
		GeeIterator* _tmp2_ = NULL;
		GeeIterator* _tmp3_;
		GeeIterator* _file_it;
		_tmp0_ = gee_map_get_keys (GEE_MAP (self->priv->map));
		_tmp1_ = _tmp0_;
		_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_));
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_file_it = _tmp3_;
		while (TRUE) {
			gboolean _tmp4_;
			gpointer _tmp5_ = NULL;
			GFile* file;
			GFile* _tmp6_ = NULL;
			GFile* parent;
			gboolean _tmp7_ = FALSE;
			gpointer _tmp9_ = NULL;
			GFileInfo* _tmp10_;
			DirectoryMonitorFType _tmp11_;
			DirectoryMonitorFType _tmp12_;
			DirectoryMonitorFType ftype;
			_tmp4_ = gee_iterator_next (_file_it);
			if (!_tmp4_) {
				break;
			}
			_tmp5_ = gee_iterator_get (_file_it);
			file = (GFile*) _tmp5_;
			_tmp6_ = g_file_get_parent (file);
			parent = _tmp6_;
			if (parent == NULL) {
				_tmp7_ = TRUE;
			} else {
				gboolean _tmp8_;
				_tmp8_ = g_file_equal (parent, root);
				_tmp7_ = !_tmp8_;
			}
			if (_tmp7_) {
				_g_object_unref0 (parent);
				_g_object_unref0 (file);
				continue;
			}
			_tmp9_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (self->priv->map), file);
			_tmp10_ = (GFileInfo*) _tmp9_;
			_tmp11_ = directory_monitor_get_ftype (_tmp10_);
			_tmp12_ = _tmp11_;
			_g_object_unref0 (_tmp10_);
			ftype = _tmp12_;
			switch (ftype) {
				case DIRECTORY_MONITOR_FTYPE_FILE:
				{
					gee_collection_add (files, file);
					count++;
					break;
				}
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
				{
					gee_collection_add (dirs, file);
					count++;
					break;
				}
				default:
				{
					g_assert (ftype == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
					break;
				}
			}
			_g_object_unref0 (parent);
			_g_object_unref0 (file);
		}
		_g_object_unref0 (_file_it);
	}
	result = count;
	return result;
}


static void directory_monitor_value_file_info_map_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void directory_monitor_value_file_info_map_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		directory_monitor_file_info_map_unref (value->data[0].v_pointer);
	}
}


static void directory_monitor_value_file_info_map_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = directory_monitor_file_info_map_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer directory_monitor_value_file_info_map_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* directory_monitor_value_file_info_map_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DirectoryMonitorFileInfoMap* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = directory_monitor_file_info_map_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* directory_monitor_value_file_info_map_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DirectoryMonitorFileInfoMap** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = directory_monitor_file_info_map_ref (value->data[0].v_pointer);
	}
	return NULL;
}


static GParamSpec* directory_monitor_param_spec_file_info_map (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DirectoryMonitorParamSpecFileInfoMap* spec;
	g_return_val_if_fail (g_type_is_a (object_type, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


static gpointer directory_monitor_value_get_file_info_map (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP), NULL);
	return value->data[0].v_pointer;
}


static void directory_monitor_value_set_file_info_map (GValue* value, gpointer v_object) {
	DirectoryMonitorFileInfoMap* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		directory_monitor_file_info_map_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		directory_monitor_file_info_map_unref (old);
	}
}


static void directory_monitor_value_take_file_info_map (GValue* value, gpointer v_object) {
	DirectoryMonitorFileInfoMap* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		directory_monitor_file_info_map_unref (old);
	}
}


static void directory_monitor_file_info_map_class_init (DirectoryMonitorFileInfoMapClass * klass) {
	directory_monitor_file_info_map_parent_class = g_type_class_peek_parent (klass);
	DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS (klass)->finalize = directory_monitor_file_info_map_finalize;
	g_type_class_add_private (klass, sizeof (DirectoryMonitorFileInfoMapPrivate));
}


static void directory_monitor_file_info_map_instance_init (DirectoryMonitorFileInfoMap * self) {
	GeeHashMap* _tmp0_ = NULL;
	GeeHashMap* _tmp1_ = NULL;
	self->priv = DIRECTORY_MONITOR_FILE_INFO_MAP_GET_PRIVATE (self);
	_tmp0_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_FILE_INFO, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_file_hash, g_file_equal, NULL);
	self->priv->map = _tmp0_;
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_str_hash, g_str_equal, g_file_equal);
	self->priv->id_map = _tmp1_;
	self->ref_count = 1;
}


static void directory_monitor_file_info_map_finalize (DirectoryMonitorFileInfoMap* obj) {
	DirectoryMonitorFileInfoMap * self;
	self = DIRECTORY_MONITOR_FILE_INFO_MAP (obj);
	_g_object_unref0 (self->priv->map);
	_g_object_unref0 (self->priv->id_map);
}


static GType directory_monitor_file_info_map_get_type (void) {
	static volatile gsize directory_monitor_file_info_map_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_file_info_map_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { directory_monitor_value_file_info_map_init, directory_monitor_value_file_info_map_free_value, directory_monitor_value_file_info_map_copy_value, directory_monitor_value_file_info_map_peek_pointer, "p", directory_monitor_value_file_info_map_collect_value, "p", directory_monitor_value_file_info_map_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorFileInfoMapClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_file_info_map_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitorFileInfoMap), 0, (GInstanceInitFunc) directory_monitor_file_info_map_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType directory_monitor_file_info_map_type_id;
		directory_monitor_file_info_map_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DirectoryMonitorFileInfoMap", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&directory_monitor_file_info_map_type_id__volatile, directory_monitor_file_info_map_type_id);
	}
	return directory_monitor_file_info_map_type_id__volatile;
}


static gpointer directory_monitor_file_info_map_ref (gpointer instance) {
	DirectoryMonitorFileInfoMap* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


static void directory_monitor_file_info_map_unref (gpointer instance) {
	DirectoryMonitorFileInfoMap* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DIRECTORY_MONITOR_FILE_INFO_MAP_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}


static void directory_monitor_class_init (DirectoryMonitorClass * klass) {
	directory_monitor_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DirectoryMonitorPrivate));
	DIRECTORY_MONITOR_CLASS (klass)->notify_root_deleted = directory_monitor_real_notify_root_deleted;
	DIRECTORY_MONITOR_CLASS (klass)->notify_root_moved = directory_monitor_real_notify_root_moved;
	DIRECTORY_MONITOR_CLASS (klass)->notify_discovery_started = directory_monitor_real_notify_discovery_started;
	DIRECTORY_MONITOR_CLASS (klass)->internal_notify_file_discovered = directory_monitor_real_internal_notify_file_discovered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_discovered = directory_monitor_real_notify_file_discovered;
	DIRECTORY_MONITOR_CLASS (klass)->internal_notify_directory_discovered = directory_monitor_real_internal_notify_directory_discovered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_discovered = directory_monitor_real_notify_directory_discovered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_discovery_failed = directory_monitor_real_notify_discovery_failed;
	DIRECTORY_MONITOR_CLASS (klass)->notify_discovery_completed = directory_monitor_real_notify_discovery_completed;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_created = directory_monitor_real_notify_file_created;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_moved = directory_monitor_real_notify_file_moved;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_altered = directory_monitor_real_notify_file_altered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_alteration_completed = directory_monitor_real_notify_file_alteration_completed;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_attributes_altered = directory_monitor_real_notify_file_attributes_altered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_deleted = directory_monitor_real_notify_file_deleted;
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_created = directory_monitor_real_notify_directory_created;
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_moved = directory_monitor_real_notify_directory_moved;
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_altered = directory_monitor_real_notify_directory_altered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_alteration_completed = directory_monitor_real_notify_directory_alteration_completed;
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_attributes_altered = directory_monitor_real_notify_directory_attributes_altered;
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_deleted = directory_monitor_real_notify_directory_deleted;
	DIRECTORY_MONITOR_CLASS (klass)->notify_closed = directory_monitor_real_notify_closed;
	DIRECTORY_MONITOR_CLASS (klass)->close = directory_monitor_real_close;
	DIRECTORY_MONITOR_CLASS (klass)->root_moved = directory_monitor_real_root_moved;
	DIRECTORY_MONITOR_CLASS (klass)->root_deleted = directory_monitor_real_root_deleted;
	DIRECTORY_MONITOR_CLASS (klass)->discovery_started = directory_monitor_real_discovery_started;
	DIRECTORY_MONITOR_CLASS (klass)->file_discovered = directory_monitor_real_file_discovered;
	DIRECTORY_MONITOR_CLASS (klass)->directory_discovered = directory_monitor_real_directory_discovered;
	DIRECTORY_MONITOR_CLASS (klass)->discovery_failed = directory_monitor_real_discovery_failed;
	DIRECTORY_MONITOR_CLASS (klass)->discovery_completed = directory_monitor_real_discovery_completed;
	DIRECTORY_MONITOR_CLASS (klass)->file_created = directory_monitor_real_file_created;
	DIRECTORY_MONITOR_CLASS (klass)->file_moved = directory_monitor_real_file_moved;
	DIRECTORY_MONITOR_CLASS (klass)->file_altered = directory_monitor_real_file_altered;
	DIRECTORY_MONITOR_CLASS (klass)->file_alteration_completed = directory_monitor_real_file_alteration_completed;
	DIRECTORY_MONITOR_CLASS (klass)->file_attributes_altered = directory_monitor_real_file_attributes_altered;
	DIRECTORY_MONITOR_CLASS (klass)->file_deleted = directory_monitor_real_file_deleted;
	DIRECTORY_MONITOR_CLASS (klass)->directory_created = directory_monitor_real_directory_created;
	DIRECTORY_MONITOR_CLASS (klass)->directory_moved = directory_monitor_real_directory_moved;
	DIRECTORY_MONITOR_CLASS (klass)->directory_altered = directory_monitor_real_directory_altered;
	DIRECTORY_MONITOR_CLASS (klass)->directory_alteration_completed = directory_monitor_real_directory_alteration_completed;
	DIRECTORY_MONITOR_CLASS (klass)->directory_attributes_altered = directory_monitor_real_directory_attributes_altered;
	DIRECTORY_MONITOR_CLASS (klass)->directory_deleted = directory_monitor_real_directory_deleted;
	DIRECTORY_MONITOR_CLASS (klass)->closed = directory_monitor_real_closed;
	G_OBJECT_CLASS (klass)->finalize = directory_monitor_finalize;
	g_signal_new ("root_moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, root_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, G_TYPE_FILE, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("root_deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, root_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
	g_signal_new ("discovery_started", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_started), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("file_discovered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_discovered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("directory_discovered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_discovered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("discovery_failed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_failed), NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	g_signal_new ("discovery_completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_completed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("file_created", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_created), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("file_moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, G_TYPE_FILE, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("file_altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
	g_signal_new ("file_alteration_completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_alteration_completed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("file_attributes_altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_attributes_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
	g_signal_new ("file_deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
	g_signal_new ("directory_created", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_created), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("directory_moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, G_TYPE_FILE, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("directory_altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
	g_signal_new ("directory_alteration_completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_alteration_completed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
	g_signal_new ("directory_attributes_altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_attributes_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
	g_signal_new ("directory_deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
	g_signal_new ("closed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, closed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void directory_monitor_instance_init (DirectoryMonitor * self) {
	GeeHashMap* _tmp0_ = NULL;
	GeeLinkedList* _tmp1_ = NULL;
	DirectoryMonitorFileInfoMap* _tmp2_ = NULL;
	DirectoryMonitorFileInfoMap* _tmp3_ = NULL;
	GCancellable* _tmp4_ = NULL;
	self->priv = DIRECTORY_MONITOR_GET_PRIVATE (self);
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_FILE_MONITOR, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
	self->priv->monitors = _tmp0_;
	_tmp1_ = gee_linked_list_new (DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, (GBoxedCopyFunc) directory_monitor_query_info_queue_element_ref, directory_monitor_query_info_queue_element_unref, NULL);
	self->priv->query_info_queue = GEE_QUEUE (_tmp1_);
	_tmp2_ = directory_monitor_file_info_map_new ();
	self->priv->files = _tmp2_;
	_tmp3_ = directory_monitor_file_info_map_new ();
	self->priv->parent_moved = _tmp3_;
	_tmp4_ = g_cancellable_new ();
	self->priv->cancellable = _tmp4_;
	self->priv->outstanding_exploration_dirs = 0;
	self->priv->started = FALSE;
	self->priv->has_discovery_started = FALSE;
	self->priv->delete_timer_id = (guint) 0;
}


static void directory_monitor_finalize (GObject* obj) {
	DirectoryMonitor * self;
	self = DIRECTORY_MONITOR (obj);
	_g_object_unref0 (self->priv->root);
	_g_object_unref0 (self->priv->monitors);
	_g_object_unref0 (self->priv->query_info_queue);
	_directory_monitor_file_info_map_unref0 (self->priv->files);
	_directory_monitor_file_info_map_unref0 (self->priv->parent_moved);
	_g_object_unref0 (self->priv->cancellable);
	G_OBJECT_CLASS (directory_monitor_parent_class)->finalize (obj);
}


GType directory_monitor_get_type (void) {
	static volatile gsize directory_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitor), 0, (GInstanceInitFunc) directory_monitor_instance_init, NULL };
		GType directory_monitor_type_id;
		directory_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "DirectoryMonitor", &g_define_type_info, 0);
		g_once_init_leave (&directory_monitor_type_id__volatile, directory_monitor_type_id);
	}
	return directory_monitor_type_id__volatile;
}



